{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls #-}


module HROOT.Class.Implementation where

import Data.Word
-- import Foreign.C            
import Foreign.Ptr
import Foreign.ForeignPtr

import System.IO.Unsafe

import HROOT.Class.Interface
import HROOT.Class.FFI



instance (ITObject a, FPtr a) => Castable a (Ptr RawTObject) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITNamed a, FPtr a) => Castable a (Ptr RawTNamed) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 



instance (ITClass a, FPtr a) => Castable a (Ptr RawTClass) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITFormula a, FPtr a) => Castable a (Ptr RawTFormula) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAtt3D a, FPtr a) => Castable a (Ptr RawTAtt3D) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAttAxis a, FPtr a) => Castable a (Ptr RawTAttAxis) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAttBBox a, FPtr a) => Castable a (Ptr RawTAttBBox) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAttCanvas a, FPtr a) => Castable a (Ptr RawTAttCanvas) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAttFill a, FPtr a) => Castable a (Ptr RawTAttFill) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAttImage a, FPtr a) => Castable a (Ptr RawTAttImage) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAttLine a, FPtr a) => Castable a (Ptr RawTAttLine) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAttMarker a, FPtr a) => Castable a (Ptr RawTAttMarker) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAttPad a, FPtr a) => Castable a (Ptr RawTAttPad) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAttParticle a, FPtr a) => Castable a (Ptr RawTAttParticle) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAttText a, FPtr a) => Castable a (Ptr RawTAttText) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITHStack a, FPtr a) => Castable a (Ptr RawTHStack) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITF1 a, FPtr a) => Castable a (Ptr RawTF1) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITGraph a, FPtr a) => Castable a (Ptr RawTGraph) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITGraphAsymmErrors a, FPtr a) => Castable a (Ptr RawTGraphAsymmErrors) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITCutG a, FPtr a) => Castable a (Ptr RawTCutG) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITGraphBentErrors a, FPtr a) => Castable a (Ptr RawTGraphBentErrors) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITGraphErrors a, FPtr a) => Castable a (Ptr RawTGraphErrors) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITGraphPolar a, FPtr a) => Castable a (Ptr RawTGraphPolar) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITGraphQQ a, FPtr a) => Castable a (Ptr RawTGraphQQ) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITEllipse a, FPtr a) => Castable a (Ptr RawTEllipse) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITArc a, FPtr a) => Castable a (Ptr RawTArc) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITCrown a, FPtr a) => Castable a (Ptr RawTCrown) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITLine a, FPtr a) => Castable a (Ptr RawTLine) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITArrow a, FPtr a) => Castable a (Ptr RawTArrow) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITGaxis a, FPtr a) => Castable a (Ptr RawTGaxis) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITShape a, FPtr a) => Castable a (Ptr RawTShape) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITBRIK a, FPtr a) => Castable a (Ptr RawTBRIK) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITTUBE a, FPtr a) => Castable a (Ptr RawTTUBE) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITPCON a, FPtr a) => Castable a (Ptr RawTPCON) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITSPHE a, FPtr a) => Castable a (Ptr RawTSPHE) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITXTRU a, FPtr a) => Castable a (Ptr RawTXTRU) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITBox a, FPtr a) => Castable a (Ptr RawTBox) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITPave a, FPtr a) => Castable a (Ptr RawTPave) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITPaveText a, FPtr a) => Castable a (Ptr RawTPaveText) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITDiamond a, FPtr a) => Castable a (Ptr RawTDiamond) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITPaveStats a, FPtr a) => Castable a (Ptr RawTPaveStats) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITPavesText a, FPtr a) => Castable a (Ptr RawTPavesText) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITLegend a, FPtr a) => Castable a (Ptr RawTLegend) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITLegendEntry a, FPtr a) => Castable a (Ptr RawTLegendEntry) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITPaveLabel a, FPtr a) => Castable a (Ptr RawTPaveLabel) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITPaveClass a, FPtr a) => Castable a (Ptr RawTPaveClass) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITWbox a, FPtr a) => Castable a (Ptr RawTWbox) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITFrame a, FPtr a) => Castable a (Ptr RawTFrame) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITSliderBox a, FPtr a) => Castable a (Ptr RawTSliderBox) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITTree a, FPtr a) => Castable a (Ptr RawTTree) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITChain a, FPtr a) => Castable a (Ptr RawTChain) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITNtuple a, FPtr a) => Castable a (Ptr RawTNtuple) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITNtupleD a, FPtr a) => Castable a (Ptr RawTNtupleD) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITTreeSQL a, FPtr a) => Castable a (Ptr RawTTreeSQL) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITPolyLine a, FPtr a) => Castable a (Ptr RawTPolyLine) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITCurlyLine a, FPtr a) => Castable a (Ptr RawTCurlyLine) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITCurlyArc a, FPtr a) => Castable a (Ptr RawTCurlyArc) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITEfficiency a, FPtr a) => Castable a (Ptr RawTEfficiency) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITAxis a, FPtr a) => Castable a (Ptr RawTAxis) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITLatex a, FPtr a) => Castable a (Ptr RawTLatex) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITText a, FPtr a) => Castable a (Ptr RawTText) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITDirectory a, FPtr a) => Castable a (Ptr RawTDirectory) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITDirectoryFile a, FPtr a) => Castable a (Ptr RawTDirectoryFile) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITFile a, FPtr a) => Castable a (Ptr RawTFile) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITBranch a, FPtr a) => Castable a (Ptr RawTBranch) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITVirtualTreePlayer a, FPtr a) => Castable a (Ptr RawTVirtualTreePlayer) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITTreePlayer a, FPtr a) => Castable a (Ptr RawTTreePlayer) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITArray a, FPtr a) => Castable a (Ptr RawTArray) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITArrayC a, FPtr a) => Castable a (Ptr RawTArrayC) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITArrayD a, FPtr a) => Castable a (Ptr RawTArrayD) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITArrayF a, FPtr a) => Castable a (Ptr RawTArrayF) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITArrayI a, FPtr a) => Castable a (Ptr RawTArrayI) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITArrayL a, FPtr a) => Castable a (Ptr RawTArrayL) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITArrayL64 a, FPtr a) => Castable a (Ptr RawTArrayL64) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITArrayS a, FPtr a) => Castable a (Ptr RawTArrayS) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH1 a, FPtr a) => Castable a (Ptr RawTH1) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH2 a, FPtr a) => Castable a (Ptr RawTH2) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH3 a, FPtr a) => Castable a (Ptr RawTH3) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH1C a, FPtr a) => Castable a (Ptr RawTH1C) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH1D a, FPtr a) => Castable a (Ptr RawTH1D) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH1F a, FPtr a) => Castable a (Ptr RawTH1F) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH1I a, FPtr a) => Castable a (Ptr RawTH1I) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH1S a, FPtr a) => Castable a (Ptr RawTH1S) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH2C a, FPtr a) => Castable a (Ptr RawTH2C) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH2D a, FPtr a) => Castable a (Ptr RawTH2D) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH2F a, FPtr a) => Castable a (Ptr RawTH2F) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH2I a, FPtr a) => Castable a (Ptr RawTH2I) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH2Poly a, FPtr a) => Castable a (Ptr RawTH2Poly) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH2S a, FPtr a) => Castable a (Ptr RawTH2S) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH3C a, FPtr a) => Castable a (Ptr RawTH3C) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH3D a, FPtr a) => Castable a (Ptr RawTH3D) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH3F a, FPtr a) => Castable a (Ptr RawTH3F) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH3I a, FPtr a) => Castable a (Ptr RawTH3I) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITH3S a, FPtr a) => Castable a (Ptr RawTH3S) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITQObject a, FPtr a) => Castable a (Ptr RawTQObject) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITVirtualPad a, FPtr a) => Castable a (Ptr RawTVirtualPad) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITPad a, FPtr a) => Castable a (Ptr RawTPad) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITButton a, FPtr a) => Castable a (Ptr RawTButton) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITGroupButton a, FPtr a) => Castable a (Ptr RawTGroupButton) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITCanvas a, FPtr a) => Castable a (Ptr RawTCanvas) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITDialogCanvas a, FPtr a) => Castable a (Ptr RawTDialogCanvas) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITInspectCanvas a, FPtr a) => Castable a (Ptr RawTInspectCanvas) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITEvePad a, FPtr a) => Castable a (Ptr RawTEvePad) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITSlider a, FPtr a) => Castable a (Ptr RawTSlider) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITApplication a, FPtr a) => Castable a (Ptr RawTApplication) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITRint a, FPtr a) => Castable a (Ptr RawTRint) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITRandom a, FPtr a) => Castable a (Ptr RawTRandom) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITCollection a, FPtr a) => Castable a (Ptr RawTCollection) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITSeqCollection a, FPtr a) => Castable a (Ptr RawTSeqCollection) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITObjArray a, FPtr a) => Castable a (Ptr RawTObjArray) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITList a, FPtr a) => Castable a (Ptr RawTList) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITKey a, FPtr a) => Castable a (Ptr RawTKey) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance (ITDatime a, FPtr a) => Castable a (Ptr RawTDatime) where
  cast = unsafeForeignPtrToPtr . castForeignPtr . get_fptr
  uncast = cast_fptr_to_obj . castForeignPtr . unsafePerformIO . newForeignPtr_ 

instance FPtr (Exist TObject) where
  type Raw (Exist TObject) = RawTObject
  get_fptr (ETObject obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETObject (cast_fptr_to_obj (fptr :: ForeignPtr RawTObject) :: TObject)

instance FPtr (Exist TNamed) where
  type Raw (Exist TNamed) = RawTNamed
  get_fptr (ETNamed obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETNamed (cast_fptr_to_obj (fptr :: ForeignPtr RawTNamed) :: TNamed)

instance FPtr (Exist TClass) where
  type Raw (Exist TClass) = RawTClass
  get_fptr (ETClass obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETClass (cast_fptr_to_obj (fptr :: ForeignPtr RawTClass) :: TClass)

instance FPtr (Exist TFormula) where
  type Raw (Exist TFormula) = RawTFormula
  get_fptr (ETFormula obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETFormula (cast_fptr_to_obj (fptr :: ForeignPtr RawTFormula) :: TFormula)

instance FPtr (Exist TAtt3D) where
  type Raw (Exist TAtt3D) = RawTAtt3D
  get_fptr (ETAtt3D obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAtt3D (cast_fptr_to_obj (fptr :: ForeignPtr RawTAtt3D) :: TAtt3D)

instance FPtr (Exist TAttAxis) where
  type Raw (Exist TAttAxis) = RawTAttAxis
  get_fptr (ETAttAxis obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttAxis (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttAxis) :: TAttAxis)

instance FPtr (Exist TAttBBox) where
  type Raw (Exist TAttBBox) = RawTAttBBox
  get_fptr (ETAttBBox obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttBBox (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttBBox) :: TAttBBox)

instance FPtr (Exist TAttCanvas) where
  type Raw (Exist TAttCanvas) = RawTAttCanvas
  get_fptr (ETAttCanvas obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttCanvas (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttCanvas) :: TAttCanvas)

instance FPtr (Exist TAttFill) where
  type Raw (Exist TAttFill) = RawTAttFill
  get_fptr (ETAttFill obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttFill (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttFill) :: TAttFill)

instance FPtr (Exist TAttImage) where
  type Raw (Exist TAttImage) = RawTAttImage
  get_fptr (ETAttImage obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttImage (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttImage) :: TAttImage)

instance FPtr (Exist TAttLine) where
  type Raw (Exist TAttLine) = RawTAttLine
  get_fptr (ETAttLine obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttLine (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttLine) :: TAttLine)

instance FPtr (Exist TAttMarker) where
  type Raw (Exist TAttMarker) = RawTAttMarker
  get_fptr (ETAttMarker obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttMarker (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttMarker) :: TAttMarker)

instance FPtr (Exist TAttPad) where
  type Raw (Exist TAttPad) = RawTAttPad
  get_fptr (ETAttPad obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttPad (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttPad) :: TAttPad)

instance FPtr (Exist TAttParticle) where
  type Raw (Exist TAttParticle) = RawTAttParticle
  get_fptr (ETAttParticle obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttParticle (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttParticle) :: TAttParticle)

instance FPtr (Exist TAttText) where
  type Raw (Exist TAttText) = RawTAttText
  get_fptr (ETAttText obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAttText (cast_fptr_to_obj (fptr :: ForeignPtr RawTAttText) :: TAttText)

instance FPtr (Exist THStack) where
  type Raw (Exist THStack) = RawTHStack
  get_fptr (ETHStack obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETHStack (cast_fptr_to_obj (fptr :: ForeignPtr RawTHStack) :: THStack)

instance FPtr (Exist TF1) where
  type Raw (Exist TF1) = RawTF1
  get_fptr (ETF1 obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETF1 (cast_fptr_to_obj (fptr :: ForeignPtr RawTF1) :: TF1)

instance FPtr (Exist TGraph) where
  type Raw (Exist TGraph) = RawTGraph
  get_fptr (ETGraph obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETGraph (cast_fptr_to_obj (fptr :: ForeignPtr RawTGraph) :: TGraph)

instance FPtr (Exist TGraphAsymmErrors) where
  type Raw (Exist TGraphAsymmErrors) = RawTGraphAsymmErrors
  get_fptr (ETGraphAsymmErrors obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETGraphAsymmErrors (cast_fptr_to_obj (fptr :: ForeignPtr RawTGraphAsymmErrors) :: TGraphAsymmErrors)

instance FPtr (Exist TCutG) where
  type Raw (Exist TCutG) = RawTCutG
  get_fptr (ETCutG obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETCutG (cast_fptr_to_obj (fptr :: ForeignPtr RawTCutG) :: TCutG)

instance FPtr (Exist TGraphBentErrors) where
  type Raw (Exist TGraphBentErrors) = RawTGraphBentErrors
  get_fptr (ETGraphBentErrors obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETGraphBentErrors (cast_fptr_to_obj (fptr :: ForeignPtr RawTGraphBentErrors) :: TGraphBentErrors)

instance FPtr (Exist TGraphErrors) where
  type Raw (Exist TGraphErrors) = RawTGraphErrors
  get_fptr (ETGraphErrors obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETGraphErrors (cast_fptr_to_obj (fptr :: ForeignPtr RawTGraphErrors) :: TGraphErrors)

instance FPtr (Exist TGraphPolar) where
  type Raw (Exist TGraphPolar) = RawTGraphPolar
  get_fptr (ETGraphPolar obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETGraphPolar (cast_fptr_to_obj (fptr :: ForeignPtr RawTGraphPolar) :: TGraphPolar)

instance FPtr (Exist TGraphQQ) where
  type Raw (Exist TGraphQQ) = RawTGraphQQ
  get_fptr (ETGraphQQ obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETGraphQQ (cast_fptr_to_obj (fptr :: ForeignPtr RawTGraphQQ) :: TGraphQQ)

instance FPtr (Exist TEllipse) where
  type Raw (Exist TEllipse) = RawTEllipse
  get_fptr (ETEllipse obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETEllipse (cast_fptr_to_obj (fptr :: ForeignPtr RawTEllipse) :: TEllipse)

instance FPtr (Exist TArc) where
  type Raw (Exist TArc) = RawTArc
  get_fptr (ETArc obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArc (cast_fptr_to_obj (fptr :: ForeignPtr RawTArc) :: TArc)

instance FPtr (Exist TCrown) where
  type Raw (Exist TCrown) = RawTCrown
  get_fptr (ETCrown obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETCrown (cast_fptr_to_obj (fptr :: ForeignPtr RawTCrown) :: TCrown)

instance FPtr (Exist TLine) where
  type Raw (Exist TLine) = RawTLine
  get_fptr (ETLine obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETLine (cast_fptr_to_obj (fptr :: ForeignPtr RawTLine) :: TLine)

instance FPtr (Exist TArrow) where
  type Raw (Exist TArrow) = RawTArrow
  get_fptr (ETArrow obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrow (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrow) :: TArrow)

instance FPtr (Exist TGaxis) where
  type Raw (Exist TGaxis) = RawTGaxis
  get_fptr (ETGaxis obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETGaxis (cast_fptr_to_obj (fptr :: ForeignPtr RawTGaxis) :: TGaxis)

instance FPtr (Exist TShape) where
  type Raw (Exist TShape) = RawTShape
  get_fptr (ETShape obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETShape (cast_fptr_to_obj (fptr :: ForeignPtr RawTShape) :: TShape)

instance FPtr (Exist TBRIK) where
  type Raw (Exist TBRIK) = RawTBRIK
  get_fptr (ETBRIK obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETBRIK (cast_fptr_to_obj (fptr :: ForeignPtr RawTBRIK) :: TBRIK)

instance FPtr (Exist TTUBE) where
  type Raw (Exist TTUBE) = RawTTUBE
  get_fptr (ETTUBE obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETTUBE (cast_fptr_to_obj (fptr :: ForeignPtr RawTTUBE) :: TTUBE)

instance FPtr (Exist TPCON) where
  type Raw (Exist TPCON) = RawTPCON
  get_fptr (ETPCON obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPCON (cast_fptr_to_obj (fptr :: ForeignPtr RawTPCON) :: TPCON)

instance FPtr (Exist TSPHE) where
  type Raw (Exist TSPHE) = RawTSPHE
  get_fptr (ETSPHE obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETSPHE (cast_fptr_to_obj (fptr :: ForeignPtr RawTSPHE) :: TSPHE)

instance FPtr (Exist TXTRU) where
  type Raw (Exist TXTRU) = RawTXTRU
  get_fptr (ETXTRU obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETXTRU (cast_fptr_to_obj (fptr :: ForeignPtr RawTXTRU) :: TXTRU)

instance FPtr (Exist TBox) where
  type Raw (Exist TBox) = RawTBox
  get_fptr (ETBox obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETBox (cast_fptr_to_obj (fptr :: ForeignPtr RawTBox) :: TBox)

instance FPtr (Exist TPave) where
  type Raw (Exist TPave) = RawTPave
  get_fptr (ETPave obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPave (cast_fptr_to_obj (fptr :: ForeignPtr RawTPave) :: TPave)

instance FPtr (Exist TPaveText) where
  type Raw (Exist TPaveText) = RawTPaveText
  get_fptr (ETPaveText obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPaveText (cast_fptr_to_obj (fptr :: ForeignPtr RawTPaveText) :: TPaveText)

instance FPtr (Exist TDiamond) where
  type Raw (Exist TDiamond) = RawTDiamond
  get_fptr (ETDiamond obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETDiamond (cast_fptr_to_obj (fptr :: ForeignPtr RawTDiamond) :: TDiamond)

instance FPtr (Exist TPaveStats) where
  type Raw (Exist TPaveStats) = RawTPaveStats
  get_fptr (ETPaveStats obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPaveStats (cast_fptr_to_obj (fptr :: ForeignPtr RawTPaveStats) :: TPaveStats)

instance FPtr (Exist TPavesText) where
  type Raw (Exist TPavesText) = RawTPavesText
  get_fptr (ETPavesText obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPavesText (cast_fptr_to_obj (fptr :: ForeignPtr RawTPavesText) :: TPavesText)

instance FPtr (Exist TLegend) where
  type Raw (Exist TLegend) = RawTLegend
  get_fptr (ETLegend obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETLegend (cast_fptr_to_obj (fptr :: ForeignPtr RawTLegend) :: TLegend)

instance FPtr (Exist TLegendEntry) where
  type Raw (Exist TLegendEntry) = RawTLegendEntry
  get_fptr (ETLegendEntry obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETLegendEntry (cast_fptr_to_obj (fptr :: ForeignPtr RawTLegendEntry) :: TLegendEntry)

instance FPtr (Exist TPaveLabel) where
  type Raw (Exist TPaveLabel) = RawTPaveLabel
  get_fptr (ETPaveLabel obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPaveLabel (cast_fptr_to_obj (fptr :: ForeignPtr RawTPaveLabel) :: TPaveLabel)

instance FPtr (Exist TPaveClass) where
  type Raw (Exist TPaveClass) = RawTPaveClass
  get_fptr (ETPaveClass obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPaveClass (cast_fptr_to_obj (fptr :: ForeignPtr RawTPaveClass) :: TPaveClass)

instance FPtr (Exist TWbox) where
  type Raw (Exist TWbox) = RawTWbox
  get_fptr (ETWbox obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETWbox (cast_fptr_to_obj (fptr :: ForeignPtr RawTWbox) :: TWbox)

instance FPtr (Exist TFrame) where
  type Raw (Exist TFrame) = RawTFrame
  get_fptr (ETFrame obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETFrame (cast_fptr_to_obj (fptr :: ForeignPtr RawTFrame) :: TFrame)

instance FPtr (Exist TSliderBox) where
  type Raw (Exist TSliderBox) = RawTSliderBox
  get_fptr (ETSliderBox obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETSliderBox (cast_fptr_to_obj (fptr :: ForeignPtr RawTSliderBox) :: TSliderBox)

instance FPtr (Exist TTree) where
  type Raw (Exist TTree) = RawTTree
  get_fptr (ETTree obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETTree (cast_fptr_to_obj (fptr :: ForeignPtr RawTTree) :: TTree)

instance FPtr (Exist TChain) where
  type Raw (Exist TChain) = RawTChain
  get_fptr (ETChain obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETChain (cast_fptr_to_obj (fptr :: ForeignPtr RawTChain) :: TChain)

instance FPtr (Exist TNtuple) where
  type Raw (Exist TNtuple) = RawTNtuple
  get_fptr (ETNtuple obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETNtuple (cast_fptr_to_obj (fptr :: ForeignPtr RawTNtuple) :: TNtuple)

instance FPtr (Exist TNtupleD) where
  type Raw (Exist TNtupleD) = RawTNtupleD
  get_fptr (ETNtupleD obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETNtupleD (cast_fptr_to_obj (fptr :: ForeignPtr RawTNtupleD) :: TNtupleD)

instance FPtr (Exist TTreeSQL) where
  type Raw (Exist TTreeSQL) = RawTTreeSQL
  get_fptr (ETTreeSQL obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETTreeSQL (cast_fptr_to_obj (fptr :: ForeignPtr RawTTreeSQL) :: TTreeSQL)

instance FPtr (Exist TPolyLine) where
  type Raw (Exist TPolyLine) = RawTPolyLine
  get_fptr (ETPolyLine obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPolyLine (cast_fptr_to_obj (fptr :: ForeignPtr RawTPolyLine) :: TPolyLine)

instance FPtr (Exist TCurlyLine) where
  type Raw (Exist TCurlyLine) = RawTCurlyLine
  get_fptr (ETCurlyLine obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETCurlyLine (cast_fptr_to_obj (fptr :: ForeignPtr RawTCurlyLine) :: TCurlyLine)

instance FPtr (Exist TCurlyArc) where
  type Raw (Exist TCurlyArc) = RawTCurlyArc
  get_fptr (ETCurlyArc obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETCurlyArc (cast_fptr_to_obj (fptr :: ForeignPtr RawTCurlyArc) :: TCurlyArc)

instance FPtr (Exist TEfficiency) where
  type Raw (Exist TEfficiency) = RawTEfficiency
  get_fptr (ETEfficiency obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETEfficiency (cast_fptr_to_obj (fptr :: ForeignPtr RawTEfficiency) :: TEfficiency)

instance FPtr (Exist TAxis) where
  type Raw (Exist TAxis) = RawTAxis
  get_fptr (ETAxis obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETAxis (cast_fptr_to_obj (fptr :: ForeignPtr RawTAxis) :: TAxis)

instance FPtr (Exist TLatex) where
  type Raw (Exist TLatex) = RawTLatex
  get_fptr (ETLatex obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETLatex (cast_fptr_to_obj (fptr :: ForeignPtr RawTLatex) :: TLatex)

instance FPtr (Exist TText) where
  type Raw (Exist TText) = RawTText
  get_fptr (ETText obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETText (cast_fptr_to_obj (fptr :: ForeignPtr RawTText) :: TText)

instance FPtr (Exist TDirectory) where
  type Raw (Exist TDirectory) = RawTDirectory
  get_fptr (ETDirectory obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETDirectory (cast_fptr_to_obj (fptr :: ForeignPtr RawTDirectory) :: TDirectory)

instance FPtr (Exist TDirectoryFile) where
  type Raw (Exist TDirectoryFile) = RawTDirectoryFile
  get_fptr (ETDirectoryFile obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETDirectoryFile (cast_fptr_to_obj (fptr :: ForeignPtr RawTDirectoryFile) :: TDirectoryFile)

instance FPtr (Exist TFile) where
  type Raw (Exist TFile) = RawTFile
  get_fptr (ETFile obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETFile (cast_fptr_to_obj (fptr :: ForeignPtr RawTFile) :: TFile)

instance FPtr (Exist TBranch) where
  type Raw (Exist TBranch) = RawTBranch
  get_fptr (ETBranch obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETBranch (cast_fptr_to_obj (fptr :: ForeignPtr RawTBranch) :: TBranch)

instance FPtr (Exist TVirtualTreePlayer) where
  type Raw (Exist TVirtualTreePlayer) = RawTVirtualTreePlayer
  get_fptr (ETVirtualTreePlayer obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETVirtualTreePlayer (cast_fptr_to_obj (fptr :: ForeignPtr RawTVirtualTreePlayer) :: TVirtualTreePlayer)

instance FPtr (Exist TTreePlayer) where
  type Raw (Exist TTreePlayer) = RawTTreePlayer
  get_fptr (ETTreePlayer obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETTreePlayer (cast_fptr_to_obj (fptr :: ForeignPtr RawTTreePlayer) :: TTreePlayer)

instance FPtr (Exist TArray) where
  type Raw (Exist TArray) = RawTArray
  get_fptr (ETArray obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArray (cast_fptr_to_obj (fptr :: ForeignPtr RawTArray) :: TArray)

instance FPtr (Exist TArrayC) where
  type Raw (Exist TArrayC) = RawTArrayC
  get_fptr (ETArrayC obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayC (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayC) :: TArrayC)

instance FPtr (Exist TArrayD) where
  type Raw (Exist TArrayD) = RawTArrayD
  get_fptr (ETArrayD obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayD (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayD) :: TArrayD)

instance FPtr (Exist TArrayF) where
  type Raw (Exist TArrayF) = RawTArrayF
  get_fptr (ETArrayF obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayF (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayF) :: TArrayF)

instance FPtr (Exist TArrayI) where
  type Raw (Exist TArrayI) = RawTArrayI
  get_fptr (ETArrayI obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayI (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayI) :: TArrayI)

instance FPtr (Exist TArrayL) where
  type Raw (Exist TArrayL) = RawTArrayL
  get_fptr (ETArrayL obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayL (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayL) :: TArrayL)

instance FPtr (Exist TArrayL64) where
  type Raw (Exist TArrayL64) = RawTArrayL64
  get_fptr (ETArrayL64 obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayL64 (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayL64) :: TArrayL64)

instance FPtr (Exist TArrayS) where
  type Raw (Exist TArrayS) = RawTArrayS
  get_fptr (ETArrayS obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETArrayS (cast_fptr_to_obj (fptr :: ForeignPtr RawTArrayS) :: TArrayS)

instance FPtr (Exist TH1) where
  type Raw (Exist TH1) = RawTH1
  get_fptr (ETH1 obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH1 (cast_fptr_to_obj (fptr :: ForeignPtr RawTH1) :: TH1)

instance FPtr (Exist TH2) where
  type Raw (Exist TH2) = RawTH2
  get_fptr (ETH2 obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH2 (cast_fptr_to_obj (fptr :: ForeignPtr RawTH2) :: TH2)

instance FPtr (Exist TH3) where
  type Raw (Exist TH3) = RawTH3
  get_fptr (ETH3 obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH3 (cast_fptr_to_obj (fptr :: ForeignPtr RawTH3) :: TH3)

instance FPtr (Exist TH1C) where
  type Raw (Exist TH1C) = RawTH1C
  get_fptr (ETH1C obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH1C (cast_fptr_to_obj (fptr :: ForeignPtr RawTH1C) :: TH1C)

instance FPtr (Exist TH1D) where
  type Raw (Exist TH1D) = RawTH1D
  get_fptr (ETH1D obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH1D (cast_fptr_to_obj (fptr :: ForeignPtr RawTH1D) :: TH1D)

instance FPtr (Exist TH1F) where
  type Raw (Exist TH1F) = RawTH1F
  get_fptr (ETH1F obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH1F (cast_fptr_to_obj (fptr :: ForeignPtr RawTH1F) :: TH1F)

instance FPtr (Exist TH1I) where
  type Raw (Exist TH1I) = RawTH1I
  get_fptr (ETH1I obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH1I (cast_fptr_to_obj (fptr :: ForeignPtr RawTH1I) :: TH1I)

instance FPtr (Exist TH1S) where
  type Raw (Exist TH1S) = RawTH1S
  get_fptr (ETH1S obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH1S (cast_fptr_to_obj (fptr :: ForeignPtr RawTH1S) :: TH1S)

instance FPtr (Exist TH2C) where
  type Raw (Exist TH2C) = RawTH2C
  get_fptr (ETH2C obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH2C (cast_fptr_to_obj (fptr :: ForeignPtr RawTH2C) :: TH2C)

instance FPtr (Exist TH2D) where
  type Raw (Exist TH2D) = RawTH2D
  get_fptr (ETH2D obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH2D (cast_fptr_to_obj (fptr :: ForeignPtr RawTH2D) :: TH2D)

instance FPtr (Exist TH2F) where
  type Raw (Exist TH2F) = RawTH2F
  get_fptr (ETH2F obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH2F (cast_fptr_to_obj (fptr :: ForeignPtr RawTH2F) :: TH2F)

instance FPtr (Exist TH2I) where
  type Raw (Exist TH2I) = RawTH2I
  get_fptr (ETH2I obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH2I (cast_fptr_to_obj (fptr :: ForeignPtr RawTH2I) :: TH2I)

instance FPtr (Exist TH2Poly) where
  type Raw (Exist TH2Poly) = RawTH2Poly
  get_fptr (ETH2Poly obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH2Poly (cast_fptr_to_obj (fptr :: ForeignPtr RawTH2Poly) :: TH2Poly)

instance FPtr (Exist TH2S) where
  type Raw (Exist TH2S) = RawTH2S
  get_fptr (ETH2S obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH2S (cast_fptr_to_obj (fptr :: ForeignPtr RawTH2S) :: TH2S)

instance FPtr (Exist TH3C) where
  type Raw (Exist TH3C) = RawTH3C
  get_fptr (ETH3C obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH3C (cast_fptr_to_obj (fptr :: ForeignPtr RawTH3C) :: TH3C)

instance FPtr (Exist TH3D) where
  type Raw (Exist TH3D) = RawTH3D
  get_fptr (ETH3D obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH3D (cast_fptr_to_obj (fptr :: ForeignPtr RawTH3D) :: TH3D)

instance FPtr (Exist TH3F) where
  type Raw (Exist TH3F) = RawTH3F
  get_fptr (ETH3F obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH3F (cast_fptr_to_obj (fptr :: ForeignPtr RawTH3F) :: TH3F)

instance FPtr (Exist TH3I) where
  type Raw (Exist TH3I) = RawTH3I
  get_fptr (ETH3I obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH3I (cast_fptr_to_obj (fptr :: ForeignPtr RawTH3I) :: TH3I)

instance FPtr (Exist TH3S) where
  type Raw (Exist TH3S) = RawTH3S
  get_fptr (ETH3S obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETH3S (cast_fptr_to_obj (fptr :: ForeignPtr RawTH3S) :: TH3S)

instance FPtr (Exist TQObject) where
  type Raw (Exist TQObject) = RawTQObject
  get_fptr (ETQObject obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETQObject (cast_fptr_to_obj (fptr :: ForeignPtr RawTQObject) :: TQObject)

instance FPtr (Exist TVirtualPad) where
  type Raw (Exist TVirtualPad) = RawTVirtualPad
  get_fptr (ETVirtualPad obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETVirtualPad (cast_fptr_to_obj (fptr :: ForeignPtr RawTVirtualPad) :: TVirtualPad)

instance FPtr (Exist TPad) where
  type Raw (Exist TPad) = RawTPad
  get_fptr (ETPad obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETPad (cast_fptr_to_obj (fptr :: ForeignPtr RawTPad) :: TPad)

instance FPtr (Exist TButton) where
  type Raw (Exist TButton) = RawTButton
  get_fptr (ETButton obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETButton (cast_fptr_to_obj (fptr :: ForeignPtr RawTButton) :: TButton)

instance FPtr (Exist TGroupButton) where
  type Raw (Exist TGroupButton) = RawTGroupButton
  get_fptr (ETGroupButton obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETGroupButton (cast_fptr_to_obj (fptr :: ForeignPtr RawTGroupButton) :: TGroupButton)

instance FPtr (Exist TCanvas) where
  type Raw (Exist TCanvas) = RawTCanvas
  get_fptr (ETCanvas obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETCanvas (cast_fptr_to_obj (fptr :: ForeignPtr RawTCanvas) :: TCanvas)

instance FPtr (Exist TDialogCanvas) where
  type Raw (Exist TDialogCanvas) = RawTDialogCanvas
  get_fptr (ETDialogCanvas obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETDialogCanvas (cast_fptr_to_obj (fptr :: ForeignPtr RawTDialogCanvas) :: TDialogCanvas)

instance FPtr (Exist TInspectCanvas) where
  type Raw (Exist TInspectCanvas) = RawTInspectCanvas
  get_fptr (ETInspectCanvas obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETInspectCanvas (cast_fptr_to_obj (fptr :: ForeignPtr RawTInspectCanvas) :: TInspectCanvas)

instance FPtr (Exist TEvePad) where
  type Raw (Exist TEvePad) = RawTEvePad
  get_fptr (ETEvePad obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETEvePad (cast_fptr_to_obj (fptr :: ForeignPtr RawTEvePad) :: TEvePad)

instance FPtr (Exist TSlider) where
  type Raw (Exist TSlider) = RawTSlider
  get_fptr (ETSlider obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETSlider (cast_fptr_to_obj (fptr :: ForeignPtr RawTSlider) :: TSlider)

instance FPtr (Exist TApplication) where
  type Raw (Exist TApplication) = RawTApplication
  get_fptr (ETApplication obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETApplication (cast_fptr_to_obj (fptr :: ForeignPtr RawTApplication) :: TApplication)

instance FPtr (Exist TRint) where
  type Raw (Exist TRint) = RawTRint
  get_fptr (ETRint obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETRint (cast_fptr_to_obj (fptr :: ForeignPtr RawTRint) :: TRint)

instance FPtr (Exist TRandom) where
  type Raw (Exist TRandom) = RawTRandom
  get_fptr (ETRandom obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETRandom (cast_fptr_to_obj (fptr :: ForeignPtr RawTRandom) :: TRandom)

instance FPtr (Exist TCollection) where
  type Raw (Exist TCollection) = RawTCollection
  get_fptr (ETCollection obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETCollection (cast_fptr_to_obj (fptr :: ForeignPtr RawTCollection) :: TCollection)

instance FPtr (Exist TSeqCollection) where
  type Raw (Exist TSeqCollection) = RawTSeqCollection
  get_fptr (ETSeqCollection obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETSeqCollection (cast_fptr_to_obj (fptr :: ForeignPtr RawTSeqCollection) :: TSeqCollection)

instance FPtr (Exist TObjArray) where
  type Raw (Exist TObjArray) = RawTObjArray
  get_fptr (ETObjArray obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETObjArray (cast_fptr_to_obj (fptr :: ForeignPtr RawTObjArray) :: TObjArray)

instance FPtr (Exist TList) where
  type Raw (Exist TList) = RawTList
  get_fptr (ETList obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETList (cast_fptr_to_obj (fptr :: ForeignPtr RawTList) :: TList)

instance FPtr (Exist TKey) where
  type Raw (Exist TKey) = RawTKey
  get_fptr (ETKey obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETKey (cast_fptr_to_obj (fptr :: ForeignPtr RawTKey) :: TKey)

instance FPtr (Exist TDatime) where
  type Raw (Exist TDatime) = RawTDatime
  get_fptr (ETDatime obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETDatime (cast_fptr_to_obj (fptr :: ForeignPtr RawTDatime) :: TDatime)

instance ITObject (Exist TObject) where
  getName (ETObject x) = getName x
  draw (ETObject x) = draw x
  findObject (ETObject x) = findObject x
  saveAs (ETObject x) = saveAs x
  write (ETObject x) = write x
  isA (ETObject x) = isA x
  printObj (ETObject x) = printObj x

instance IDeletable (Exist TObject) where
  delete (ETObject x) = delete x

instance ITNamed (Exist TNamed) where
  setTitle (ETNamed x) = setTitle x

instance ITObject (Exist TNamed) where
  getName (ETNamed x) = getName x
  draw (ETNamed x) = draw x
  findObject (ETNamed x) = findObject x
  saveAs (ETNamed x) = saveAs x
  write (ETNamed x) = write x
  isA (ETNamed x) = isA x
  printObj (ETNamed x) = printObj x

instance IDeletable (Exist TNamed) where
  delete (ETNamed x) = delete x

instance ITClass (Exist TClass) where


instance ITDictionary (Exist TClass) where


instance ITNamed (Exist TClass) where
  setTitle (ETClass x) = setTitle x

instance ITObject (Exist TClass) where
  getName (ETClass x) = getName x
  draw (ETClass x) = draw x
  findObject (ETClass x) = findObject x
  saveAs (ETClass x) = saveAs x
  write (ETClass x) = write x
  isA (ETClass x) = isA x
  printObj (ETClass x) = printObj x

instance IDeletable (Exist TClass) where
  delete (ETClass x) = delete x

instance ITFormula (Exist TFormula) where
  getParameter (ETFormula x) = getParameter x
  setParameter (ETFormula x) = setParameter x

instance ITNamed (Exist TFormula) where
  setTitle (ETFormula x) = setTitle x

instance ITObject (Exist TFormula) where
  getName (ETFormula x) = getName x
  draw (ETFormula x) = draw x
  findObject (ETFormula x) = findObject x
  saveAs (ETFormula x) = saveAs x
  write (ETFormula x) = write x
  isA (ETFormula x) = isA x
  printObj (ETFormula x) = printObj x

instance IDeletable (Exist TFormula) where
  delete (ETFormula x) = delete x

instance ITAtt3D (Exist TAtt3D) where


instance IDeletable (Exist TAtt3D) where
  delete (ETAtt3D x) = delete x

instance ITAttAxis (Exist TAttAxis) where
  setLabelColor (ETAttAxis x) = setLabelColor x
  setLabelSize (ETAttAxis x) = setLabelSize x
  setTickLength (ETAttAxis x) = setTickLength x
  setTitleOffset (ETAttAxis x) = setTitleOffset x
  setNdivisions (ETAttAxis x) = setNdivisions x

instance IDeletable (Exist TAttAxis) where
  delete (ETAttAxis x) = delete x

instance ITAttBBox (Exist TAttBBox) where


instance IDeletable (Exist TAttBBox) where
  delete (ETAttBBox x) = delete x

instance ITAttCanvas (Exist TAttCanvas) where


instance IDeletable (Exist TAttCanvas) where
  delete (ETAttCanvas x) = delete x

instance ITAttFill (Exist TAttFill) where
  setFillColor (ETAttFill x) = setFillColor x
  setFillStyle (ETAttFill x) = setFillStyle x

instance IDeletable (Exist TAttFill) where
  delete (ETAttFill x) = delete x

instance ITAttImage (Exist TAttImage) where


instance IDeletable (Exist TAttImage) where
  delete (ETAttImage x) = delete x

instance ITAttLine (Exist TAttLine) where
  setLineColor (ETAttLine x) = setLineColor x

instance IDeletable (Exist TAttLine) where
  delete (ETAttLine x) = delete x

instance ITAttMarker (Exist TAttMarker) where


instance IDeletable (Exist TAttMarker) where
  delete (ETAttMarker x) = delete x

instance ITAttPad (Exist TAttPad) where


instance IDeletable (Exist TAttPad) where
  delete (ETAttPad x) = delete x

instance ITAttParticle (Exist TAttParticle) where


instance ITNamed (Exist TAttParticle) where
  setTitle (ETAttParticle x) = setTitle x

instance ITObject (Exist TAttParticle) where
  getName (ETAttParticle x) = getName x
  draw (ETAttParticle x) = draw x
  findObject (ETAttParticle x) = findObject x
  saveAs (ETAttParticle x) = saveAs x
  write (ETAttParticle x) = write x
  isA (ETAttParticle x) = isA x
  printObj (ETAttParticle x) = printObj x

instance IDeletable (Exist TAttParticle) where
  delete (ETAttParticle x) = delete x

instance ITAttText (Exist TAttText) where
  setTextColor (ETAttText x) = setTextColor x
  setTextAlign (ETAttText x) = setTextAlign x
  setTextSize (ETAttText x) = setTextSize x

instance IDeletable (Exist TAttText) where
  delete (ETAttText x) = delete x

instance ITHStack (Exist THStack) where


instance ITNamed (Exist THStack) where
  setTitle (ETHStack x) = setTitle x

instance ITObject (Exist THStack) where
  getName (ETHStack x) = getName x
  draw (ETHStack x) = draw x
  findObject (ETHStack x) = findObject x
  saveAs (ETHStack x) = saveAs x
  write (ETHStack x) = write x
  isA (ETHStack x) = isA x
  printObj (ETHStack x) = printObj x

instance IDeletable (Exist THStack) where
  delete (ETHStack x) = delete x

instance ITF1 (Exist TF1) where


instance ITFormula (Exist TF1) where
  getParameter (ETF1 x) = getParameter x
  setParameter (ETF1 x) = setParameter x

instance ITAttLine (Exist TF1) where
  setLineColor (ETF1 x) = setLineColor x

instance ITAttFill (Exist TF1) where
  setFillColor (ETF1 x) = setFillColor x
  setFillStyle (ETF1 x) = setFillStyle x

instance ITNamed (Exist TF1) where
  setTitle (ETF1 x) = setTitle x

instance ITObject (Exist TF1) where
  getName (ETF1 x) = getName x
  draw (ETF1 x) = draw x
  findObject (ETF1 x) = findObject x
  saveAs (ETF1 x) = saveAs x
  write (ETF1 x) = write x
  isA (ETF1 x) = isA x
  printObj (ETF1 x) = printObj x

instance IDeletable (Exist TF1) where
  delete (ETF1 x) = delete x

instance ITGraph (Exist TGraph) where


instance ITNamed (Exist TGraph) where
  setTitle (ETGraph x) = setTitle x

instance ITAttLine (Exist TGraph) where
  setLineColor (ETGraph x) = setLineColor x

instance ITAttFill (Exist TGraph) where
  setFillColor (ETGraph x) = setFillColor x
  setFillStyle (ETGraph x) = setFillStyle x

instance ITAttMarker (Exist TGraph) where


instance ITObject (Exist TGraph) where
  getName (ETGraph x) = getName x
  draw (ETGraph x) = draw x
  findObject (ETGraph x) = findObject x
  saveAs (ETGraph x) = saveAs x
  write (ETGraph x) = write x
  isA (ETGraph x) = isA x
  printObj (ETGraph x) = printObj x

instance IDeletable (Exist TGraph) where
  delete (ETGraph x) = delete x

instance ITGraphAsymmErrors (Exist TGraphAsymmErrors) where


instance ITGraph (Exist TGraphAsymmErrors) where


instance ITNamed (Exist TGraphAsymmErrors) where
  setTitle (ETGraphAsymmErrors x) = setTitle x

instance ITAttLine (Exist TGraphAsymmErrors) where
  setLineColor (ETGraphAsymmErrors x) = setLineColor x

instance ITAttFill (Exist TGraphAsymmErrors) where
  setFillColor (ETGraphAsymmErrors x) = setFillColor x
  setFillStyle (ETGraphAsymmErrors x) = setFillStyle x

instance ITAttMarker (Exist TGraphAsymmErrors) where


instance ITObject (Exist TGraphAsymmErrors) where
  getName (ETGraphAsymmErrors x) = getName x
  draw (ETGraphAsymmErrors x) = draw x
  findObject (ETGraphAsymmErrors x) = findObject x
  saveAs (ETGraphAsymmErrors x) = saveAs x
  write (ETGraphAsymmErrors x) = write x
  isA (ETGraphAsymmErrors x) = isA x
  printObj (ETGraphAsymmErrors x) = printObj x

instance IDeletable (Exist TGraphAsymmErrors) where
  delete (ETGraphAsymmErrors x) = delete x

instance ITCutG (Exist TCutG) where


instance ITGraph (Exist TCutG) where


instance ITNamed (Exist TCutG) where
  setTitle (ETCutG x) = setTitle x

instance ITAttLine (Exist TCutG) where
  setLineColor (ETCutG x) = setLineColor x

instance ITAttFill (Exist TCutG) where
  setFillColor (ETCutG x) = setFillColor x
  setFillStyle (ETCutG x) = setFillStyle x

instance ITAttMarker (Exist TCutG) where


instance ITObject (Exist TCutG) where
  getName (ETCutG x) = getName x
  draw (ETCutG x) = draw x
  findObject (ETCutG x) = findObject x
  saveAs (ETCutG x) = saveAs x
  write (ETCutG x) = write x
  isA (ETCutG x) = isA x
  printObj (ETCutG x) = printObj x

instance IDeletable (Exist TCutG) where
  delete (ETCutG x) = delete x

instance ITGraphBentErrors (Exist TGraphBentErrors) where


instance ITGraph (Exist TGraphBentErrors) where


instance ITNamed (Exist TGraphBentErrors) where
  setTitle (ETGraphBentErrors x) = setTitle x

instance ITAttLine (Exist TGraphBentErrors) where
  setLineColor (ETGraphBentErrors x) = setLineColor x

instance ITAttFill (Exist TGraphBentErrors) where
  setFillColor (ETGraphBentErrors x) = setFillColor x
  setFillStyle (ETGraphBentErrors x) = setFillStyle x

instance ITAttMarker (Exist TGraphBentErrors) where


instance ITObject (Exist TGraphBentErrors) where
  getName (ETGraphBentErrors x) = getName x
  draw (ETGraphBentErrors x) = draw x
  findObject (ETGraphBentErrors x) = findObject x
  saveAs (ETGraphBentErrors x) = saveAs x
  write (ETGraphBentErrors x) = write x
  isA (ETGraphBentErrors x) = isA x
  printObj (ETGraphBentErrors x) = printObj x

instance IDeletable (Exist TGraphBentErrors) where
  delete (ETGraphBentErrors x) = delete x

instance ITGraphErrors (Exist TGraphErrors) where


instance ITGraph (Exist TGraphErrors) where


instance ITNamed (Exist TGraphErrors) where
  setTitle (ETGraphErrors x) = setTitle x

instance ITAttLine (Exist TGraphErrors) where
  setLineColor (ETGraphErrors x) = setLineColor x

instance ITAttFill (Exist TGraphErrors) where
  setFillColor (ETGraphErrors x) = setFillColor x
  setFillStyle (ETGraphErrors x) = setFillStyle x

instance ITAttMarker (Exist TGraphErrors) where


instance ITObject (Exist TGraphErrors) where
  getName (ETGraphErrors x) = getName x
  draw (ETGraphErrors x) = draw x
  findObject (ETGraphErrors x) = findObject x
  saveAs (ETGraphErrors x) = saveAs x
  write (ETGraphErrors x) = write x
  isA (ETGraphErrors x) = isA x
  printObj (ETGraphErrors x) = printObj x

instance IDeletable (Exist TGraphErrors) where
  delete (ETGraphErrors x) = delete x

instance ITGraphPolar (Exist TGraphPolar) where


instance ITGraphErrors (Exist TGraphPolar) where


instance ITGraph (Exist TGraphPolar) where


instance ITNamed (Exist TGraphPolar) where
  setTitle (ETGraphPolar x) = setTitle x

instance ITAttLine (Exist TGraphPolar) where
  setLineColor (ETGraphPolar x) = setLineColor x

instance ITAttFill (Exist TGraphPolar) where
  setFillColor (ETGraphPolar x) = setFillColor x
  setFillStyle (ETGraphPolar x) = setFillStyle x

instance ITAttMarker (Exist TGraphPolar) where


instance ITObject (Exist TGraphPolar) where
  getName (ETGraphPolar x) = getName x
  draw (ETGraphPolar x) = draw x
  findObject (ETGraphPolar x) = findObject x
  saveAs (ETGraphPolar x) = saveAs x
  write (ETGraphPolar x) = write x
  isA (ETGraphPolar x) = isA x
  printObj (ETGraphPolar x) = printObj x

instance IDeletable (Exist TGraphPolar) where
  delete (ETGraphPolar x) = delete x

instance ITGraphQQ (Exist TGraphQQ) where


instance ITGraph (Exist TGraphQQ) where


instance ITNamed (Exist TGraphQQ) where
  setTitle (ETGraphQQ x) = setTitle x

instance ITAttLine (Exist TGraphQQ) where
  setLineColor (ETGraphQQ x) = setLineColor x

instance ITAttFill (Exist TGraphQQ) where
  setFillColor (ETGraphQQ x) = setFillColor x
  setFillStyle (ETGraphQQ x) = setFillStyle x

instance ITAttMarker (Exist TGraphQQ) where


instance ITObject (Exist TGraphQQ) where
  getName (ETGraphQQ x) = getName x
  draw (ETGraphQQ x) = draw x
  findObject (ETGraphQQ x) = findObject x
  saveAs (ETGraphQQ x) = saveAs x
  write (ETGraphQQ x) = write x
  isA (ETGraphQQ x) = isA x
  printObj (ETGraphQQ x) = printObj x

instance IDeletable (Exist TGraphQQ) where
  delete (ETGraphQQ x) = delete x

instance ITEllipse (Exist TEllipse) where


instance ITObject (Exist TEllipse) where
  getName (ETEllipse x) = getName x
  draw (ETEllipse x) = draw x
  findObject (ETEllipse x) = findObject x
  saveAs (ETEllipse x) = saveAs x
  write (ETEllipse x) = write x
  isA (ETEllipse x) = isA x
  printObj (ETEllipse x) = printObj x

instance ITAttLine (Exist TEllipse) where
  setLineColor (ETEllipse x) = setLineColor x

instance ITAttFill (Exist TEllipse) where
  setFillColor (ETEllipse x) = setFillColor x
  setFillStyle (ETEllipse x) = setFillStyle x

instance IDeletable (Exist TEllipse) where
  delete (ETEllipse x) = delete x

instance ITArc (Exist TArc) where


instance ITEllipse (Exist TArc) where


instance ITObject (Exist TArc) where
  getName (ETArc x) = getName x
  draw (ETArc x) = draw x
  findObject (ETArc x) = findObject x
  saveAs (ETArc x) = saveAs x
  write (ETArc x) = write x
  isA (ETArc x) = isA x
  printObj (ETArc x) = printObj x

instance ITAttLine (Exist TArc) where
  setLineColor (ETArc x) = setLineColor x

instance ITAttFill (Exist TArc) where
  setFillColor (ETArc x) = setFillColor x
  setFillStyle (ETArc x) = setFillStyle x

instance IDeletable (Exist TArc) where
  delete (ETArc x) = delete x

instance ITCrown (Exist TCrown) where


instance ITEllipse (Exist TCrown) where


instance ITObject (Exist TCrown) where
  getName (ETCrown x) = getName x
  draw (ETCrown x) = draw x
  findObject (ETCrown x) = findObject x
  saveAs (ETCrown x) = saveAs x
  write (ETCrown x) = write x
  isA (ETCrown x) = isA x
  printObj (ETCrown x) = printObj x

instance ITAttLine (Exist TCrown) where
  setLineColor (ETCrown x) = setLineColor x

instance ITAttFill (Exist TCrown) where
  setFillColor (ETCrown x) = setFillColor x
  setFillStyle (ETCrown x) = setFillStyle x

instance IDeletable (Exist TCrown) where
  delete (ETCrown x) = delete x

instance ITLine (Exist TLine) where


instance ITObject (Exist TLine) where
  getName (ETLine x) = getName x
  draw (ETLine x) = draw x
  findObject (ETLine x) = findObject x
  saveAs (ETLine x) = saveAs x
  write (ETLine x) = write x
  isA (ETLine x) = isA x
  printObj (ETLine x) = printObj x

instance ITAttLine (Exist TLine) where
  setLineColor (ETLine x) = setLineColor x

instance IDeletable (Exist TLine) where
  delete (ETLine x) = delete x

instance ITArrow (Exist TArrow) where


instance ITLine (Exist TArrow) where


instance ITAttFill (Exist TArrow) where
  setFillColor (ETArrow x) = setFillColor x
  setFillStyle (ETArrow x) = setFillStyle x

instance ITObject (Exist TArrow) where
  getName (ETArrow x) = getName x
  draw (ETArrow x) = draw x
  findObject (ETArrow x) = findObject x
  saveAs (ETArrow x) = saveAs x
  write (ETArrow x) = write x
  isA (ETArrow x) = isA x
  printObj (ETArrow x) = printObj x

instance ITAttLine (Exist TArrow) where
  setLineColor (ETArrow x) = setLineColor x

instance IDeletable (Exist TArrow) where
  delete (ETArrow x) = delete x

instance ITGaxis (Exist TGaxis) where


instance ITLine (Exist TGaxis) where


instance ITAttText (Exist TGaxis) where
  setTextColor (ETGaxis x) = setTextColor x
  setTextAlign (ETGaxis x) = setTextAlign x
  setTextSize (ETGaxis x) = setTextSize x

instance ITObject (Exist TGaxis) where
  getName (ETGaxis x) = getName x
  draw (ETGaxis x) = draw x
  findObject (ETGaxis x) = findObject x
  saveAs (ETGaxis x) = saveAs x
  write (ETGaxis x) = write x
  isA (ETGaxis x) = isA x
  printObj (ETGaxis x) = printObj x

instance ITAttLine (Exist TGaxis) where
  setLineColor (ETGaxis x) = setLineColor x

instance IDeletable (Exist TGaxis) where
  delete (ETGaxis x) = delete x

instance ITShape (Exist TShape) where


instance ITNamed (Exist TShape) where
  setTitle (ETShape x) = setTitle x

instance ITAttLine (Exist TShape) where
  setLineColor (ETShape x) = setLineColor x

instance ITAttFill (Exist TShape) where
  setFillColor (ETShape x) = setFillColor x
  setFillStyle (ETShape x) = setFillStyle x

instance ITAtt3D (Exist TShape) where


instance ITObject (Exist TShape) where
  getName (ETShape x) = getName x
  draw (ETShape x) = draw x
  findObject (ETShape x) = findObject x
  saveAs (ETShape x) = saveAs x
  write (ETShape x) = write x
  isA (ETShape x) = isA x
  printObj (ETShape x) = printObj x

instance IDeletable (Exist TShape) where
  delete (ETShape x) = delete x

instance ITBRIK (Exist TBRIK) where


instance ITShape (Exist TBRIK) where


instance ITNamed (Exist TBRIK) where
  setTitle (ETBRIK x) = setTitle x

instance ITAttLine (Exist TBRIK) where
  setLineColor (ETBRIK x) = setLineColor x

instance ITAttFill (Exist TBRIK) where
  setFillColor (ETBRIK x) = setFillColor x
  setFillStyle (ETBRIK x) = setFillStyle x

instance ITAtt3D (Exist TBRIK) where


instance ITObject (Exist TBRIK) where
  getName (ETBRIK x) = getName x
  draw (ETBRIK x) = draw x
  findObject (ETBRIK x) = findObject x
  saveAs (ETBRIK x) = saveAs x
  write (ETBRIK x) = write x
  isA (ETBRIK x) = isA x
  printObj (ETBRIK x) = printObj x

instance IDeletable (Exist TBRIK) where
  delete (ETBRIK x) = delete x

instance ITTUBE (Exist TTUBE) where


instance ITShape (Exist TTUBE) where


instance ITNamed (Exist TTUBE) where
  setTitle (ETTUBE x) = setTitle x

instance ITAttLine (Exist TTUBE) where
  setLineColor (ETTUBE x) = setLineColor x

instance ITAttFill (Exist TTUBE) where
  setFillColor (ETTUBE x) = setFillColor x
  setFillStyle (ETTUBE x) = setFillStyle x

instance ITAtt3D (Exist TTUBE) where


instance ITObject (Exist TTUBE) where
  getName (ETTUBE x) = getName x
  draw (ETTUBE x) = draw x
  findObject (ETTUBE x) = findObject x
  saveAs (ETTUBE x) = saveAs x
  write (ETTUBE x) = write x
  isA (ETTUBE x) = isA x
  printObj (ETTUBE x) = printObj x

instance IDeletable (Exist TTUBE) where
  delete (ETTUBE x) = delete x

instance ITPCON (Exist TPCON) where


instance ITShape (Exist TPCON) where


instance ITNamed (Exist TPCON) where
  setTitle (ETPCON x) = setTitle x

instance ITAttLine (Exist TPCON) where
  setLineColor (ETPCON x) = setLineColor x

instance ITAttFill (Exist TPCON) where
  setFillColor (ETPCON x) = setFillColor x
  setFillStyle (ETPCON x) = setFillStyle x

instance ITAtt3D (Exist TPCON) where


instance ITObject (Exist TPCON) where
  getName (ETPCON x) = getName x
  draw (ETPCON x) = draw x
  findObject (ETPCON x) = findObject x
  saveAs (ETPCON x) = saveAs x
  write (ETPCON x) = write x
  isA (ETPCON x) = isA x
  printObj (ETPCON x) = printObj x

instance IDeletable (Exist TPCON) where
  delete (ETPCON x) = delete x

instance ITSPHE (Exist TSPHE) where


instance ITShape (Exist TSPHE) where


instance ITNamed (Exist TSPHE) where
  setTitle (ETSPHE x) = setTitle x

instance ITAttLine (Exist TSPHE) where
  setLineColor (ETSPHE x) = setLineColor x

instance ITAttFill (Exist TSPHE) where
  setFillColor (ETSPHE x) = setFillColor x
  setFillStyle (ETSPHE x) = setFillStyle x

instance ITAtt3D (Exist TSPHE) where


instance ITObject (Exist TSPHE) where
  getName (ETSPHE x) = getName x
  draw (ETSPHE x) = draw x
  findObject (ETSPHE x) = findObject x
  saveAs (ETSPHE x) = saveAs x
  write (ETSPHE x) = write x
  isA (ETSPHE x) = isA x
  printObj (ETSPHE x) = printObj x

instance IDeletable (Exist TSPHE) where
  delete (ETSPHE x) = delete x

instance ITXTRU (Exist TXTRU) where


instance ITShape (Exist TXTRU) where


instance ITNamed (Exist TXTRU) where
  setTitle (ETXTRU x) = setTitle x

instance ITAttLine (Exist TXTRU) where
  setLineColor (ETXTRU x) = setLineColor x

instance ITAttFill (Exist TXTRU) where
  setFillColor (ETXTRU x) = setFillColor x
  setFillStyle (ETXTRU x) = setFillStyle x

instance ITAtt3D (Exist TXTRU) where


instance ITObject (Exist TXTRU) where
  getName (ETXTRU x) = getName x
  draw (ETXTRU x) = draw x
  findObject (ETXTRU x) = findObject x
  saveAs (ETXTRU x) = saveAs x
  write (ETXTRU x) = write x
  isA (ETXTRU x) = isA x
  printObj (ETXTRU x) = printObj x

instance IDeletable (Exist TXTRU) where
  delete (ETXTRU x) = delete x

instance ITBox (Exist TBox) where


instance ITObject (Exist TBox) where
  getName (ETBox x) = getName x
  draw (ETBox x) = draw x
  findObject (ETBox x) = findObject x
  saveAs (ETBox x) = saveAs x
  write (ETBox x) = write x
  isA (ETBox x) = isA x
  printObj (ETBox x) = printObj x

instance ITAttLine (Exist TBox) where
  setLineColor (ETBox x) = setLineColor x

instance ITAttFill (Exist TBox) where
  setFillColor (ETBox x) = setFillColor x
  setFillStyle (ETBox x) = setFillStyle x

instance IDeletable (Exist TBox) where
  delete (ETBox x) = delete x

instance ITPave (Exist TPave) where


instance ITBox (Exist TPave) where


instance ITObject (Exist TPave) where
  getName (ETPave x) = getName x
  draw (ETPave x) = draw x
  findObject (ETPave x) = findObject x
  saveAs (ETPave x) = saveAs x
  write (ETPave x) = write x
  isA (ETPave x) = isA x
  printObj (ETPave x) = printObj x

instance ITAttLine (Exist TPave) where
  setLineColor (ETPave x) = setLineColor x

instance ITAttFill (Exist TPave) where
  setFillColor (ETPave x) = setFillColor x
  setFillStyle (ETPave x) = setFillStyle x

instance IDeletable (Exist TPave) where
  delete (ETPave x) = delete x

instance ITPaveText (Exist TPaveText) where


instance ITPave (Exist TPaveText) where


instance ITAttText (Exist TPaveText) where
  setTextColor (ETPaveText x) = setTextColor x
  setTextAlign (ETPaveText x) = setTextAlign x
  setTextSize (ETPaveText x) = setTextSize x

instance ITBox (Exist TPaveText) where


instance ITObject (Exist TPaveText) where
  getName (ETPaveText x) = getName x
  draw (ETPaveText x) = draw x
  findObject (ETPaveText x) = findObject x
  saveAs (ETPaveText x) = saveAs x
  write (ETPaveText x) = write x
  isA (ETPaveText x) = isA x
  printObj (ETPaveText x) = printObj x

instance ITAttLine (Exist TPaveText) where
  setLineColor (ETPaveText x) = setLineColor x

instance ITAttFill (Exist TPaveText) where
  setFillColor (ETPaveText x) = setFillColor x
  setFillStyle (ETPaveText x) = setFillStyle x

instance IDeletable (Exist TPaveText) where
  delete (ETPaveText x) = delete x

instance ITDiamond (Exist TDiamond) where


instance ITPaveText (Exist TDiamond) where


instance ITPave (Exist TDiamond) where


instance ITAttText (Exist TDiamond) where
  setTextColor (ETDiamond x) = setTextColor x
  setTextAlign (ETDiamond x) = setTextAlign x
  setTextSize (ETDiamond x) = setTextSize x

instance ITBox (Exist TDiamond) where


instance ITObject (Exist TDiamond) where
  getName (ETDiamond x) = getName x
  draw (ETDiamond x) = draw x
  findObject (ETDiamond x) = findObject x
  saveAs (ETDiamond x) = saveAs x
  write (ETDiamond x) = write x
  isA (ETDiamond x) = isA x
  printObj (ETDiamond x) = printObj x

instance ITAttLine (Exist TDiamond) where
  setLineColor (ETDiamond x) = setLineColor x

instance ITAttFill (Exist TDiamond) where
  setFillColor (ETDiamond x) = setFillColor x
  setFillStyle (ETDiamond x) = setFillStyle x

instance IDeletable (Exist TDiamond) where
  delete (ETDiamond x) = delete x

instance ITPaveStats (Exist TPaveStats) where


instance ITPaveText (Exist TPaveStats) where


instance ITPave (Exist TPaveStats) where


instance ITAttText (Exist TPaveStats) where
  setTextColor (ETPaveStats x) = setTextColor x
  setTextAlign (ETPaveStats x) = setTextAlign x
  setTextSize (ETPaveStats x) = setTextSize x

instance ITBox (Exist TPaveStats) where


instance ITObject (Exist TPaveStats) where
  getName (ETPaveStats x) = getName x
  draw (ETPaveStats x) = draw x
  findObject (ETPaveStats x) = findObject x
  saveAs (ETPaveStats x) = saveAs x
  write (ETPaveStats x) = write x
  isA (ETPaveStats x) = isA x
  printObj (ETPaveStats x) = printObj x

instance ITAttLine (Exist TPaveStats) where
  setLineColor (ETPaveStats x) = setLineColor x

instance ITAttFill (Exist TPaveStats) where
  setFillColor (ETPaveStats x) = setFillColor x
  setFillStyle (ETPaveStats x) = setFillStyle x

instance IDeletable (Exist TPaveStats) where
  delete (ETPaveStats x) = delete x

instance ITPavesText (Exist TPavesText) where


instance ITPaveText (Exist TPavesText) where


instance ITPave (Exist TPavesText) where


instance ITAttText (Exist TPavesText) where
  setTextColor (ETPavesText x) = setTextColor x
  setTextAlign (ETPavesText x) = setTextAlign x
  setTextSize (ETPavesText x) = setTextSize x

instance ITBox (Exist TPavesText) where


instance ITObject (Exist TPavesText) where
  getName (ETPavesText x) = getName x
  draw (ETPavesText x) = draw x
  findObject (ETPavesText x) = findObject x
  saveAs (ETPavesText x) = saveAs x
  write (ETPavesText x) = write x
  isA (ETPavesText x) = isA x
  printObj (ETPavesText x) = printObj x

instance ITAttLine (Exist TPavesText) where
  setLineColor (ETPavesText x) = setLineColor x

instance ITAttFill (Exist TPavesText) where
  setFillColor (ETPavesText x) = setFillColor x
  setFillStyle (ETPavesText x) = setFillStyle x

instance IDeletable (Exist TPavesText) where
  delete (ETPavesText x) = delete x

instance ITLegend (Exist TLegend) where
  addEntry (ETLegend x) = addEntry x

instance ITPave (Exist TLegend) where


instance ITAttText (Exist TLegend) where
  setTextColor (ETLegend x) = setTextColor x
  setTextAlign (ETLegend x) = setTextAlign x
  setTextSize (ETLegend x) = setTextSize x

instance ITBox (Exist TLegend) where


instance ITObject (Exist TLegend) where
  getName (ETLegend x) = getName x
  draw (ETLegend x) = draw x
  findObject (ETLegend x) = findObject x
  saveAs (ETLegend x) = saveAs x
  write (ETLegend x) = write x
  isA (ETLegend x) = isA x
  printObj (ETLegend x) = printObj x

instance ITAttLine (Exist TLegend) where
  setLineColor (ETLegend x) = setLineColor x

instance ITAttFill (Exist TLegend) where
  setFillColor (ETLegend x) = setFillColor x
  setFillStyle (ETLegend x) = setFillStyle x

instance IDeletable (Exist TLegend) where
  delete (ETLegend x) = delete x

instance ITLegendEntry (Exist TLegendEntry) where


instance ITObject (Exist TLegendEntry) where
  getName (ETLegendEntry x) = getName x
  draw (ETLegendEntry x) = draw x
  findObject (ETLegendEntry x) = findObject x
  saveAs (ETLegendEntry x) = saveAs x
  write (ETLegendEntry x) = write x
  isA (ETLegendEntry x) = isA x
  printObj (ETLegendEntry x) = printObj x

instance ITAttText (Exist TLegendEntry) where
  setTextColor (ETLegendEntry x) = setTextColor x
  setTextAlign (ETLegendEntry x) = setTextAlign x
  setTextSize (ETLegendEntry x) = setTextSize x

instance ITAttLine (Exist TLegendEntry) where
  setLineColor (ETLegendEntry x) = setLineColor x

instance ITAttFill (Exist TLegendEntry) where
  setFillColor (ETLegendEntry x) = setFillColor x
  setFillStyle (ETLegendEntry x) = setFillStyle x

instance ITAttMarker (Exist TLegendEntry) where


instance IDeletable (Exist TLegendEntry) where
  delete (ETLegendEntry x) = delete x

instance ITPaveLabel (Exist TPaveLabel) where


instance ITPave (Exist TPaveLabel) where


instance ITAttText (Exist TPaveLabel) where
  setTextColor (ETPaveLabel x) = setTextColor x
  setTextAlign (ETPaveLabel x) = setTextAlign x
  setTextSize (ETPaveLabel x) = setTextSize x

instance ITBox (Exist TPaveLabel) where


instance ITObject (Exist TPaveLabel) where
  getName (ETPaveLabel x) = getName x
  draw (ETPaveLabel x) = draw x
  findObject (ETPaveLabel x) = findObject x
  saveAs (ETPaveLabel x) = saveAs x
  write (ETPaveLabel x) = write x
  isA (ETPaveLabel x) = isA x
  printObj (ETPaveLabel x) = printObj x

instance ITAttLine (Exist TPaveLabel) where
  setLineColor (ETPaveLabel x) = setLineColor x

instance ITAttFill (Exist TPaveLabel) where
  setFillColor (ETPaveLabel x) = setFillColor x
  setFillStyle (ETPaveLabel x) = setFillStyle x

instance IDeletable (Exist TPaveLabel) where
  delete (ETPaveLabel x) = delete x

instance ITPaveClass (Exist TPaveClass) where


instance ITPaveLabel (Exist TPaveClass) where


instance ITPave (Exist TPaveClass) where


instance ITAttText (Exist TPaveClass) where
  setTextColor (ETPaveClass x) = setTextColor x
  setTextAlign (ETPaveClass x) = setTextAlign x
  setTextSize (ETPaveClass x) = setTextSize x

instance ITBox (Exist TPaveClass) where


instance ITObject (Exist TPaveClass) where
  getName (ETPaveClass x) = getName x
  draw (ETPaveClass x) = draw x
  findObject (ETPaveClass x) = findObject x
  saveAs (ETPaveClass x) = saveAs x
  write (ETPaveClass x) = write x
  isA (ETPaveClass x) = isA x
  printObj (ETPaveClass x) = printObj x

instance ITAttLine (Exist TPaveClass) where
  setLineColor (ETPaveClass x) = setLineColor x

instance ITAttFill (Exist TPaveClass) where
  setFillColor (ETPaveClass x) = setFillColor x
  setFillStyle (ETPaveClass x) = setFillStyle x

instance IDeletable (Exist TPaveClass) where
  delete (ETPaveClass x) = delete x

instance ITWbox (Exist TWbox) where
  setBorderMode (ETWbox x) = setBorderMode x

instance ITBox (Exist TWbox) where


instance ITObject (Exist TWbox) where
  getName (ETWbox x) = getName x
  draw (ETWbox x) = draw x
  findObject (ETWbox x) = findObject x
  saveAs (ETWbox x) = saveAs x
  write (ETWbox x) = write x
  isA (ETWbox x) = isA x
  printObj (ETWbox x) = printObj x

instance ITAttLine (Exist TWbox) where
  setLineColor (ETWbox x) = setLineColor x

instance ITAttFill (Exist TWbox) where
  setFillColor (ETWbox x) = setFillColor x
  setFillStyle (ETWbox x) = setFillStyle x

instance IDeletable (Exist TWbox) where
  delete (ETWbox x) = delete x

instance ITFrame (Exist TFrame) where


instance ITWbox (Exist TFrame) where
  setBorderMode (ETFrame x) = setBorderMode x

instance ITBox (Exist TFrame) where


instance ITObject (Exist TFrame) where
  getName (ETFrame x) = getName x
  draw (ETFrame x) = draw x
  findObject (ETFrame x) = findObject x
  saveAs (ETFrame x) = saveAs x
  write (ETFrame x) = write x
  isA (ETFrame x) = isA x
  printObj (ETFrame x) = printObj x

instance ITAttLine (Exist TFrame) where
  setLineColor (ETFrame x) = setLineColor x

instance ITAttFill (Exist TFrame) where
  setFillColor (ETFrame x) = setFillColor x
  setFillStyle (ETFrame x) = setFillStyle x

instance IDeletable (Exist TFrame) where
  delete (ETFrame x) = delete x

instance ITSliderBox (Exist TSliderBox) where


instance ITWbox (Exist TSliderBox) where
  setBorderMode (ETSliderBox x) = setBorderMode x

instance ITBox (Exist TSliderBox) where


instance ITObject (Exist TSliderBox) where
  getName (ETSliderBox x) = getName x
  draw (ETSliderBox x) = draw x
  findObject (ETSliderBox x) = findObject x
  saveAs (ETSliderBox x) = saveAs x
  write (ETSliderBox x) = write x
  isA (ETSliderBox x) = isA x
  printObj (ETSliderBox x) = printObj x

instance ITAttLine (Exist TSliderBox) where
  setLineColor (ETSliderBox x) = setLineColor x

instance ITAttFill (Exist TSliderBox) where
  setFillColor (ETSliderBox x) = setFillColor x
  setFillStyle (ETSliderBox x) = setFillStyle x

instance IDeletable (Exist TSliderBox) where
  delete (ETSliderBox x) = delete x

instance ITTree (Exist TTree) where


instance ITNamed (Exist TTree) where
  setTitle (ETTree x) = setTitle x

instance ITAttLine (Exist TTree) where
  setLineColor (ETTree x) = setLineColor x

instance ITAttFill (Exist TTree) where
  setFillColor (ETTree x) = setFillColor x
  setFillStyle (ETTree x) = setFillStyle x

instance ITAttMarker (Exist TTree) where


instance ITObject (Exist TTree) where
  getName (ETTree x) = getName x
  draw (ETTree x) = draw x
  findObject (ETTree x) = findObject x
  saveAs (ETTree x) = saveAs x
  write (ETTree x) = write x
  isA (ETTree x) = isA x
  printObj (ETTree x) = printObj x

instance IDeletable (Exist TTree) where
  delete (ETTree x) = delete x

instance ITChain (Exist TChain) where


instance ITTree (Exist TChain) where


instance ITNamed (Exist TChain) where
  setTitle (ETChain x) = setTitle x

instance ITAttLine (Exist TChain) where
  setLineColor (ETChain x) = setLineColor x

instance ITAttFill (Exist TChain) where
  setFillColor (ETChain x) = setFillColor x
  setFillStyle (ETChain x) = setFillStyle x

instance ITAttMarker (Exist TChain) where


instance ITObject (Exist TChain) where
  getName (ETChain x) = getName x
  draw (ETChain x) = draw x
  findObject (ETChain x) = findObject x
  saveAs (ETChain x) = saveAs x
  write (ETChain x) = write x
  isA (ETChain x) = isA x
  printObj (ETChain x) = printObj x

instance IDeletable (Exist TChain) where
  delete (ETChain x) = delete x

instance ITNtuple (Exist TNtuple) where


instance ITTree (Exist TNtuple) where


instance ITNamed (Exist TNtuple) where
  setTitle (ETNtuple x) = setTitle x

instance ITAttLine (Exist TNtuple) where
  setLineColor (ETNtuple x) = setLineColor x

instance ITAttFill (Exist TNtuple) where
  setFillColor (ETNtuple x) = setFillColor x
  setFillStyle (ETNtuple x) = setFillStyle x

instance ITAttMarker (Exist TNtuple) where


instance ITObject (Exist TNtuple) where
  getName (ETNtuple x) = getName x
  draw (ETNtuple x) = draw x
  findObject (ETNtuple x) = findObject x
  saveAs (ETNtuple x) = saveAs x
  write (ETNtuple x) = write x
  isA (ETNtuple x) = isA x
  printObj (ETNtuple x) = printObj x

instance IDeletable (Exist TNtuple) where
  delete (ETNtuple x) = delete x

instance ITNtupleD (Exist TNtupleD) where


instance ITTree (Exist TNtupleD) where


instance ITNamed (Exist TNtupleD) where
  setTitle (ETNtupleD x) = setTitle x

instance ITAttLine (Exist TNtupleD) where
  setLineColor (ETNtupleD x) = setLineColor x

instance ITAttFill (Exist TNtupleD) where
  setFillColor (ETNtupleD x) = setFillColor x
  setFillStyle (ETNtupleD x) = setFillStyle x

instance ITAttMarker (Exist TNtupleD) where


instance ITObject (Exist TNtupleD) where
  getName (ETNtupleD x) = getName x
  draw (ETNtupleD x) = draw x
  findObject (ETNtupleD x) = findObject x
  saveAs (ETNtupleD x) = saveAs x
  write (ETNtupleD x) = write x
  isA (ETNtupleD x) = isA x
  printObj (ETNtupleD x) = printObj x

instance IDeletable (Exist TNtupleD) where
  delete (ETNtupleD x) = delete x

instance ITTreeSQL (Exist TTreeSQL) where


instance ITTree (Exist TTreeSQL) where


instance ITNamed (Exist TTreeSQL) where
  setTitle (ETTreeSQL x) = setTitle x

instance ITAttLine (Exist TTreeSQL) where
  setLineColor (ETTreeSQL x) = setLineColor x

instance ITAttFill (Exist TTreeSQL) where
  setFillColor (ETTreeSQL x) = setFillColor x
  setFillStyle (ETTreeSQL x) = setFillStyle x

instance ITAttMarker (Exist TTreeSQL) where


instance ITObject (Exist TTreeSQL) where
  getName (ETTreeSQL x) = getName x
  draw (ETTreeSQL x) = draw x
  findObject (ETTreeSQL x) = findObject x
  saveAs (ETTreeSQL x) = saveAs x
  write (ETTreeSQL x) = write x
  isA (ETTreeSQL x) = isA x
  printObj (ETTreeSQL x) = printObj x

instance IDeletable (Exist TTreeSQL) where
  delete (ETTreeSQL x) = delete x

instance ITPolyLine (Exist TPolyLine) where


instance ITObject (Exist TPolyLine) where
  getName (ETPolyLine x) = getName x
  draw (ETPolyLine x) = draw x
  findObject (ETPolyLine x) = findObject x
  saveAs (ETPolyLine x) = saveAs x
  write (ETPolyLine x) = write x
  isA (ETPolyLine x) = isA x
  printObj (ETPolyLine x) = printObj x

instance ITAttLine (Exist TPolyLine) where
  setLineColor (ETPolyLine x) = setLineColor x

instance ITAttFill (Exist TPolyLine) where
  setFillColor (ETPolyLine x) = setFillColor x
  setFillStyle (ETPolyLine x) = setFillStyle x

instance IDeletable (Exist TPolyLine) where
  delete (ETPolyLine x) = delete x

instance ITCurlyLine (Exist TCurlyLine) where


instance ITPolyLine (Exist TCurlyLine) where


instance ITObject (Exist TCurlyLine) where
  getName (ETCurlyLine x) = getName x
  draw (ETCurlyLine x) = draw x
  findObject (ETCurlyLine x) = findObject x
  saveAs (ETCurlyLine x) = saveAs x
  write (ETCurlyLine x) = write x
  isA (ETCurlyLine x) = isA x
  printObj (ETCurlyLine x) = printObj x

instance ITAttLine (Exist TCurlyLine) where
  setLineColor (ETCurlyLine x) = setLineColor x

instance ITAttFill (Exist TCurlyLine) where
  setFillColor (ETCurlyLine x) = setFillColor x
  setFillStyle (ETCurlyLine x) = setFillStyle x

instance IDeletable (Exist TCurlyLine) where
  delete (ETCurlyLine x) = delete x

instance ITCurlyArc (Exist TCurlyArc) where


instance ITCurlyLine (Exist TCurlyArc) where


instance ITPolyLine (Exist TCurlyArc) where


instance ITObject (Exist TCurlyArc) where
  getName (ETCurlyArc x) = getName x
  draw (ETCurlyArc x) = draw x
  findObject (ETCurlyArc x) = findObject x
  saveAs (ETCurlyArc x) = saveAs x
  write (ETCurlyArc x) = write x
  isA (ETCurlyArc x) = isA x
  printObj (ETCurlyArc x) = printObj x

instance ITAttLine (Exist TCurlyArc) where
  setLineColor (ETCurlyArc x) = setLineColor x

instance ITAttFill (Exist TCurlyArc) where
  setFillColor (ETCurlyArc x) = setFillColor x
  setFillStyle (ETCurlyArc x) = setFillStyle x

instance IDeletable (Exist TCurlyArc) where
  delete (ETCurlyArc x) = delete x

instance ITEfficiency (Exist TEfficiency) where


instance ITNamed (Exist TEfficiency) where
  setTitle (ETEfficiency x) = setTitle x

instance ITAttLine (Exist TEfficiency) where
  setLineColor (ETEfficiency x) = setLineColor x

instance ITAttFill (Exist TEfficiency) where
  setFillColor (ETEfficiency x) = setFillColor x
  setFillStyle (ETEfficiency x) = setFillStyle x

instance ITAttMarker (Exist TEfficiency) where


instance ITObject (Exist TEfficiency) where
  getName (ETEfficiency x) = getName x
  draw (ETEfficiency x) = draw x
  findObject (ETEfficiency x) = findObject x
  saveAs (ETEfficiency x) = saveAs x
  write (ETEfficiency x) = write x
  isA (ETEfficiency x) = isA x
  printObj (ETEfficiency x) = printObj x

instance IDeletable (Exist TEfficiency) where
  delete (ETEfficiency x) = delete x

instance ITAxis (Exist TAxis) where
  setTimeDisplay (ETAxis x) = setTimeDisplay x
  setTimeFormat (ETAxis x) = setTimeFormat x
  setTimeOffset (ETAxis x) = setTimeOffset x

instance ITNamed (Exist TAxis) where
  setTitle (ETAxis x) = setTitle x

instance ITAttAxis (Exist TAxis) where
  setLabelColor (ETAxis x) = setLabelColor x
  setLabelSize (ETAxis x) = setLabelSize x
  setTickLength (ETAxis x) = setTickLength x
  setTitleOffset (ETAxis x) = setTitleOffset x
  setNdivisions (ETAxis x) = setNdivisions x

instance ITObject (Exist TAxis) where
  getName (ETAxis x) = getName x
  draw (ETAxis x) = draw x
  findObject (ETAxis x) = findObject x
  saveAs (ETAxis x) = saveAs x
  write (ETAxis x) = write x
  isA (ETAxis x) = isA x
  printObj (ETAxis x) = printObj x

instance IDeletable (Exist TAxis) where
  delete (ETAxis x) = delete x

instance ITLatex (Exist TLatex) where


instance ITText (Exist TLatex) where


instance ITAttLine (Exist TLatex) where
  setLineColor (ETLatex x) = setLineColor x

instance ITNamed (Exist TLatex) where
  setTitle (ETLatex x) = setTitle x

instance ITAttText (Exist TLatex) where
  setTextColor (ETLatex x) = setTextColor x
  setTextAlign (ETLatex x) = setTextAlign x
  setTextSize (ETLatex x) = setTextSize x

instance ITObject (Exist TLatex) where
  getName (ETLatex x) = getName x
  draw (ETLatex x) = draw x
  findObject (ETLatex x) = findObject x
  saveAs (ETLatex x) = saveAs x
  write (ETLatex x) = write x
  isA (ETLatex x) = isA x
  printObj (ETLatex x) = printObj x

instance IDeletable (Exist TLatex) where
  delete (ETLatex x) = delete x

instance ITText (Exist TText) where


instance ITNamed (Exist TText) where
  setTitle (ETText x) = setTitle x

instance ITAttText (Exist TText) where
  setTextColor (ETText x) = setTextColor x
  setTextAlign (ETText x) = setTextAlign x
  setTextSize (ETText x) = setTextSize x

instance ITObject (Exist TText) where
  getName (ETText x) = getName x
  draw (ETText x) = draw x
  findObject (ETText x) = findObject x
  saveAs (ETText x) = saveAs x
  write (ETText x) = write x
  isA (ETText x) = isA x
  printObj (ETText x) = printObj x

instance IDeletable (Exist TText) where
  delete (ETText x) = delete x

instance ITDirectory (Exist TDirectory) where
  append (ETDirectory x) = append x
  addD (ETDirectory x) = addD x
  appendKey (ETDirectory x) = appendKey x
  close (ETDirectory x) = close x
  get (ETDirectory x) = get x

instance ITNamed (Exist TDirectory) where
  setTitle (ETDirectory x) = setTitle x

instance ITObject (Exist TDirectory) where
  getName (ETDirectory x) = getName x
  draw (ETDirectory x) = draw x
  findObject (ETDirectory x) = findObject x
  saveAs (ETDirectory x) = saveAs x
  write (ETDirectory x) = write x
  isA (ETDirectory x) = isA x
  printObj (ETDirectory x) = printObj x

instance IDeletable (Exist TDirectory) where
  delete (ETDirectory x) = delete x

instance ITDirectoryFile (Exist TDirectoryFile) where
  getListOfKeys (ETDirectoryFile x) = getListOfKeys x

instance ITDirectory (Exist TDirectoryFile) where
  append (ETDirectoryFile x) = append x
  addD (ETDirectoryFile x) = addD x
  appendKey (ETDirectoryFile x) = appendKey x
  close (ETDirectoryFile x) = close x
  get (ETDirectoryFile x) = get x

instance ITNamed (Exist TDirectoryFile) where
  setTitle (ETDirectoryFile x) = setTitle x

instance ITObject (Exist TDirectoryFile) where
  getName (ETDirectoryFile x) = getName x
  draw (ETDirectoryFile x) = draw x
  findObject (ETDirectoryFile x) = findObject x
  saveAs (ETDirectoryFile x) = saveAs x
  write (ETDirectoryFile x) = write x
  isA (ETDirectoryFile x) = isA x
  printObj (ETDirectoryFile x) = printObj x

instance IDeletable (Exist TDirectoryFile) where
  delete (ETDirectoryFile x) = delete x

instance ITFile (Exist TFile) where


instance ITDirectoryFile (Exist TFile) where
  getListOfKeys (ETFile x) = getListOfKeys x

instance ITDirectory (Exist TFile) where
  append (ETFile x) = append x
  addD (ETFile x) = addD x
  appendKey (ETFile x) = appendKey x
  close (ETFile x) = close x
  get (ETFile x) = get x

instance ITNamed (Exist TFile) where
  setTitle (ETFile x) = setTitle x

instance ITObject (Exist TFile) where
  getName (ETFile x) = getName x
  draw (ETFile x) = draw x
  findObject (ETFile x) = findObject x
  saveAs (ETFile x) = saveAs x
  write (ETFile x) = write x
  isA (ETFile x) = isA x
  printObj (ETFile x) = printObj x

instance IDeletable (Exist TFile) where
  delete (ETFile x) = delete x

instance ITBranch (Exist TBranch) where


instance ITNamed (Exist TBranch) where
  setTitle (ETBranch x) = setTitle x

instance ITAttFill (Exist TBranch) where
  setFillColor (ETBranch x) = setFillColor x
  setFillStyle (ETBranch x) = setFillStyle x

instance ITObject (Exist TBranch) where
  getName (ETBranch x) = getName x
  draw (ETBranch x) = draw x
  findObject (ETBranch x) = findObject x
  saveAs (ETBranch x) = saveAs x
  write (ETBranch x) = write x
  isA (ETBranch x) = isA x
  printObj (ETBranch x) = printObj x

instance IDeletable (Exist TBranch) where
  delete (ETBranch x) = delete x

instance ITVirtualTreePlayer (Exist TVirtualTreePlayer) where


instance ITObject (Exist TVirtualTreePlayer) where
  getName (ETVirtualTreePlayer x) = getName x
  draw (ETVirtualTreePlayer x) = draw x
  findObject (ETVirtualTreePlayer x) = findObject x
  saveAs (ETVirtualTreePlayer x) = saveAs x
  write (ETVirtualTreePlayer x) = write x
  isA (ETVirtualTreePlayer x) = isA x
  printObj (ETVirtualTreePlayer x) = printObj x

instance IDeletable (Exist TVirtualTreePlayer) where
  delete (ETVirtualTreePlayer x) = delete x

instance ITTreePlayer (Exist TTreePlayer) where


instance ITVirtualTreePlayer (Exist TTreePlayer) where


instance ITObject (Exist TTreePlayer) where
  getName (ETTreePlayer x) = getName x
  draw (ETTreePlayer x) = draw x
  findObject (ETTreePlayer x) = findObject x
  saveAs (ETTreePlayer x) = saveAs x
  write (ETTreePlayer x) = write x
  isA (ETTreePlayer x) = isA x
  printObj (ETTreePlayer x) = printObj x

instance IDeletable (Exist TTreePlayer) where
  delete (ETTreePlayer x) = delete x

instance ITArray (Exist TArray) where


instance IDeletable (Exist TArray) where
  delete (ETArray x) = delete x

instance ITArrayC (Exist TArrayC) where


instance ITArray (Exist TArrayC) where


instance IDeletable (Exist TArrayC) where
  delete (ETArrayC x) = delete x

instance ITArrayD (Exist TArrayD) where


instance ITArray (Exist TArrayD) where


instance IDeletable (Exist TArrayD) where
  delete (ETArrayD x) = delete x

instance ITArrayF (Exist TArrayF) where


instance ITArray (Exist TArrayF) where


instance IDeletable (Exist TArrayF) where
  delete (ETArrayF x) = delete x

instance ITArrayI (Exist TArrayI) where


instance ITArray (Exist TArrayI) where


instance IDeletable (Exist TArrayI) where
  delete (ETArrayI x) = delete x

instance ITArrayL (Exist TArrayL) where


instance ITArray (Exist TArrayL) where


instance IDeletable (Exist TArrayL) where
  delete (ETArrayL x) = delete x

instance ITArrayL64 (Exist TArrayL64) where


instance ITArray (Exist TArrayL64) where


instance IDeletable (Exist TArrayL64) where
  delete (ETArrayL64 x) = delete x

instance ITArrayS (Exist TArrayS) where


instance ITArray (Exist TArrayS) where


instance IDeletable (Exist TArrayS) where
  delete (ETArrayS x) = delete x

instance ITH1 (Exist TH1) where
  add (ETH1 x) = add x
  addBinContent (ETH1 x) = addBinContent x
  chi2Test (ETH1 x) = chi2Test x
  computeIntegral (ETH1 x) = computeIntegral x
  directoryAutoAdd (ETH1 x) = directoryAutoAdd x
  distancetoPrimitive (ETH1 x) = distancetoPrimitive x
  divide (ETH1 x) = divide x
  drawCopy (ETH1 x) a1 = return . ETH1 =<< drawCopy x a1
  drawNormalized (ETH1 x) = drawNormalized x
  drawPanel (ETH1 x) = drawPanel x
  bufferEmpty (ETH1 x) = bufferEmpty x
  eval (ETH1 x) = eval x
  executeEvent (ETH1 x) = executeEvent x
  fFT (ETH1 x) = fFT x
  fill1 (ETH1 x) = fill1 x
  fillN (ETH1 x) = fillN x
  fillRandom (ETH1 x) = fillRandom x
  findBin (ETH1 x) = findBin x
  findFixBin (ETH1 x) = findFixBin x
  findFirstBinAbove (ETH1 x) = findFirstBinAbove x
  findLastBinAbove (ETH1 x) = findLastBinAbove x
  fitPanel (ETH1 x) = fitPanel x
  getNdivisions (ETH1 x) = getNdivisions x
  getAxisColor (ETH1 x) = getAxisColor x
  getLabelColor (ETH1 x) = getLabelColor x
  getLabelFont (ETH1 x) = getLabelFont x
  getLabelOffset (ETH1 x) = getLabelOffset x
  getLabelSize (ETH1 x) = getLabelSize x
  getTitleFont (ETH1 x) = getTitleFont x
  getTitleOffset (ETH1 x) = getTitleOffset x
  getTitleSize (ETH1 x) = getTitleSize x
  getTickLength (ETH1 x) = getTickLength x
  getBarOffset (ETH1 x) = getBarOffset x
  getBarWidth (ETH1 x) = getBarWidth x
  getContour (ETH1 x) = getContour x
  getContourLevel (ETH1 x) = getContourLevel x
  getContourLevelPad (ETH1 x) = getContourLevelPad x
  getBin (ETH1 x) = getBin x
  getBinCenter (ETH1 x) = getBinCenter x
  getBinContent1 (ETH1 x) = getBinContent1 x
  getBinContent2 (ETH1 x) = getBinContent2 x
  getBinContent3 (ETH1 x) = getBinContent3 x
  getBinError1 (ETH1 x) = getBinError1 x
  getBinError2 (ETH1 x) = getBinError2 x
  getBinError3 (ETH1 x) = getBinError3 x
  getBinLowEdge (ETH1 x) = getBinLowEdge x
  getBinWidth (ETH1 x) = getBinWidth x
  getCellContent (ETH1 x) = getCellContent x
  getCellError (ETH1 x) = getCellError x
  scale (ETH1 x) = scale x
  setAxisColor (ETH1 x) = setAxisColor x
  setAxisRange (ETH1 x) = setAxisRange x
  setBarOffset (ETH1 x) = setBarOffset x
  setBarWidth (ETH1 x) = setBarWidth x
  setBinContent1 (ETH1 x) = setBinContent1 x
  setBinContent2 (ETH1 x) = setBinContent2 x
  setBinContent3 (ETH1 x) = setBinContent3 x
  setBinError1 (ETH1 x) = setBinError1 x
  setBinError2 (ETH1 x) = setBinError2 x
  setBinError3 (ETH1 x) = setBinError3 x
  setBins1 (ETH1 x) = setBins1 x
  setBins2 (ETH1 x) = setBins2 x
  setBins3 (ETH1 x) = setBins3 x
  setMaximum (ETH1 x) = setMaximum x
  setMinimum (ETH1 x) = setMinimum x
  setXTitle (ETH1 x) = setXTitle x
  setYTitle (ETH1 x) = setYTitle x
  setZTitle (ETH1 x) = setZTitle x

instance ITNamed (Exist TH1) where
  setTitle (ETH1 x) = setTitle x

instance ITAttLine (Exist TH1) where
  setLineColor (ETH1 x) = setLineColor x

instance ITAttFill (Exist TH1) where
  setFillColor (ETH1 x) = setFillColor x
  setFillStyle (ETH1 x) = setFillStyle x

instance ITAttMarker (Exist TH1) where


instance ITObject (Exist TH1) where
  getName (ETH1 x) = getName x
  draw (ETH1 x) = draw x
  findObject (ETH1 x) = findObject x
  saveAs (ETH1 x) = saveAs x
  write (ETH1 x) = write x
  isA (ETH1 x) = isA x
  printObj (ETH1 x) = printObj x

instance IDeletable (Exist TH1) where
  delete (ETH1 x) = delete x

instance ITH2 (Exist TH2) where
  fill2 (ETH2 x) = fill2 x
  fillRandom2 (ETH2 x) = fillRandom2 x
  findFirstBinAbove2 (ETH2 x) = findFirstBinAbove2 x
  findLastBinAbove2 (ETH2 x) = findLastBinAbove2 x
  fitSlicesX (ETH2 x) = fitSlicesX x
  fitSlicesY (ETH2 x) = fitSlicesY x
  getCorrelationFactor (ETH2 x) = getCorrelationFactor x
  getCovariance (ETH2 x) = getCovariance x
  getStats (ETH2 x) = getStats x
  integral (ETH2 x) = integral x
  interpolate (ETH2 x) = interpolate x
  kolmogorovTest (ETH2 x) = kolmogorovTest x
  rebinX (ETH2 x) = rebinX x
  rebinY (ETH2 x) = rebinY x
  rebin2D (ETH2 x) = rebin2D x
  putStats (ETH2 x) = putStats x
  reset (ETH2 x) = reset x
  setShowProjectionX (ETH2 x) = setShowProjectionX x
  setShowProjectionY (ETH2 x) = setShowProjectionY x
  showBackground (ETH2 x) = showBackground x
  showPeaks (ETH2 x) = showPeaks x
  smooth (ETH2 x) = smooth x

instance ITH1 (Exist TH2) where
  add (ETH2 x) = add x
  addBinContent (ETH2 x) = addBinContent x
  chi2Test (ETH2 x) = chi2Test x
  computeIntegral (ETH2 x) = computeIntegral x
  directoryAutoAdd (ETH2 x) = directoryAutoAdd x
  distancetoPrimitive (ETH2 x) = distancetoPrimitive x
  divide (ETH2 x) = divide x
  drawCopy (ETH2 x) a1 = return . ETH2 =<< drawCopy x a1
  drawNormalized (ETH2 x) = drawNormalized x
  drawPanel (ETH2 x) = drawPanel x
  bufferEmpty (ETH2 x) = bufferEmpty x
  eval (ETH2 x) = eval x
  executeEvent (ETH2 x) = executeEvent x
  fFT (ETH2 x) = fFT x
  fill1 (ETH2 x) = fill1 x
  fillN (ETH2 x) = fillN x
  fillRandom (ETH2 x) = fillRandom x
  findBin (ETH2 x) = findBin x
  findFixBin (ETH2 x) = findFixBin x
  findFirstBinAbove (ETH2 x) = findFirstBinAbove x
  findLastBinAbove (ETH2 x) = findLastBinAbove x
  fitPanel (ETH2 x) = fitPanel x
  getNdivisions (ETH2 x) = getNdivisions x
  getAxisColor (ETH2 x) = getAxisColor x
  getLabelColor (ETH2 x) = getLabelColor x
  getLabelFont (ETH2 x) = getLabelFont x
  getLabelOffset (ETH2 x) = getLabelOffset x
  getLabelSize (ETH2 x) = getLabelSize x
  getTitleFont (ETH2 x) = getTitleFont x
  getTitleOffset (ETH2 x) = getTitleOffset x
  getTitleSize (ETH2 x) = getTitleSize x
  getTickLength (ETH2 x) = getTickLength x
  getBarOffset (ETH2 x) = getBarOffset x
  getBarWidth (ETH2 x) = getBarWidth x
  getContour (ETH2 x) = getContour x
  getContourLevel (ETH2 x) = getContourLevel x
  getContourLevelPad (ETH2 x) = getContourLevelPad x
  getBin (ETH2 x) = getBin x
  getBinCenter (ETH2 x) = getBinCenter x
  getBinContent1 (ETH2 x) = getBinContent1 x
  getBinContent2 (ETH2 x) = getBinContent2 x
  getBinContent3 (ETH2 x) = getBinContent3 x
  getBinError1 (ETH2 x) = getBinError1 x
  getBinError2 (ETH2 x) = getBinError2 x
  getBinError3 (ETH2 x) = getBinError3 x
  getBinLowEdge (ETH2 x) = getBinLowEdge x
  getBinWidth (ETH2 x) = getBinWidth x
  getCellContent (ETH2 x) = getCellContent x
  getCellError (ETH2 x) = getCellError x
  scale (ETH2 x) = scale x
  setAxisColor (ETH2 x) = setAxisColor x
  setAxisRange (ETH2 x) = setAxisRange x
  setBarOffset (ETH2 x) = setBarOffset x
  setBarWidth (ETH2 x) = setBarWidth x
  setBinContent1 (ETH2 x) = setBinContent1 x
  setBinContent2 (ETH2 x) = setBinContent2 x
  setBinContent3 (ETH2 x) = setBinContent3 x
  setBinError1 (ETH2 x) = setBinError1 x
  setBinError2 (ETH2 x) = setBinError2 x
  setBinError3 (ETH2 x) = setBinError3 x
  setBins1 (ETH2 x) = setBins1 x
  setBins2 (ETH2 x) = setBins2 x
  setBins3 (ETH2 x) = setBins3 x
  setMaximum (ETH2 x) = setMaximum x
  setMinimum (ETH2 x) = setMinimum x
  setXTitle (ETH2 x) = setXTitle x
  setYTitle (ETH2 x) = setYTitle x
  setZTitle (ETH2 x) = setZTitle x

instance ITNamed (Exist TH2) where
  setTitle (ETH2 x) = setTitle x

instance ITAttLine (Exist TH2) where
  setLineColor (ETH2 x) = setLineColor x

instance ITAttFill (Exist TH2) where
  setFillColor (ETH2 x) = setFillColor x
  setFillStyle (ETH2 x) = setFillStyle x

instance ITAttMarker (Exist TH2) where


instance ITObject (Exist TH2) where
  getName (ETH2 x) = getName x
  draw (ETH2 x) = draw x
  findObject (ETH2 x) = findObject x
  saveAs (ETH2 x) = saveAs x
  write (ETH2 x) = write x
  isA (ETH2 x) = isA x
  printObj (ETH2 x) = printObj x

instance IDeletable (Exist TH2) where
  delete (ETH2 x) = delete x

instance ITH3 (Exist TH3) where


instance ITH1 (Exist TH3) where
  add (ETH3 x) = add x
  addBinContent (ETH3 x) = addBinContent x
  chi2Test (ETH3 x) = chi2Test x
  computeIntegral (ETH3 x) = computeIntegral x
  directoryAutoAdd (ETH3 x) = directoryAutoAdd x
  distancetoPrimitive (ETH3 x) = distancetoPrimitive x
  divide (ETH3 x) = divide x
  drawCopy (ETH3 x) a1 = return . ETH3 =<< drawCopy x a1
  drawNormalized (ETH3 x) = drawNormalized x
  drawPanel (ETH3 x) = drawPanel x
  bufferEmpty (ETH3 x) = bufferEmpty x
  eval (ETH3 x) = eval x
  executeEvent (ETH3 x) = executeEvent x
  fFT (ETH3 x) = fFT x
  fill1 (ETH3 x) = fill1 x
  fillN (ETH3 x) = fillN x
  fillRandom (ETH3 x) = fillRandom x
  findBin (ETH3 x) = findBin x
  findFixBin (ETH3 x) = findFixBin x
  findFirstBinAbove (ETH3 x) = findFirstBinAbove x
  findLastBinAbove (ETH3 x) = findLastBinAbove x
  fitPanel (ETH3 x) = fitPanel x
  getNdivisions (ETH3 x) = getNdivisions x
  getAxisColor (ETH3 x) = getAxisColor x
  getLabelColor (ETH3 x) = getLabelColor x
  getLabelFont (ETH3 x) = getLabelFont x
  getLabelOffset (ETH3 x) = getLabelOffset x
  getLabelSize (ETH3 x) = getLabelSize x
  getTitleFont (ETH3 x) = getTitleFont x
  getTitleOffset (ETH3 x) = getTitleOffset x
  getTitleSize (ETH3 x) = getTitleSize x
  getTickLength (ETH3 x) = getTickLength x
  getBarOffset (ETH3 x) = getBarOffset x
  getBarWidth (ETH3 x) = getBarWidth x
  getContour (ETH3 x) = getContour x
  getContourLevel (ETH3 x) = getContourLevel x
  getContourLevelPad (ETH3 x) = getContourLevelPad x
  getBin (ETH3 x) = getBin x
  getBinCenter (ETH3 x) = getBinCenter x
  getBinContent1 (ETH3 x) = getBinContent1 x
  getBinContent2 (ETH3 x) = getBinContent2 x
  getBinContent3 (ETH3 x) = getBinContent3 x
  getBinError1 (ETH3 x) = getBinError1 x
  getBinError2 (ETH3 x) = getBinError2 x
  getBinError3 (ETH3 x) = getBinError3 x
  getBinLowEdge (ETH3 x) = getBinLowEdge x
  getBinWidth (ETH3 x) = getBinWidth x
  getCellContent (ETH3 x) = getCellContent x
  getCellError (ETH3 x) = getCellError x
  scale (ETH3 x) = scale x
  setAxisColor (ETH3 x) = setAxisColor x
  setAxisRange (ETH3 x) = setAxisRange x
  setBarOffset (ETH3 x) = setBarOffset x
  setBarWidth (ETH3 x) = setBarWidth x
  setBinContent1 (ETH3 x) = setBinContent1 x
  setBinContent2 (ETH3 x) = setBinContent2 x
  setBinContent3 (ETH3 x) = setBinContent3 x
  setBinError1 (ETH3 x) = setBinError1 x
  setBinError2 (ETH3 x) = setBinError2 x
  setBinError3 (ETH3 x) = setBinError3 x
  setBins1 (ETH3 x) = setBins1 x
  setBins2 (ETH3 x) = setBins2 x
  setBins3 (ETH3 x) = setBins3 x
  setMaximum (ETH3 x) = setMaximum x
  setMinimum (ETH3 x) = setMinimum x
  setXTitle (ETH3 x) = setXTitle x
  setYTitle (ETH3 x) = setYTitle x
  setZTitle (ETH3 x) = setZTitle x

instance ITAtt3D (Exist TH3) where


instance ITNamed (Exist TH3) where
  setTitle (ETH3 x) = setTitle x

instance ITAttLine (Exist TH3) where
  setLineColor (ETH3 x) = setLineColor x

instance ITAttFill (Exist TH3) where
  setFillColor (ETH3 x) = setFillColor x
  setFillStyle (ETH3 x) = setFillStyle x

instance ITAttMarker (Exist TH3) where


instance ITObject (Exist TH3) where
  getName (ETH3 x) = getName x
  draw (ETH3 x) = draw x
  findObject (ETH3 x) = findObject x
  saveAs (ETH3 x) = saveAs x
  write (ETH3 x) = write x
  isA (ETH3 x) = isA x
  printObj (ETH3 x) = printObj x

instance IDeletable (Exist TH3) where
  delete (ETH3 x) = delete x

instance ITH1C (Exist TH1C) where


instance ITH1 (Exist TH1C) where
  add (ETH1C x) = add x
  addBinContent (ETH1C x) = addBinContent x
  chi2Test (ETH1C x) = chi2Test x
  computeIntegral (ETH1C x) = computeIntegral x
  directoryAutoAdd (ETH1C x) = directoryAutoAdd x
  distancetoPrimitive (ETH1C x) = distancetoPrimitive x
  divide (ETH1C x) = divide x
  drawCopy (ETH1C x) a1 = return . ETH1C =<< drawCopy x a1
  drawNormalized (ETH1C x) = drawNormalized x
  drawPanel (ETH1C x) = drawPanel x
  bufferEmpty (ETH1C x) = bufferEmpty x
  eval (ETH1C x) = eval x
  executeEvent (ETH1C x) = executeEvent x
  fFT (ETH1C x) = fFT x
  fill1 (ETH1C x) = fill1 x
  fillN (ETH1C x) = fillN x
  fillRandom (ETH1C x) = fillRandom x
  findBin (ETH1C x) = findBin x
  findFixBin (ETH1C x) = findFixBin x
  findFirstBinAbove (ETH1C x) = findFirstBinAbove x
  findLastBinAbove (ETH1C x) = findLastBinAbove x
  fitPanel (ETH1C x) = fitPanel x
  getNdivisions (ETH1C x) = getNdivisions x
  getAxisColor (ETH1C x) = getAxisColor x
  getLabelColor (ETH1C x) = getLabelColor x
  getLabelFont (ETH1C x) = getLabelFont x
  getLabelOffset (ETH1C x) = getLabelOffset x
  getLabelSize (ETH1C x) = getLabelSize x
  getTitleFont (ETH1C x) = getTitleFont x
  getTitleOffset (ETH1C x) = getTitleOffset x
  getTitleSize (ETH1C x) = getTitleSize x
  getTickLength (ETH1C x) = getTickLength x
  getBarOffset (ETH1C x) = getBarOffset x
  getBarWidth (ETH1C x) = getBarWidth x
  getContour (ETH1C x) = getContour x
  getContourLevel (ETH1C x) = getContourLevel x
  getContourLevelPad (ETH1C x) = getContourLevelPad x
  getBin (ETH1C x) = getBin x
  getBinCenter (ETH1C x) = getBinCenter x
  getBinContent1 (ETH1C x) = getBinContent1 x
  getBinContent2 (ETH1C x) = getBinContent2 x
  getBinContent3 (ETH1C x) = getBinContent3 x
  getBinError1 (ETH1C x) = getBinError1 x
  getBinError2 (ETH1C x) = getBinError2 x
  getBinError3 (ETH1C x) = getBinError3 x
  getBinLowEdge (ETH1C x) = getBinLowEdge x
  getBinWidth (ETH1C x) = getBinWidth x
  getCellContent (ETH1C x) = getCellContent x
  getCellError (ETH1C x) = getCellError x
  scale (ETH1C x) = scale x
  setAxisColor (ETH1C x) = setAxisColor x
  setAxisRange (ETH1C x) = setAxisRange x
  setBarOffset (ETH1C x) = setBarOffset x
  setBarWidth (ETH1C x) = setBarWidth x
  setBinContent1 (ETH1C x) = setBinContent1 x
  setBinContent2 (ETH1C x) = setBinContent2 x
  setBinContent3 (ETH1C x) = setBinContent3 x
  setBinError1 (ETH1C x) = setBinError1 x
  setBinError2 (ETH1C x) = setBinError2 x
  setBinError3 (ETH1C x) = setBinError3 x
  setBins1 (ETH1C x) = setBins1 x
  setBins2 (ETH1C x) = setBins2 x
  setBins3 (ETH1C x) = setBins3 x
  setMaximum (ETH1C x) = setMaximum x
  setMinimum (ETH1C x) = setMinimum x
  setXTitle (ETH1C x) = setXTitle x
  setYTitle (ETH1C x) = setYTitle x
  setZTitle (ETH1C x) = setZTitle x

instance ITArrayC (Exist TH1C) where


instance ITNamed (Exist TH1C) where
  setTitle (ETH1C x) = setTitle x

instance ITAttLine (Exist TH1C) where
  setLineColor (ETH1C x) = setLineColor x

instance ITAttFill (Exist TH1C) where
  setFillColor (ETH1C x) = setFillColor x
  setFillStyle (ETH1C x) = setFillStyle x

instance ITAttMarker (Exist TH1C) where


instance ITObject (Exist TH1C) where
  getName (ETH1C x) = getName x
  draw (ETH1C x) = draw x
  findObject (ETH1C x) = findObject x
  saveAs (ETH1C x) = saveAs x
  write (ETH1C x) = write x
  isA (ETH1C x) = isA x
  printObj (ETH1C x) = printObj x

instance IDeletable (Exist TH1C) where
  delete (ETH1C x) = delete x

instance ITArray (Exist TH1C) where


instance ITH1D (Exist TH1D) where


instance ITH1 (Exist TH1D) where
  add (ETH1D x) = add x
  addBinContent (ETH1D x) = addBinContent x
  chi2Test (ETH1D x) = chi2Test x
  computeIntegral (ETH1D x) = computeIntegral x
  directoryAutoAdd (ETH1D x) = directoryAutoAdd x
  distancetoPrimitive (ETH1D x) = distancetoPrimitive x
  divide (ETH1D x) = divide x
  drawCopy (ETH1D x) a1 = return . ETH1D =<< drawCopy x a1
  drawNormalized (ETH1D x) = drawNormalized x
  drawPanel (ETH1D x) = drawPanel x
  bufferEmpty (ETH1D x) = bufferEmpty x
  eval (ETH1D x) = eval x
  executeEvent (ETH1D x) = executeEvent x
  fFT (ETH1D x) = fFT x
  fill1 (ETH1D x) = fill1 x
  fillN (ETH1D x) = fillN x
  fillRandom (ETH1D x) = fillRandom x
  findBin (ETH1D x) = findBin x
  findFixBin (ETH1D x) = findFixBin x
  findFirstBinAbove (ETH1D x) = findFirstBinAbove x
  findLastBinAbove (ETH1D x) = findLastBinAbove x
  fitPanel (ETH1D x) = fitPanel x
  getNdivisions (ETH1D x) = getNdivisions x
  getAxisColor (ETH1D x) = getAxisColor x
  getLabelColor (ETH1D x) = getLabelColor x
  getLabelFont (ETH1D x) = getLabelFont x
  getLabelOffset (ETH1D x) = getLabelOffset x
  getLabelSize (ETH1D x) = getLabelSize x
  getTitleFont (ETH1D x) = getTitleFont x
  getTitleOffset (ETH1D x) = getTitleOffset x
  getTitleSize (ETH1D x) = getTitleSize x
  getTickLength (ETH1D x) = getTickLength x
  getBarOffset (ETH1D x) = getBarOffset x
  getBarWidth (ETH1D x) = getBarWidth x
  getContour (ETH1D x) = getContour x
  getContourLevel (ETH1D x) = getContourLevel x
  getContourLevelPad (ETH1D x) = getContourLevelPad x
  getBin (ETH1D x) = getBin x
  getBinCenter (ETH1D x) = getBinCenter x
  getBinContent1 (ETH1D x) = getBinContent1 x
  getBinContent2 (ETH1D x) = getBinContent2 x
  getBinContent3 (ETH1D x) = getBinContent3 x
  getBinError1 (ETH1D x) = getBinError1 x
  getBinError2 (ETH1D x) = getBinError2 x
  getBinError3 (ETH1D x) = getBinError3 x
  getBinLowEdge (ETH1D x) = getBinLowEdge x
  getBinWidth (ETH1D x) = getBinWidth x
  getCellContent (ETH1D x) = getCellContent x
  getCellError (ETH1D x) = getCellError x
  scale (ETH1D x) = scale x
  setAxisColor (ETH1D x) = setAxisColor x
  setAxisRange (ETH1D x) = setAxisRange x
  setBarOffset (ETH1D x) = setBarOffset x
  setBarWidth (ETH1D x) = setBarWidth x
  setBinContent1 (ETH1D x) = setBinContent1 x
  setBinContent2 (ETH1D x) = setBinContent2 x
  setBinContent3 (ETH1D x) = setBinContent3 x
  setBinError1 (ETH1D x) = setBinError1 x
  setBinError2 (ETH1D x) = setBinError2 x
  setBinError3 (ETH1D x) = setBinError3 x
  setBins1 (ETH1D x) = setBins1 x
  setBins2 (ETH1D x) = setBins2 x
  setBins3 (ETH1D x) = setBins3 x
  setMaximum (ETH1D x) = setMaximum x
  setMinimum (ETH1D x) = setMinimum x
  setXTitle (ETH1D x) = setXTitle x
  setYTitle (ETH1D x) = setYTitle x
  setZTitle (ETH1D x) = setZTitle x

instance ITArrayD (Exist TH1D) where


instance ITNamed (Exist TH1D) where
  setTitle (ETH1D x) = setTitle x

instance ITAttLine (Exist TH1D) where
  setLineColor (ETH1D x) = setLineColor x

instance ITAttFill (Exist TH1D) where
  setFillColor (ETH1D x) = setFillColor x
  setFillStyle (ETH1D x) = setFillStyle x

instance ITAttMarker (Exist TH1D) where


instance ITObject (Exist TH1D) where
  getName (ETH1D x) = getName x
  draw (ETH1D x) = draw x
  findObject (ETH1D x) = findObject x
  saveAs (ETH1D x) = saveAs x
  write (ETH1D x) = write x
  isA (ETH1D x) = isA x
  printObj (ETH1D x) = printObj x

instance IDeletable (Exist TH1D) where
  delete (ETH1D x) = delete x

instance ITArray (Exist TH1D) where


instance ITH1F (Exist TH1F) where


instance ITH1 (Exist TH1F) where
  add (ETH1F x) = add x
  addBinContent (ETH1F x) = addBinContent x
  chi2Test (ETH1F x) = chi2Test x
  computeIntegral (ETH1F x) = computeIntegral x
  directoryAutoAdd (ETH1F x) = directoryAutoAdd x
  distancetoPrimitive (ETH1F x) = distancetoPrimitive x
  divide (ETH1F x) = divide x
  drawCopy (ETH1F x) a1 = return . ETH1F =<< drawCopy x a1
  drawNormalized (ETH1F x) = drawNormalized x
  drawPanel (ETH1F x) = drawPanel x
  bufferEmpty (ETH1F x) = bufferEmpty x
  eval (ETH1F x) = eval x
  executeEvent (ETH1F x) = executeEvent x
  fFT (ETH1F x) = fFT x
  fill1 (ETH1F x) = fill1 x
  fillN (ETH1F x) = fillN x
  fillRandom (ETH1F x) = fillRandom x
  findBin (ETH1F x) = findBin x
  findFixBin (ETH1F x) = findFixBin x
  findFirstBinAbove (ETH1F x) = findFirstBinAbove x
  findLastBinAbove (ETH1F x) = findLastBinAbove x
  fitPanel (ETH1F x) = fitPanel x
  getNdivisions (ETH1F x) = getNdivisions x
  getAxisColor (ETH1F x) = getAxisColor x
  getLabelColor (ETH1F x) = getLabelColor x
  getLabelFont (ETH1F x) = getLabelFont x
  getLabelOffset (ETH1F x) = getLabelOffset x
  getLabelSize (ETH1F x) = getLabelSize x
  getTitleFont (ETH1F x) = getTitleFont x
  getTitleOffset (ETH1F x) = getTitleOffset x
  getTitleSize (ETH1F x) = getTitleSize x
  getTickLength (ETH1F x) = getTickLength x
  getBarOffset (ETH1F x) = getBarOffset x
  getBarWidth (ETH1F x) = getBarWidth x
  getContour (ETH1F x) = getContour x
  getContourLevel (ETH1F x) = getContourLevel x
  getContourLevelPad (ETH1F x) = getContourLevelPad x
  getBin (ETH1F x) = getBin x
  getBinCenter (ETH1F x) = getBinCenter x
  getBinContent1 (ETH1F x) = getBinContent1 x
  getBinContent2 (ETH1F x) = getBinContent2 x
  getBinContent3 (ETH1F x) = getBinContent3 x
  getBinError1 (ETH1F x) = getBinError1 x
  getBinError2 (ETH1F x) = getBinError2 x
  getBinError3 (ETH1F x) = getBinError3 x
  getBinLowEdge (ETH1F x) = getBinLowEdge x
  getBinWidth (ETH1F x) = getBinWidth x
  getCellContent (ETH1F x) = getCellContent x
  getCellError (ETH1F x) = getCellError x
  scale (ETH1F x) = scale x
  setAxisColor (ETH1F x) = setAxisColor x
  setAxisRange (ETH1F x) = setAxisRange x
  setBarOffset (ETH1F x) = setBarOffset x
  setBarWidth (ETH1F x) = setBarWidth x
  setBinContent1 (ETH1F x) = setBinContent1 x
  setBinContent2 (ETH1F x) = setBinContent2 x
  setBinContent3 (ETH1F x) = setBinContent3 x
  setBinError1 (ETH1F x) = setBinError1 x
  setBinError2 (ETH1F x) = setBinError2 x
  setBinError3 (ETH1F x) = setBinError3 x
  setBins1 (ETH1F x) = setBins1 x
  setBins2 (ETH1F x) = setBins2 x
  setBins3 (ETH1F x) = setBins3 x
  setMaximum (ETH1F x) = setMaximum x
  setMinimum (ETH1F x) = setMinimum x
  setXTitle (ETH1F x) = setXTitle x
  setYTitle (ETH1F x) = setYTitle x
  setZTitle (ETH1F x) = setZTitle x

instance ITArrayF (Exist TH1F) where


instance ITNamed (Exist TH1F) where
  setTitle (ETH1F x) = setTitle x

instance ITAttLine (Exist TH1F) where
  setLineColor (ETH1F x) = setLineColor x

instance ITAttFill (Exist TH1F) where
  setFillColor (ETH1F x) = setFillColor x
  setFillStyle (ETH1F x) = setFillStyle x

instance ITAttMarker (Exist TH1F) where


instance ITObject (Exist TH1F) where
  getName (ETH1F x) = getName x
  draw (ETH1F x) = draw x
  findObject (ETH1F x) = findObject x
  saveAs (ETH1F x) = saveAs x
  write (ETH1F x) = write x
  isA (ETH1F x) = isA x
  printObj (ETH1F x) = printObj x

instance IDeletable (Exist TH1F) where
  delete (ETH1F x) = delete x

instance ITArray (Exist TH1F) where


instance ITH1I (Exist TH1I) where


instance ITH1 (Exist TH1I) where
  add (ETH1I x) = add x
  addBinContent (ETH1I x) = addBinContent x
  chi2Test (ETH1I x) = chi2Test x
  computeIntegral (ETH1I x) = computeIntegral x
  directoryAutoAdd (ETH1I x) = directoryAutoAdd x
  distancetoPrimitive (ETH1I x) = distancetoPrimitive x
  divide (ETH1I x) = divide x
  drawCopy (ETH1I x) a1 = return . ETH1I =<< drawCopy x a1
  drawNormalized (ETH1I x) = drawNormalized x
  drawPanel (ETH1I x) = drawPanel x
  bufferEmpty (ETH1I x) = bufferEmpty x
  eval (ETH1I x) = eval x
  executeEvent (ETH1I x) = executeEvent x
  fFT (ETH1I x) = fFT x
  fill1 (ETH1I x) = fill1 x
  fillN (ETH1I x) = fillN x
  fillRandom (ETH1I x) = fillRandom x
  findBin (ETH1I x) = findBin x
  findFixBin (ETH1I x) = findFixBin x
  findFirstBinAbove (ETH1I x) = findFirstBinAbove x
  findLastBinAbove (ETH1I x) = findLastBinAbove x
  fitPanel (ETH1I x) = fitPanel x
  getNdivisions (ETH1I x) = getNdivisions x
  getAxisColor (ETH1I x) = getAxisColor x
  getLabelColor (ETH1I x) = getLabelColor x
  getLabelFont (ETH1I x) = getLabelFont x
  getLabelOffset (ETH1I x) = getLabelOffset x
  getLabelSize (ETH1I x) = getLabelSize x
  getTitleFont (ETH1I x) = getTitleFont x
  getTitleOffset (ETH1I x) = getTitleOffset x
  getTitleSize (ETH1I x) = getTitleSize x
  getTickLength (ETH1I x) = getTickLength x
  getBarOffset (ETH1I x) = getBarOffset x
  getBarWidth (ETH1I x) = getBarWidth x
  getContour (ETH1I x) = getContour x
  getContourLevel (ETH1I x) = getContourLevel x
  getContourLevelPad (ETH1I x) = getContourLevelPad x
  getBin (ETH1I x) = getBin x
  getBinCenter (ETH1I x) = getBinCenter x
  getBinContent1 (ETH1I x) = getBinContent1 x
  getBinContent2 (ETH1I x) = getBinContent2 x
  getBinContent3 (ETH1I x) = getBinContent3 x
  getBinError1 (ETH1I x) = getBinError1 x
  getBinError2 (ETH1I x) = getBinError2 x
  getBinError3 (ETH1I x) = getBinError3 x
  getBinLowEdge (ETH1I x) = getBinLowEdge x
  getBinWidth (ETH1I x) = getBinWidth x
  getCellContent (ETH1I x) = getCellContent x
  getCellError (ETH1I x) = getCellError x
  scale (ETH1I x) = scale x
  setAxisColor (ETH1I x) = setAxisColor x
  setAxisRange (ETH1I x) = setAxisRange x
  setBarOffset (ETH1I x) = setBarOffset x
  setBarWidth (ETH1I x) = setBarWidth x
  setBinContent1 (ETH1I x) = setBinContent1 x
  setBinContent2 (ETH1I x) = setBinContent2 x
  setBinContent3 (ETH1I x) = setBinContent3 x
  setBinError1 (ETH1I x) = setBinError1 x
  setBinError2 (ETH1I x) = setBinError2 x
  setBinError3 (ETH1I x) = setBinError3 x
  setBins1 (ETH1I x) = setBins1 x
  setBins2 (ETH1I x) = setBins2 x
  setBins3 (ETH1I x) = setBins3 x
  setMaximum (ETH1I x) = setMaximum x
  setMinimum (ETH1I x) = setMinimum x
  setXTitle (ETH1I x) = setXTitle x
  setYTitle (ETH1I x) = setYTitle x
  setZTitle (ETH1I x) = setZTitle x

instance ITArrayI (Exist TH1I) where


instance ITNamed (Exist TH1I) where
  setTitle (ETH1I x) = setTitle x

instance ITAttLine (Exist TH1I) where
  setLineColor (ETH1I x) = setLineColor x

instance ITAttFill (Exist TH1I) where
  setFillColor (ETH1I x) = setFillColor x
  setFillStyle (ETH1I x) = setFillStyle x

instance ITAttMarker (Exist TH1I) where


instance ITObject (Exist TH1I) where
  getName (ETH1I x) = getName x
  draw (ETH1I x) = draw x
  findObject (ETH1I x) = findObject x
  saveAs (ETH1I x) = saveAs x
  write (ETH1I x) = write x
  isA (ETH1I x) = isA x
  printObj (ETH1I x) = printObj x

instance IDeletable (Exist TH1I) where
  delete (ETH1I x) = delete x

instance ITArray (Exist TH1I) where


instance ITH1S (Exist TH1S) where


instance ITH1 (Exist TH1S) where
  add (ETH1S x) = add x
  addBinContent (ETH1S x) = addBinContent x
  chi2Test (ETH1S x) = chi2Test x
  computeIntegral (ETH1S x) = computeIntegral x
  directoryAutoAdd (ETH1S x) = directoryAutoAdd x
  distancetoPrimitive (ETH1S x) = distancetoPrimitive x
  divide (ETH1S x) = divide x
  drawCopy (ETH1S x) a1 = return . ETH1S =<< drawCopy x a1
  drawNormalized (ETH1S x) = drawNormalized x
  drawPanel (ETH1S x) = drawPanel x
  bufferEmpty (ETH1S x) = bufferEmpty x
  eval (ETH1S x) = eval x
  executeEvent (ETH1S x) = executeEvent x
  fFT (ETH1S x) = fFT x
  fill1 (ETH1S x) = fill1 x
  fillN (ETH1S x) = fillN x
  fillRandom (ETH1S x) = fillRandom x
  findBin (ETH1S x) = findBin x
  findFixBin (ETH1S x) = findFixBin x
  findFirstBinAbove (ETH1S x) = findFirstBinAbove x
  findLastBinAbove (ETH1S x) = findLastBinAbove x
  fitPanel (ETH1S x) = fitPanel x
  getNdivisions (ETH1S x) = getNdivisions x
  getAxisColor (ETH1S x) = getAxisColor x
  getLabelColor (ETH1S x) = getLabelColor x
  getLabelFont (ETH1S x) = getLabelFont x
  getLabelOffset (ETH1S x) = getLabelOffset x
  getLabelSize (ETH1S x) = getLabelSize x
  getTitleFont (ETH1S x) = getTitleFont x
  getTitleOffset (ETH1S x) = getTitleOffset x
  getTitleSize (ETH1S x) = getTitleSize x
  getTickLength (ETH1S x) = getTickLength x
  getBarOffset (ETH1S x) = getBarOffset x
  getBarWidth (ETH1S x) = getBarWidth x
  getContour (ETH1S x) = getContour x
  getContourLevel (ETH1S x) = getContourLevel x
  getContourLevelPad (ETH1S x) = getContourLevelPad x
  getBin (ETH1S x) = getBin x
  getBinCenter (ETH1S x) = getBinCenter x
  getBinContent1 (ETH1S x) = getBinContent1 x
  getBinContent2 (ETH1S x) = getBinContent2 x
  getBinContent3 (ETH1S x) = getBinContent3 x
  getBinError1 (ETH1S x) = getBinError1 x
  getBinError2 (ETH1S x) = getBinError2 x
  getBinError3 (ETH1S x) = getBinError3 x
  getBinLowEdge (ETH1S x) = getBinLowEdge x
  getBinWidth (ETH1S x) = getBinWidth x
  getCellContent (ETH1S x) = getCellContent x
  getCellError (ETH1S x) = getCellError x
  scale (ETH1S x) = scale x
  setAxisColor (ETH1S x) = setAxisColor x
  setAxisRange (ETH1S x) = setAxisRange x
  setBarOffset (ETH1S x) = setBarOffset x
  setBarWidth (ETH1S x) = setBarWidth x
  setBinContent1 (ETH1S x) = setBinContent1 x
  setBinContent2 (ETH1S x) = setBinContent2 x
  setBinContent3 (ETH1S x) = setBinContent3 x
  setBinError1 (ETH1S x) = setBinError1 x
  setBinError2 (ETH1S x) = setBinError2 x
  setBinError3 (ETH1S x) = setBinError3 x
  setBins1 (ETH1S x) = setBins1 x
  setBins2 (ETH1S x) = setBins2 x
  setBins3 (ETH1S x) = setBins3 x
  setMaximum (ETH1S x) = setMaximum x
  setMinimum (ETH1S x) = setMinimum x
  setXTitle (ETH1S x) = setXTitle x
  setYTitle (ETH1S x) = setYTitle x
  setZTitle (ETH1S x) = setZTitle x

instance ITArrayS (Exist TH1S) where


instance ITNamed (Exist TH1S) where
  setTitle (ETH1S x) = setTitle x

instance ITAttLine (Exist TH1S) where
  setLineColor (ETH1S x) = setLineColor x

instance ITAttFill (Exist TH1S) where
  setFillColor (ETH1S x) = setFillColor x
  setFillStyle (ETH1S x) = setFillStyle x

instance ITAttMarker (Exist TH1S) where


instance ITObject (Exist TH1S) where
  getName (ETH1S x) = getName x
  draw (ETH1S x) = draw x
  findObject (ETH1S x) = findObject x
  saveAs (ETH1S x) = saveAs x
  write (ETH1S x) = write x
  isA (ETH1S x) = isA x
  printObj (ETH1S x) = printObj x

instance IDeletable (Exist TH1S) where
  delete (ETH1S x) = delete x

instance ITArray (Exist TH1S) where


instance ITH2C (Exist TH2C) where


instance ITH2 (Exist TH2C) where
  fill2 (ETH2C x) = fill2 x
  fillRandom2 (ETH2C x) = fillRandom2 x
  findFirstBinAbove2 (ETH2C x) = findFirstBinAbove2 x
  findLastBinAbove2 (ETH2C x) = findLastBinAbove2 x
  fitSlicesX (ETH2C x) = fitSlicesX x
  fitSlicesY (ETH2C x) = fitSlicesY x
  getCorrelationFactor (ETH2C x) = getCorrelationFactor x
  getCovariance (ETH2C x) = getCovariance x
  getStats (ETH2C x) = getStats x
  integral (ETH2C x) = integral x
  interpolate (ETH2C x) = interpolate x
  kolmogorovTest (ETH2C x) = kolmogorovTest x
  rebinX (ETH2C x) = rebinX x
  rebinY (ETH2C x) = rebinY x
  rebin2D (ETH2C x) = rebin2D x
  putStats (ETH2C x) = putStats x
  reset (ETH2C x) = reset x
  setShowProjectionX (ETH2C x) = setShowProjectionX x
  setShowProjectionY (ETH2C x) = setShowProjectionY x
  showBackground (ETH2C x) = showBackground x
  showPeaks (ETH2C x) = showPeaks x
  smooth (ETH2C x) = smooth x

instance ITArrayC (Exist TH2C) where


instance ITH1 (Exist TH2C) where
  add (ETH2C x) = add x
  addBinContent (ETH2C x) = addBinContent x
  chi2Test (ETH2C x) = chi2Test x
  computeIntegral (ETH2C x) = computeIntegral x
  directoryAutoAdd (ETH2C x) = directoryAutoAdd x
  distancetoPrimitive (ETH2C x) = distancetoPrimitive x
  divide (ETH2C x) = divide x
  drawCopy (ETH2C x) a1 = return . ETH2C =<< drawCopy x a1
  drawNormalized (ETH2C x) = drawNormalized x
  drawPanel (ETH2C x) = drawPanel x
  bufferEmpty (ETH2C x) = bufferEmpty x
  eval (ETH2C x) = eval x
  executeEvent (ETH2C x) = executeEvent x
  fFT (ETH2C x) = fFT x
  fill1 (ETH2C x) = fill1 x
  fillN (ETH2C x) = fillN x
  fillRandom (ETH2C x) = fillRandom x
  findBin (ETH2C x) = findBin x
  findFixBin (ETH2C x) = findFixBin x
  findFirstBinAbove (ETH2C x) = findFirstBinAbove x
  findLastBinAbove (ETH2C x) = findLastBinAbove x
  fitPanel (ETH2C x) = fitPanel x
  getNdivisions (ETH2C x) = getNdivisions x
  getAxisColor (ETH2C x) = getAxisColor x
  getLabelColor (ETH2C x) = getLabelColor x
  getLabelFont (ETH2C x) = getLabelFont x
  getLabelOffset (ETH2C x) = getLabelOffset x
  getLabelSize (ETH2C x) = getLabelSize x
  getTitleFont (ETH2C x) = getTitleFont x
  getTitleOffset (ETH2C x) = getTitleOffset x
  getTitleSize (ETH2C x) = getTitleSize x
  getTickLength (ETH2C x) = getTickLength x
  getBarOffset (ETH2C x) = getBarOffset x
  getBarWidth (ETH2C x) = getBarWidth x
  getContour (ETH2C x) = getContour x
  getContourLevel (ETH2C x) = getContourLevel x
  getContourLevelPad (ETH2C x) = getContourLevelPad x
  getBin (ETH2C x) = getBin x
  getBinCenter (ETH2C x) = getBinCenter x
  getBinContent1 (ETH2C x) = getBinContent1 x
  getBinContent2 (ETH2C x) = getBinContent2 x
  getBinContent3 (ETH2C x) = getBinContent3 x
  getBinError1 (ETH2C x) = getBinError1 x
  getBinError2 (ETH2C x) = getBinError2 x
  getBinError3 (ETH2C x) = getBinError3 x
  getBinLowEdge (ETH2C x) = getBinLowEdge x
  getBinWidth (ETH2C x) = getBinWidth x
  getCellContent (ETH2C x) = getCellContent x
  getCellError (ETH2C x) = getCellError x
  scale (ETH2C x) = scale x
  setAxisColor (ETH2C x) = setAxisColor x
  setAxisRange (ETH2C x) = setAxisRange x
  setBarOffset (ETH2C x) = setBarOffset x
  setBarWidth (ETH2C x) = setBarWidth x
  setBinContent1 (ETH2C x) = setBinContent1 x
  setBinContent2 (ETH2C x) = setBinContent2 x
  setBinContent3 (ETH2C x) = setBinContent3 x
  setBinError1 (ETH2C x) = setBinError1 x
  setBinError2 (ETH2C x) = setBinError2 x
  setBinError3 (ETH2C x) = setBinError3 x
  setBins1 (ETH2C x) = setBins1 x
  setBins2 (ETH2C x) = setBins2 x
  setBins3 (ETH2C x) = setBins3 x
  setMaximum (ETH2C x) = setMaximum x
  setMinimum (ETH2C x) = setMinimum x
  setXTitle (ETH2C x) = setXTitle x
  setYTitle (ETH2C x) = setYTitle x
  setZTitle (ETH2C x) = setZTitle x

instance ITNamed (Exist TH2C) where
  setTitle (ETH2C x) = setTitle x

instance ITAttLine (Exist TH2C) where
  setLineColor (ETH2C x) = setLineColor x

instance ITAttFill (Exist TH2C) where
  setFillColor (ETH2C x) = setFillColor x
  setFillStyle (ETH2C x) = setFillStyle x

instance ITAttMarker (Exist TH2C) where


instance ITObject (Exist TH2C) where
  getName (ETH2C x) = getName x
  draw (ETH2C x) = draw x
  findObject (ETH2C x) = findObject x
  saveAs (ETH2C x) = saveAs x
  write (ETH2C x) = write x
  isA (ETH2C x) = isA x
  printObj (ETH2C x) = printObj x

instance IDeletable (Exist TH2C) where
  delete (ETH2C x) = delete x

instance ITArray (Exist TH2C) where


instance ITH2D (Exist TH2D) where


instance ITH2 (Exist TH2D) where
  fill2 (ETH2D x) = fill2 x
  fillRandom2 (ETH2D x) = fillRandom2 x
  findFirstBinAbove2 (ETH2D x) = findFirstBinAbove2 x
  findLastBinAbove2 (ETH2D x) = findLastBinAbove2 x
  fitSlicesX (ETH2D x) = fitSlicesX x
  fitSlicesY (ETH2D x) = fitSlicesY x
  getCorrelationFactor (ETH2D x) = getCorrelationFactor x
  getCovariance (ETH2D x) = getCovariance x
  getStats (ETH2D x) = getStats x
  integral (ETH2D x) = integral x
  interpolate (ETH2D x) = interpolate x
  kolmogorovTest (ETH2D x) = kolmogorovTest x
  rebinX (ETH2D x) = rebinX x
  rebinY (ETH2D x) = rebinY x
  rebin2D (ETH2D x) = rebin2D x
  putStats (ETH2D x) = putStats x
  reset (ETH2D x) = reset x
  setShowProjectionX (ETH2D x) = setShowProjectionX x
  setShowProjectionY (ETH2D x) = setShowProjectionY x
  showBackground (ETH2D x) = showBackground x
  showPeaks (ETH2D x) = showPeaks x
  smooth (ETH2D x) = smooth x

instance ITArrayD (Exist TH2D) where


instance ITH1 (Exist TH2D) where
  add (ETH2D x) = add x
  addBinContent (ETH2D x) = addBinContent x
  chi2Test (ETH2D x) = chi2Test x
  computeIntegral (ETH2D x) = computeIntegral x
  directoryAutoAdd (ETH2D x) = directoryAutoAdd x
  distancetoPrimitive (ETH2D x) = distancetoPrimitive x
  divide (ETH2D x) = divide x
  drawCopy (ETH2D x) a1 = return . ETH2D =<< drawCopy x a1
  drawNormalized (ETH2D x) = drawNormalized x
  drawPanel (ETH2D x) = drawPanel x
  bufferEmpty (ETH2D x) = bufferEmpty x
  eval (ETH2D x) = eval x
  executeEvent (ETH2D x) = executeEvent x
  fFT (ETH2D x) = fFT x
  fill1 (ETH2D x) = fill1 x
  fillN (ETH2D x) = fillN x
  fillRandom (ETH2D x) = fillRandom x
  findBin (ETH2D x) = findBin x
  findFixBin (ETH2D x) = findFixBin x
  findFirstBinAbove (ETH2D x) = findFirstBinAbove x
  findLastBinAbove (ETH2D x) = findLastBinAbove x
  fitPanel (ETH2D x) = fitPanel x
  getNdivisions (ETH2D x) = getNdivisions x
  getAxisColor (ETH2D x) = getAxisColor x
  getLabelColor (ETH2D x) = getLabelColor x
  getLabelFont (ETH2D x) = getLabelFont x
  getLabelOffset (ETH2D x) = getLabelOffset x
  getLabelSize (ETH2D x) = getLabelSize x
  getTitleFont (ETH2D x) = getTitleFont x
  getTitleOffset (ETH2D x) = getTitleOffset x
  getTitleSize (ETH2D x) = getTitleSize x
  getTickLength (ETH2D x) = getTickLength x
  getBarOffset (ETH2D x) = getBarOffset x
  getBarWidth (ETH2D x) = getBarWidth x
  getContour (ETH2D x) = getContour x
  getContourLevel (ETH2D x) = getContourLevel x
  getContourLevelPad (ETH2D x) = getContourLevelPad x
  getBin (ETH2D x) = getBin x
  getBinCenter (ETH2D x) = getBinCenter x
  getBinContent1 (ETH2D x) = getBinContent1 x
  getBinContent2 (ETH2D x) = getBinContent2 x
  getBinContent3 (ETH2D x) = getBinContent3 x
  getBinError1 (ETH2D x) = getBinError1 x
  getBinError2 (ETH2D x) = getBinError2 x
  getBinError3 (ETH2D x) = getBinError3 x
  getBinLowEdge (ETH2D x) = getBinLowEdge x
  getBinWidth (ETH2D x) = getBinWidth x
  getCellContent (ETH2D x) = getCellContent x
  getCellError (ETH2D x) = getCellError x
  scale (ETH2D x) = scale x
  setAxisColor (ETH2D x) = setAxisColor x
  setAxisRange (ETH2D x) = setAxisRange x
  setBarOffset (ETH2D x) = setBarOffset x
  setBarWidth (ETH2D x) = setBarWidth x
  setBinContent1 (ETH2D x) = setBinContent1 x
  setBinContent2 (ETH2D x) = setBinContent2 x
  setBinContent3 (ETH2D x) = setBinContent3 x
  setBinError1 (ETH2D x) = setBinError1 x
  setBinError2 (ETH2D x) = setBinError2 x
  setBinError3 (ETH2D x) = setBinError3 x
  setBins1 (ETH2D x) = setBins1 x
  setBins2 (ETH2D x) = setBins2 x
  setBins3 (ETH2D x) = setBins3 x
  setMaximum (ETH2D x) = setMaximum x
  setMinimum (ETH2D x) = setMinimum x
  setXTitle (ETH2D x) = setXTitle x
  setYTitle (ETH2D x) = setYTitle x
  setZTitle (ETH2D x) = setZTitle x

instance ITNamed (Exist TH2D) where
  setTitle (ETH2D x) = setTitle x

instance ITAttLine (Exist TH2D) where
  setLineColor (ETH2D x) = setLineColor x

instance ITAttFill (Exist TH2D) where
  setFillColor (ETH2D x) = setFillColor x
  setFillStyle (ETH2D x) = setFillStyle x

instance ITAttMarker (Exist TH2D) where


instance ITObject (Exist TH2D) where
  getName (ETH2D x) = getName x
  draw (ETH2D x) = draw x
  findObject (ETH2D x) = findObject x
  saveAs (ETH2D x) = saveAs x
  write (ETH2D x) = write x
  isA (ETH2D x) = isA x
  printObj (ETH2D x) = printObj x

instance IDeletable (Exist TH2D) where
  delete (ETH2D x) = delete x

instance ITArray (Exist TH2D) where


instance ITH2F (Exist TH2F) where


instance ITH2 (Exist TH2F) where
  fill2 (ETH2F x) = fill2 x
  fillRandom2 (ETH2F x) = fillRandom2 x
  findFirstBinAbove2 (ETH2F x) = findFirstBinAbove2 x
  findLastBinAbove2 (ETH2F x) = findLastBinAbove2 x
  fitSlicesX (ETH2F x) = fitSlicesX x
  fitSlicesY (ETH2F x) = fitSlicesY x
  getCorrelationFactor (ETH2F x) = getCorrelationFactor x
  getCovariance (ETH2F x) = getCovariance x
  getStats (ETH2F x) = getStats x
  integral (ETH2F x) = integral x
  interpolate (ETH2F x) = interpolate x
  kolmogorovTest (ETH2F x) = kolmogorovTest x
  rebinX (ETH2F x) = rebinX x
  rebinY (ETH2F x) = rebinY x
  rebin2D (ETH2F x) = rebin2D x
  putStats (ETH2F x) = putStats x
  reset (ETH2F x) = reset x
  setShowProjectionX (ETH2F x) = setShowProjectionX x
  setShowProjectionY (ETH2F x) = setShowProjectionY x
  showBackground (ETH2F x) = showBackground x
  showPeaks (ETH2F x) = showPeaks x
  smooth (ETH2F x) = smooth x

instance ITArrayF (Exist TH2F) where


instance ITH1 (Exist TH2F) where
  add (ETH2F x) = add x
  addBinContent (ETH2F x) = addBinContent x
  chi2Test (ETH2F x) = chi2Test x
  computeIntegral (ETH2F x) = computeIntegral x
  directoryAutoAdd (ETH2F x) = directoryAutoAdd x
  distancetoPrimitive (ETH2F x) = distancetoPrimitive x
  divide (ETH2F x) = divide x
  drawCopy (ETH2F x) a1 = return . ETH2F =<< drawCopy x a1
  drawNormalized (ETH2F x) = drawNormalized x
  drawPanel (ETH2F x) = drawPanel x
  bufferEmpty (ETH2F x) = bufferEmpty x
  eval (ETH2F x) = eval x
  executeEvent (ETH2F x) = executeEvent x
  fFT (ETH2F x) = fFT x
  fill1 (ETH2F x) = fill1 x
  fillN (ETH2F x) = fillN x
  fillRandom (ETH2F x) = fillRandom x
  findBin (ETH2F x) = findBin x
  findFixBin (ETH2F x) = findFixBin x
  findFirstBinAbove (ETH2F x) = findFirstBinAbove x
  findLastBinAbove (ETH2F x) = findLastBinAbove x
  fitPanel (ETH2F x) = fitPanel x
  getNdivisions (ETH2F x) = getNdivisions x
  getAxisColor (ETH2F x) = getAxisColor x
  getLabelColor (ETH2F x) = getLabelColor x
  getLabelFont (ETH2F x) = getLabelFont x
  getLabelOffset (ETH2F x) = getLabelOffset x
  getLabelSize (ETH2F x) = getLabelSize x
  getTitleFont (ETH2F x) = getTitleFont x
  getTitleOffset (ETH2F x) = getTitleOffset x
  getTitleSize (ETH2F x) = getTitleSize x
  getTickLength (ETH2F x) = getTickLength x
  getBarOffset (ETH2F x) = getBarOffset x
  getBarWidth (ETH2F x) = getBarWidth x
  getContour (ETH2F x) = getContour x
  getContourLevel (ETH2F x) = getContourLevel x
  getContourLevelPad (ETH2F x) = getContourLevelPad x
  getBin (ETH2F x) = getBin x
  getBinCenter (ETH2F x) = getBinCenter x
  getBinContent1 (ETH2F x) = getBinContent1 x
  getBinContent2 (ETH2F x) = getBinContent2 x
  getBinContent3 (ETH2F x) = getBinContent3 x
  getBinError1 (ETH2F x) = getBinError1 x
  getBinError2 (ETH2F x) = getBinError2 x
  getBinError3 (ETH2F x) = getBinError3 x
  getBinLowEdge (ETH2F x) = getBinLowEdge x
  getBinWidth (ETH2F x) = getBinWidth x
  getCellContent (ETH2F x) = getCellContent x
  getCellError (ETH2F x) = getCellError x
  scale (ETH2F x) = scale x
  setAxisColor (ETH2F x) = setAxisColor x
  setAxisRange (ETH2F x) = setAxisRange x
  setBarOffset (ETH2F x) = setBarOffset x
  setBarWidth (ETH2F x) = setBarWidth x
  setBinContent1 (ETH2F x) = setBinContent1 x
  setBinContent2 (ETH2F x) = setBinContent2 x
  setBinContent3 (ETH2F x) = setBinContent3 x
  setBinError1 (ETH2F x) = setBinError1 x
  setBinError2 (ETH2F x) = setBinError2 x
  setBinError3 (ETH2F x) = setBinError3 x
  setBins1 (ETH2F x) = setBins1 x
  setBins2 (ETH2F x) = setBins2 x
  setBins3 (ETH2F x) = setBins3 x
  setMaximum (ETH2F x) = setMaximum x
  setMinimum (ETH2F x) = setMinimum x
  setXTitle (ETH2F x) = setXTitle x
  setYTitle (ETH2F x) = setYTitle x
  setZTitle (ETH2F x) = setZTitle x

instance ITNamed (Exist TH2F) where
  setTitle (ETH2F x) = setTitle x

instance ITAttLine (Exist TH2F) where
  setLineColor (ETH2F x) = setLineColor x

instance ITAttFill (Exist TH2F) where
  setFillColor (ETH2F x) = setFillColor x
  setFillStyle (ETH2F x) = setFillStyle x

instance ITAttMarker (Exist TH2F) where


instance ITObject (Exist TH2F) where
  getName (ETH2F x) = getName x
  draw (ETH2F x) = draw x
  findObject (ETH2F x) = findObject x
  saveAs (ETH2F x) = saveAs x
  write (ETH2F x) = write x
  isA (ETH2F x) = isA x
  printObj (ETH2F x) = printObj x

instance IDeletable (Exist TH2F) where
  delete (ETH2F x) = delete x

instance ITArray (Exist TH2F) where


instance ITH2I (Exist TH2I) where


instance ITH2 (Exist TH2I) where
  fill2 (ETH2I x) = fill2 x
  fillRandom2 (ETH2I x) = fillRandom2 x
  findFirstBinAbove2 (ETH2I x) = findFirstBinAbove2 x
  findLastBinAbove2 (ETH2I x) = findLastBinAbove2 x
  fitSlicesX (ETH2I x) = fitSlicesX x
  fitSlicesY (ETH2I x) = fitSlicesY x
  getCorrelationFactor (ETH2I x) = getCorrelationFactor x
  getCovariance (ETH2I x) = getCovariance x
  getStats (ETH2I x) = getStats x
  integral (ETH2I x) = integral x
  interpolate (ETH2I x) = interpolate x
  kolmogorovTest (ETH2I x) = kolmogorovTest x
  rebinX (ETH2I x) = rebinX x
  rebinY (ETH2I x) = rebinY x
  rebin2D (ETH2I x) = rebin2D x
  putStats (ETH2I x) = putStats x
  reset (ETH2I x) = reset x
  setShowProjectionX (ETH2I x) = setShowProjectionX x
  setShowProjectionY (ETH2I x) = setShowProjectionY x
  showBackground (ETH2I x) = showBackground x
  showPeaks (ETH2I x) = showPeaks x
  smooth (ETH2I x) = smooth x

instance ITArrayI (Exist TH2I) where


instance ITH1 (Exist TH2I) where
  add (ETH2I x) = add x
  addBinContent (ETH2I x) = addBinContent x
  chi2Test (ETH2I x) = chi2Test x
  computeIntegral (ETH2I x) = computeIntegral x
  directoryAutoAdd (ETH2I x) = directoryAutoAdd x
  distancetoPrimitive (ETH2I x) = distancetoPrimitive x
  divide (ETH2I x) = divide x
  drawCopy (ETH2I x) a1 = return . ETH2I =<< drawCopy x a1
  drawNormalized (ETH2I x) = drawNormalized x
  drawPanel (ETH2I x) = drawPanel x
  bufferEmpty (ETH2I x) = bufferEmpty x
  eval (ETH2I x) = eval x
  executeEvent (ETH2I x) = executeEvent x
  fFT (ETH2I x) = fFT x
  fill1 (ETH2I x) = fill1 x
  fillN (ETH2I x) = fillN x
  fillRandom (ETH2I x) = fillRandom x
  findBin (ETH2I x) = findBin x
  findFixBin (ETH2I x) = findFixBin x
  findFirstBinAbove (ETH2I x) = findFirstBinAbove x
  findLastBinAbove (ETH2I x) = findLastBinAbove x
  fitPanel (ETH2I x) = fitPanel x
  getNdivisions (ETH2I x) = getNdivisions x
  getAxisColor (ETH2I x) = getAxisColor x
  getLabelColor (ETH2I x) = getLabelColor x
  getLabelFont (ETH2I x) = getLabelFont x
  getLabelOffset (ETH2I x) = getLabelOffset x
  getLabelSize (ETH2I x) = getLabelSize x
  getTitleFont (ETH2I x) = getTitleFont x
  getTitleOffset (ETH2I x) = getTitleOffset x
  getTitleSize (ETH2I x) = getTitleSize x
  getTickLength (ETH2I x) = getTickLength x
  getBarOffset (ETH2I x) = getBarOffset x
  getBarWidth (ETH2I x) = getBarWidth x
  getContour (ETH2I x) = getContour x
  getContourLevel (ETH2I x) = getContourLevel x
  getContourLevelPad (ETH2I x) = getContourLevelPad x
  getBin (ETH2I x) = getBin x
  getBinCenter (ETH2I x) = getBinCenter x
  getBinContent1 (ETH2I x) = getBinContent1 x
  getBinContent2 (ETH2I x) = getBinContent2 x
  getBinContent3 (ETH2I x) = getBinContent3 x
  getBinError1 (ETH2I x) = getBinError1 x
  getBinError2 (ETH2I x) = getBinError2 x
  getBinError3 (ETH2I x) = getBinError3 x
  getBinLowEdge (ETH2I x) = getBinLowEdge x
  getBinWidth (ETH2I x) = getBinWidth x
  getCellContent (ETH2I x) = getCellContent x
  getCellError (ETH2I x) = getCellError x
  scale (ETH2I x) = scale x
  setAxisColor (ETH2I x) = setAxisColor x
  setAxisRange (ETH2I x) = setAxisRange x
  setBarOffset (ETH2I x) = setBarOffset x
  setBarWidth (ETH2I x) = setBarWidth x
  setBinContent1 (ETH2I x) = setBinContent1 x
  setBinContent2 (ETH2I x) = setBinContent2 x
  setBinContent3 (ETH2I x) = setBinContent3 x
  setBinError1 (ETH2I x) = setBinError1 x
  setBinError2 (ETH2I x) = setBinError2 x
  setBinError3 (ETH2I x) = setBinError3 x
  setBins1 (ETH2I x) = setBins1 x
  setBins2 (ETH2I x) = setBins2 x
  setBins3 (ETH2I x) = setBins3 x
  setMaximum (ETH2I x) = setMaximum x
  setMinimum (ETH2I x) = setMinimum x
  setXTitle (ETH2I x) = setXTitle x
  setYTitle (ETH2I x) = setYTitle x
  setZTitle (ETH2I x) = setZTitle x

instance ITNamed (Exist TH2I) where
  setTitle (ETH2I x) = setTitle x

instance ITAttLine (Exist TH2I) where
  setLineColor (ETH2I x) = setLineColor x

instance ITAttFill (Exist TH2I) where
  setFillColor (ETH2I x) = setFillColor x
  setFillStyle (ETH2I x) = setFillStyle x

instance ITAttMarker (Exist TH2I) where


instance ITObject (Exist TH2I) where
  getName (ETH2I x) = getName x
  draw (ETH2I x) = draw x
  findObject (ETH2I x) = findObject x
  saveAs (ETH2I x) = saveAs x
  write (ETH2I x) = write x
  isA (ETH2I x) = isA x
  printObj (ETH2I x) = printObj x

instance IDeletable (Exist TH2I) where
  delete (ETH2I x) = delete x

instance ITArray (Exist TH2I) where


instance ITH2Poly (Exist TH2Poly) where


instance ITH2 (Exist TH2Poly) where
  fill2 (ETH2Poly x) = fill2 x
  fillRandom2 (ETH2Poly x) = fillRandom2 x
  findFirstBinAbove2 (ETH2Poly x) = findFirstBinAbove2 x
  findLastBinAbove2 (ETH2Poly x) = findLastBinAbove2 x
  fitSlicesX (ETH2Poly x) = fitSlicesX x
  fitSlicesY (ETH2Poly x) = fitSlicesY x
  getCorrelationFactor (ETH2Poly x) = getCorrelationFactor x
  getCovariance (ETH2Poly x) = getCovariance x
  getStats (ETH2Poly x) = getStats x
  integral (ETH2Poly x) = integral x
  interpolate (ETH2Poly x) = interpolate x
  kolmogorovTest (ETH2Poly x) = kolmogorovTest x
  rebinX (ETH2Poly x) = rebinX x
  rebinY (ETH2Poly x) = rebinY x
  rebin2D (ETH2Poly x) = rebin2D x
  putStats (ETH2Poly x) = putStats x
  reset (ETH2Poly x) = reset x
  setShowProjectionX (ETH2Poly x) = setShowProjectionX x
  setShowProjectionY (ETH2Poly x) = setShowProjectionY x
  showBackground (ETH2Poly x) = showBackground x
  showPeaks (ETH2Poly x) = showPeaks x
  smooth (ETH2Poly x) = smooth x

instance ITH1 (Exist TH2Poly) where
  add (ETH2Poly x) = add x
  addBinContent (ETH2Poly x) = addBinContent x
  chi2Test (ETH2Poly x) = chi2Test x
  computeIntegral (ETH2Poly x) = computeIntegral x
  directoryAutoAdd (ETH2Poly x) = directoryAutoAdd x
  distancetoPrimitive (ETH2Poly x) = distancetoPrimitive x
  divide (ETH2Poly x) = divide x
  drawCopy (ETH2Poly x) a1 = return . ETH2Poly =<< drawCopy x a1
  drawNormalized (ETH2Poly x) = drawNormalized x
  drawPanel (ETH2Poly x) = drawPanel x
  bufferEmpty (ETH2Poly x) = bufferEmpty x
  eval (ETH2Poly x) = eval x
  executeEvent (ETH2Poly x) = executeEvent x
  fFT (ETH2Poly x) = fFT x
  fill1 (ETH2Poly x) = fill1 x
  fillN (ETH2Poly x) = fillN x
  fillRandom (ETH2Poly x) = fillRandom x
  findBin (ETH2Poly x) = findBin x
  findFixBin (ETH2Poly x) = findFixBin x
  findFirstBinAbove (ETH2Poly x) = findFirstBinAbove x
  findLastBinAbove (ETH2Poly x) = findLastBinAbove x
  fitPanel (ETH2Poly x) = fitPanel x
  getNdivisions (ETH2Poly x) = getNdivisions x
  getAxisColor (ETH2Poly x) = getAxisColor x
  getLabelColor (ETH2Poly x) = getLabelColor x
  getLabelFont (ETH2Poly x) = getLabelFont x
  getLabelOffset (ETH2Poly x) = getLabelOffset x
  getLabelSize (ETH2Poly x) = getLabelSize x
  getTitleFont (ETH2Poly x) = getTitleFont x
  getTitleOffset (ETH2Poly x) = getTitleOffset x
  getTitleSize (ETH2Poly x) = getTitleSize x
  getTickLength (ETH2Poly x) = getTickLength x
  getBarOffset (ETH2Poly x) = getBarOffset x
  getBarWidth (ETH2Poly x) = getBarWidth x
  getContour (ETH2Poly x) = getContour x
  getContourLevel (ETH2Poly x) = getContourLevel x
  getContourLevelPad (ETH2Poly x) = getContourLevelPad x
  getBin (ETH2Poly x) = getBin x
  getBinCenter (ETH2Poly x) = getBinCenter x
  getBinContent1 (ETH2Poly x) = getBinContent1 x
  getBinContent2 (ETH2Poly x) = getBinContent2 x
  getBinContent3 (ETH2Poly x) = getBinContent3 x
  getBinError1 (ETH2Poly x) = getBinError1 x
  getBinError2 (ETH2Poly x) = getBinError2 x
  getBinError3 (ETH2Poly x) = getBinError3 x
  getBinLowEdge (ETH2Poly x) = getBinLowEdge x
  getBinWidth (ETH2Poly x) = getBinWidth x
  getCellContent (ETH2Poly x) = getCellContent x
  getCellError (ETH2Poly x) = getCellError x
  scale (ETH2Poly x) = scale x
  setAxisColor (ETH2Poly x) = setAxisColor x
  setAxisRange (ETH2Poly x) = setAxisRange x
  setBarOffset (ETH2Poly x) = setBarOffset x
  setBarWidth (ETH2Poly x) = setBarWidth x
  setBinContent1 (ETH2Poly x) = setBinContent1 x
  setBinContent2 (ETH2Poly x) = setBinContent2 x
  setBinContent3 (ETH2Poly x) = setBinContent3 x
  setBinError1 (ETH2Poly x) = setBinError1 x
  setBinError2 (ETH2Poly x) = setBinError2 x
  setBinError3 (ETH2Poly x) = setBinError3 x
  setBins1 (ETH2Poly x) = setBins1 x
  setBins2 (ETH2Poly x) = setBins2 x
  setBins3 (ETH2Poly x) = setBins3 x
  setMaximum (ETH2Poly x) = setMaximum x
  setMinimum (ETH2Poly x) = setMinimum x
  setXTitle (ETH2Poly x) = setXTitle x
  setYTitle (ETH2Poly x) = setYTitle x
  setZTitle (ETH2Poly x) = setZTitle x

instance ITNamed (Exist TH2Poly) where
  setTitle (ETH2Poly x) = setTitle x

instance ITAttLine (Exist TH2Poly) where
  setLineColor (ETH2Poly x) = setLineColor x

instance ITAttFill (Exist TH2Poly) where
  setFillColor (ETH2Poly x) = setFillColor x
  setFillStyle (ETH2Poly x) = setFillStyle x

instance ITAttMarker (Exist TH2Poly) where


instance ITObject (Exist TH2Poly) where
  getName (ETH2Poly x) = getName x
  draw (ETH2Poly x) = draw x
  findObject (ETH2Poly x) = findObject x
  saveAs (ETH2Poly x) = saveAs x
  write (ETH2Poly x) = write x
  isA (ETH2Poly x) = isA x
  printObj (ETH2Poly x) = printObj x

instance IDeletable (Exist TH2Poly) where
  delete (ETH2Poly x) = delete x

instance ITH2S (Exist TH2S) where


instance ITH2 (Exist TH2S) where
  fill2 (ETH2S x) = fill2 x
  fillRandom2 (ETH2S x) = fillRandom2 x
  findFirstBinAbove2 (ETH2S x) = findFirstBinAbove2 x
  findLastBinAbove2 (ETH2S x) = findLastBinAbove2 x
  fitSlicesX (ETH2S x) = fitSlicesX x
  fitSlicesY (ETH2S x) = fitSlicesY x
  getCorrelationFactor (ETH2S x) = getCorrelationFactor x
  getCovariance (ETH2S x) = getCovariance x
  getStats (ETH2S x) = getStats x
  integral (ETH2S x) = integral x
  interpolate (ETH2S x) = interpolate x
  kolmogorovTest (ETH2S x) = kolmogorovTest x
  rebinX (ETH2S x) = rebinX x
  rebinY (ETH2S x) = rebinY x
  rebin2D (ETH2S x) = rebin2D x
  putStats (ETH2S x) = putStats x
  reset (ETH2S x) = reset x
  setShowProjectionX (ETH2S x) = setShowProjectionX x
  setShowProjectionY (ETH2S x) = setShowProjectionY x
  showBackground (ETH2S x) = showBackground x
  showPeaks (ETH2S x) = showPeaks x
  smooth (ETH2S x) = smooth x

instance ITArrayS (Exist TH2S) where


instance ITH1 (Exist TH2S) where
  add (ETH2S x) = add x
  addBinContent (ETH2S x) = addBinContent x
  chi2Test (ETH2S x) = chi2Test x
  computeIntegral (ETH2S x) = computeIntegral x
  directoryAutoAdd (ETH2S x) = directoryAutoAdd x
  distancetoPrimitive (ETH2S x) = distancetoPrimitive x
  divide (ETH2S x) = divide x
  drawCopy (ETH2S x) a1 = return . ETH2S =<< drawCopy x a1
  drawNormalized (ETH2S x) = drawNormalized x
  drawPanel (ETH2S x) = drawPanel x
  bufferEmpty (ETH2S x) = bufferEmpty x
  eval (ETH2S x) = eval x
  executeEvent (ETH2S x) = executeEvent x
  fFT (ETH2S x) = fFT x
  fill1 (ETH2S x) = fill1 x
  fillN (ETH2S x) = fillN x
  fillRandom (ETH2S x) = fillRandom x
  findBin (ETH2S x) = findBin x
  findFixBin (ETH2S x) = findFixBin x
  findFirstBinAbove (ETH2S x) = findFirstBinAbove x
  findLastBinAbove (ETH2S x) = findLastBinAbove x
  fitPanel (ETH2S x) = fitPanel x
  getNdivisions (ETH2S x) = getNdivisions x
  getAxisColor (ETH2S x) = getAxisColor x
  getLabelColor (ETH2S x) = getLabelColor x
  getLabelFont (ETH2S x) = getLabelFont x
  getLabelOffset (ETH2S x) = getLabelOffset x
  getLabelSize (ETH2S x) = getLabelSize x
  getTitleFont (ETH2S x) = getTitleFont x
  getTitleOffset (ETH2S x) = getTitleOffset x
  getTitleSize (ETH2S x) = getTitleSize x
  getTickLength (ETH2S x) = getTickLength x
  getBarOffset (ETH2S x) = getBarOffset x
  getBarWidth (ETH2S x) = getBarWidth x
  getContour (ETH2S x) = getContour x
  getContourLevel (ETH2S x) = getContourLevel x
  getContourLevelPad (ETH2S x) = getContourLevelPad x
  getBin (ETH2S x) = getBin x
  getBinCenter (ETH2S x) = getBinCenter x
  getBinContent1 (ETH2S x) = getBinContent1 x
  getBinContent2 (ETH2S x) = getBinContent2 x
  getBinContent3 (ETH2S x) = getBinContent3 x
  getBinError1 (ETH2S x) = getBinError1 x
  getBinError2 (ETH2S x) = getBinError2 x
  getBinError3 (ETH2S x) = getBinError3 x
  getBinLowEdge (ETH2S x) = getBinLowEdge x
  getBinWidth (ETH2S x) = getBinWidth x
  getCellContent (ETH2S x) = getCellContent x
  getCellError (ETH2S x) = getCellError x
  scale (ETH2S x) = scale x
  setAxisColor (ETH2S x) = setAxisColor x
  setAxisRange (ETH2S x) = setAxisRange x
  setBarOffset (ETH2S x) = setBarOffset x
  setBarWidth (ETH2S x) = setBarWidth x
  setBinContent1 (ETH2S x) = setBinContent1 x
  setBinContent2 (ETH2S x) = setBinContent2 x
  setBinContent3 (ETH2S x) = setBinContent3 x
  setBinError1 (ETH2S x) = setBinError1 x
  setBinError2 (ETH2S x) = setBinError2 x
  setBinError3 (ETH2S x) = setBinError3 x
  setBins1 (ETH2S x) = setBins1 x
  setBins2 (ETH2S x) = setBins2 x
  setBins3 (ETH2S x) = setBins3 x
  setMaximum (ETH2S x) = setMaximum x
  setMinimum (ETH2S x) = setMinimum x
  setXTitle (ETH2S x) = setXTitle x
  setYTitle (ETH2S x) = setYTitle x
  setZTitle (ETH2S x) = setZTitle x

instance ITNamed (Exist TH2S) where
  setTitle (ETH2S x) = setTitle x

instance ITAttLine (Exist TH2S) where
  setLineColor (ETH2S x) = setLineColor x

instance ITAttFill (Exist TH2S) where
  setFillColor (ETH2S x) = setFillColor x
  setFillStyle (ETH2S x) = setFillStyle x

instance ITAttMarker (Exist TH2S) where


instance ITObject (Exist TH2S) where
  getName (ETH2S x) = getName x
  draw (ETH2S x) = draw x
  findObject (ETH2S x) = findObject x
  saveAs (ETH2S x) = saveAs x
  write (ETH2S x) = write x
  isA (ETH2S x) = isA x
  printObj (ETH2S x) = printObj x

instance IDeletable (Exist TH2S) where
  delete (ETH2S x) = delete x

instance ITArray (Exist TH2S) where


instance ITH3C (Exist TH3C) where


instance ITH3 (Exist TH3C) where


instance ITArrayC (Exist TH3C) where


instance ITH1 (Exist TH3C) where
  add (ETH3C x) = add x
  addBinContent (ETH3C x) = addBinContent x
  chi2Test (ETH3C x) = chi2Test x
  computeIntegral (ETH3C x) = computeIntegral x
  directoryAutoAdd (ETH3C x) = directoryAutoAdd x
  distancetoPrimitive (ETH3C x) = distancetoPrimitive x
  divide (ETH3C x) = divide x
  drawCopy (ETH3C x) a1 = return . ETH3C =<< drawCopy x a1
  drawNormalized (ETH3C x) = drawNormalized x
  drawPanel (ETH3C x) = drawPanel x
  bufferEmpty (ETH3C x) = bufferEmpty x
  eval (ETH3C x) = eval x
  executeEvent (ETH3C x) = executeEvent x
  fFT (ETH3C x) = fFT x
  fill1 (ETH3C x) = fill1 x
  fillN (ETH3C x) = fillN x
  fillRandom (ETH3C x) = fillRandom x
  findBin (ETH3C x) = findBin x
  findFixBin (ETH3C x) = findFixBin x
  findFirstBinAbove (ETH3C x) = findFirstBinAbove x
  findLastBinAbove (ETH3C x) = findLastBinAbove x
  fitPanel (ETH3C x) = fitPanel x
  getNdivisions (ETH3C x) = getNdivisions x
  getAxisColor (ETH3C x) = getAxisColor x
  getLabelColor (ETH3C x) = getLabelColor x
  getLabelFont (ETH3C x) = getLabelFont x
  getLabelOffset (ETH3C x) = getLabelOffset x
  getLabelSize (ETH3C x) = getLabelSize x
  getTitleFont (ETH3C x) = getTitleFont x
  getTitleOffset (ETH3C x) = getTitleOffset x
  getTitleSize (ETH3C x) = getTitleSize x
  getTickLength (ETH3C x) = getTickLength x
  getBarOffset (ETH3C x) = getBarOffset x
  getBarWidth (ETH3C x) = getBarWidth x
  getContour (ETH3C x) = getContour x
  getContourLevel (ETH3C x) = getContourLevel x
  getContourLevelPad (ETH3C x) = getContourLevelPad x
  getBin (ETH3C x) = getBin x
  getBinCenter (ETH3C x) = getBinCenter x
  getBinContent1 (ETH3C x) = getBinContent1 x
  getBinContent2 (ETH3C x) = getBinContent2 x
  getBinContent3 (ETH3C x) = getBinContent3 x
  getBinError1 (ETH3C x) = getBinError1 x
  getBinError2 (ETH3C x) = getBinError2 x
  getBinError3 (ETH3C x) = getBinError3 x
  getBinLowEdge (ETH3C x) = getBinLowEdge x
  getBinWidth (ETH3C x) = getBinWidth x
  getCellContent (ETH3C x) = getCellContent x
  getCellError (ETH3C x) = getCellError x
  scale (ETH3C x) = scale x
  setAxisColor (ETH3C x) = setAxisColor x
  setAxisRange (ETH3C x) = setAxisRange x
  setBarOffset (ETH3C x) = setBarOffset x
  setBarWidth (ETH3C x) = setBarWidth x
  setBinContent1 (ETH3C x) = setBinContent1 x
  setBinContent2 (ETH3C x) = setBinContent2 x
  setBinContent3 (ETH3C x) = setBinContent3 x
  setBinError1 (ETH3C x) = setBinError1 x
  setBinError2 (ETH3C x) = setBinError2 x
  setBinError3 (ETH3C x) = setBinError3 x
  setBins1 (ETH3C x) = setBins1 x
  setBins2 (ETH3C x) = setBins2 x
  setBins3 (ETH3C x) = setBins3 x
  setMaximum (ETH3C x) = setMaximum x
  setMinimum (ETH3C x) = setMinimum x
  setXTitle (ETH3C x) = setXTitle x
  setYTitle (ETH3C x) = setYTitle x
  setZTitle (ETH3C x) = setZTitle x

instance ITAtt3D (Exist TH3C) where


instance ITNamed (Exist TH3C) where
  setTitle (ETH3C x) = setTitle x

instance ITAttLine (Exist TH3C) where
  setLineColor (ETH3C x) = setLineColor x

instance ITAttFill (Exist TH3C) where
  setFillColor (ETH3C x) = setFillColor x
  setFillStyle (ETH3C x) = setFillStyle x

instance ITAttMarker (Exist TH3C) where


instance ITObject (Exist TH3C) where
  getName (ETH3C x) = getName x
  draw (ETH3C x) = draw x
  findObject (ETH3C x) = findObject x
  saveAs (ETH3C x) = saveAs x
  write (ETH3C x) = write x
  isA (ETH3C x) = isA x
  printObj (ETH3C x) = printObj x

instance IDeletable (Exist TH3C) where
  delete (ETH3C x) = delete x

instance ITArray (Exist TH3C) where


instance ITH3D (Exist TH3D) where


instance ITH3 (Exist TH3D) where


instance ITArrayD (Exist TH3D) where


instance ITH1 (Exist TH3D) where
  add (ETH3D x) = add x
  addBinContent (ETH3D x) = addBinContent x
  chi2Test (ETH3D x) = chi2Test x
  computeIntegral (ETH3D x) = computeIntegral x
  directoryAutoAdd (ETH3D x) = directoryAutoAdd x
  distancetoPrimitive (ETH3D x) = distancetoPrimitive x
  divide (ETH3D x) = divide x
  drawCopy (ETH3D x) a1 = return . ETH3D =<< drawCopy x a1
  drawNormalized (ETH3D x) = drawNormalized x
  drawPanel (ETH3D x) = drawPanel x
  bufferEmpty (ETH3D x) = bufferEmpty x
  eval (ETH3D x) = eval x
  executeEvent (ETH3D x) = executeEvent x
  fFT (ETH3D x) = fFT x
  fill1 (ETH3D x) = fill1 x
  fillN (ETH3D x) = fillN x
  fillRandom (ETH3D x) = fillRandom x
  findBin (ETH3D x) = findBin x
  findFixBin (ETH3D x) = findFixBin x
  findFirstBinAbove (ETH3D x) = findFirstBinAbove x
  findLastBinAbove (ETH3D x) = findLastBinAbove x
  fitPanel (ETH3D x) = fitPanel x
  getNdivisions (ETH3D x) = getNdivisions x
  getAxisColor (ETH3D x) = getAxisColor x
  getLabelColor (ETH3D x) = getLabelColor x
  getLabelFont (ETH3D x) = getLabelFont x
  getLabelOffset (ETH3D x) = getLabelOffset x
  getLabelSize (ETH3D x) = getLabelSize x
  getTitleFont (ETH3D x) = getTitleFont x
  getTitleOffset (ETH3D x) = getTitleOffset x
  getTitleSize (ETH3D x) = getTitleSize x
  getTickLength (ETH3D x) = getTickLength x
  getBarOffset (ETH3D x) = getBarOffset x
  getBarWidth (ETH3D x) = getBarWidth x
  getContour (ETH3D x) = getContour x
  getContourLevel (ETH3D x) = getContourLevel x
  getContourLevelPad (ETH3D x) = getContourLevelPad x
  getBin (ETH3D x) = getBin x
  getBinCenter (ETH3D x) = getBinCenter x
  getBinContent1 (ETH3D x) = getBinContent1 x
  getBinContent2 (ETH3D x) = getBinContent2 x
  getBinContent3 (ETH3D x) = getBinContent3 x
  getBinError1 (ETH3D x) = getBinError1 x
  getBinError2 (ETH3D x) = getBinError2 x
  getBinError3 (ETH3D x) = getBinError3 x
  getBinLowEdge (ETH3D x) = getBinLowEdge x
  getBinWidth (ETH3D x) = getBinWidth x
  getCellContent (ETH3D x) = getCellContent x
  getCellError (ETH3D x) = getCellError x
  scale (ETH3D x) = scale x
  setAxisColor (ETH3D x) = setAxisColor x
  setAxisRange (ETH3D x) = setAxisRange x
  setBarOffset (ETH3D x) = setBarOffset x
  setBarWidth (ETH3D x) = setBarWidth x
  setBinContent1 (ETH3D x) = setBinContent1 x
  setBinContent2 (ETH3D x) = setBinContent2 x
  setBinContent3 (ETH3D x) = setBinContent3 x
  setBinError1 (ETH3D x) = setBinError1 x
  setBinError2 (ETH3D x) = setBinError2 x
  setBinError3 (ETH3D x) = setBinError3 x
  setBins1 (ETH3D x) = setBins1 x
  setBins2 (ETH3D x) = setBins2 x
  setBins3 (ETH3D x) = setBins3 x
  setMaximum (ETH3D x) = setMaximum x
  setMinimum (ETH3D x) = setMinimum x
  setXTitle (ETH3D x) = setXTitle x
  setYTitle (ETH3D x) = setYTitle x
  setZTitle (ETH3D x) = setZTitle x

instance ITAtt3D (Exist TH3D) where


instance ITNamed (Exist TH3D) where
  setTitle (ETH3D x) = setTitle x

instance ITAttLine (Exist TH3D) where
  setLineColor (ETH3D x) = setLineColor x

instance ITAttFill (Exist TH3D) where
  setFillColor (ETH3D x) = setFillColor x
  setFillStyle (ETH3D x) = setFillStyle x

instance ITAttMarker (Exist TH3D) where


instance ITObject (Exist TH3D) where
  getName (ETH3D x) = getName x
  draw (ETH3D x) = draw x
  findObject (ETH3D x) = findObject x
  saveAs (ETH3D x) = saveAs x
  write (ETH3D x) = write x
  isA (ETH3D x) = isA x
  printObj (ETH3D x) = printObj x

instance IDeletable (Exist TH3D) where
  delete (ETH3D x) = delete x

instance ITArray (Exist TH3D) where


instance ITH3F (Exist TH3F) where


instance ITH3 (Exist TH3F) where


instance ITArrayF (Exist TH3F) where


instance ITH1 (Exist TH3F) where
  add (ETH3F x) = add x
  addBinContent (ETH3F x) = addBinContent x
  chi2Test (ETH3F x) = chi2Test x
  computeIntegral (ETH3F x) = computeIntegral x
  directoryAutoAdd (ETH3F x) = directoryAutoAdd x
  distancetoPrimitive (ETH3F x) = distancetoPrimitive x
  divide (ETH3F x) = divide x
  drawCopy (ETH3F x) a1 = return . ETH3F =<< drawCopy x a1
  drawNormalized (ETH3F x) = drawNormalized x
  drawPanel (ETH3F x) = drawPanel x
  bufferEmpty (ETH3F x) = bufferEmpty x
  eval (ETH3F x) = eval x
  executeEvent (ETH3F x) = executeEvent x
  fFT (ETH3F x) = fFT x
  fill1 (ETH3F x) = fill1 x
  fillN (ETH3F x) = fillN x
  fillRandom (ETH3F x) = fillRandom x
  findBin (ETH3F x) = findBin x
  findFixBin (ETH3F x) = findFixBin x
  findFirstBinAbove (ETH3F x) = findFirstBinAbove x
  findLastBinAbove (ETH3F x) = findLastBinAbove x
  fitPanel (ETH3F x) = fitPanel x
  getNdivisions (ETH3F x) = getNdivisions x
  getAxisColor (ETH3F x) = getAxisColor x
  getLabelColor (ETH3F x) = getLabelColor x
  getLabelFont (ETH3F x) = getLabelFont x
  getLabelOffset (ETH3F x) = getLabelOffset x
  getLabelSize (ETH3F x) = getLabelSize x
  getTitleFont (ETH3F x) = getTitleFont x
  getTitleOffset (ETH3F x) = getTitleOffset x
  getTitleSize (ETH3F x) = getTitleSize x
  getTickLength (ETH3F x) = getTickLength x
  getBarOffset (ETH3F x) = getBarOffset x
  getBarWidth (ETH3F x) = getBarWidth x
  getContour (ETH3F x) = getContour x
  getContourLevel (ETH3F x) = getContourLevel x
  getContourLevelPad (ETH3F x) = getContourLevelPad x
  getBin (ETH3F x) = getBin x
  getBinCenter (ETH3F x) = getBinCenter x
  getBinContent1 (ETH3F x) = getBinContent1 x
  getBinContent2 (ETH3F x) = getBinContent2 x
  getBinContent3 (ETH3F x) = getBinContent3 x
  getBinError1 (ETH3F x) = getBinError1 x
  getBinError2 (ETH3F x) = getBinError2 x
  getBinError3 (ETH3F x) = getBinError3 x
  getBinLowEdge (ETH3F x) = getBinLowEdge x
  getBinWidth (ETH3F x) = getBinWidth x
  getCellContent (ETH3F x) = getCellContent x
  getCellError (ETH3F x) = getCellError x
  scale (ETH3F x) = scale x
  setAxisColor (ETH3F x) = setAxisColor x
  setAxisRange (ETH3F x) = setAxisRange x
  setBarOffset (ETH3F x) = setBarOffset x
  setBarWidth (ETH3F x) = setBarWidth x
  setBinContent1 (ETH3F x) = setBinContent1 x
  setBinContent2 (ETH3F x) = setBinContent2 x
  setBinContent3 (ETH3F x) = setBinContent3 x
  setBinError1 (ETH3F x) = setBinError1 x
  setBinError2 (ETH3F x) = setBinError2 x
  setBinError3 (ETH3F x) = setBinError3 x
  setBins1 (ETH3F x) = setBins1 x
  setBins2 (ETH3F x) = setBins2 x
  setBins3 (ETH3F x) = setBins3 x
  setMaximum (ETH3F x) = setMaximum x
  setMinimum (ETH3F x) = setMinimum x
  setXTitle (ETH3F x) = setXTitle x
  setYTitle (ETH3F x) = setYTitle x
  setZTitle (ETH3F x) = setZTitle x

instance ITAtt3D (Exist TH3F) where


instance ITNamed (Exist TH3F) where
  setTitle (ETH3F x) = setTitle x

instance ITAttLine (Exist TH3F) where
  setLineColor (ETH3F x) = setLineColor x

instance ITAttFill (Exist TH3F) where
  setFillColor (ETH3F x) = setFillColor x
  setFillStyle (ETH3F x) = setFillStyle x

instance ITAttMarker (Exist TH3F) where


instance ITObject (Exist TH3F) where
  getName (ETH3F x) = getName x
  draw (ETH3F x) = draw x
  findObject (ETH3F x) = findObject x
  saveAs (ETH3F x) = saveAs x
  write (ETH3F x) = write x
  isA (ETH3F x) = isA x
  printObj (ETH3F x) = printObj x

instance IDeletable (Exist TH3F) where
  delete (ETH3F x) = delete x

instance ITArray (Exist TH3F) where


instance ITH3I (Exist TH3I) where


instance ITH3 (Exist TH3I) where


instance ITArrayI (Exist TH3I) where


instance ITH1 (Exist TH3I) where
  add (ETH3I x) = add x
  addBinContent (ETH3I x) = addBinContent x
  chi2Test (ETH3I x) = chi2Test x
  computeIntegral (ETH3I x) = computeIntegral x
  directoryAutoAdd (ETH3I x) = directoryAutoAdd x
  distancetoPrimitive (ETH3I x) = distancetoPrimitive x
  divide (ETH3I x) = divide x
  drawCopy (ETH3I x) a1 = return . ETH3I =<< drawCopy x a1
  drawNormalized (ETH3I x) = drawNormalized x
  drawPanel (ETH3I x) = drawPanel x
  bufferEmpty (ETH3I x) = bufferEmpty x
  eval (ETH3I x) = eval x
  executeEvent (ETH3I x) = executeEvent x
  fFT (ETH3I x) = fFT x
  fill1 (ETH3I x) = fill1 x
  fillN (ETH3I x) = fillN x
  fillRandom (ETH3I x) = fillRandom x
  findBin (ETH3I x) = findBin x
  findFixBin (ETH3I x) = findFixBin x
  findFirstBinAbove (ETH3I x) = findFirstBinAbove x
  findLastBinAbove (ETH3I x) = findLastBinAbove x
  fitPanel (ETH3I x) = fitPanel x
  getNdivisions (ETH3I x) = getNdivisions x
  getAxisColor (ETH3I x) = getAxisColor x
  getLabelColor (ETH3I x) = getLabelColor x
  getLabelFont (ETH3I x) = getLabelFont x
  getLabelOffset (ETH3I x) = getLabelOffset x
  getLabelSize (ETH3I x) = getLabelSize x
  getTitleFont (ETH3I x) = getTitleFont x
  getTitleOffset (ETH3I x) = getTitleOffset x
  getTitleSize (ETH3I x) = getTitleSize x
  getTickLength (ETH3I x) = getTickLength x
  getBarOffset (ETH3I x) = getBarOffset x
  getBarWidth (ETH3I x) = getBarWidth x
  getContour (ETH3I x) = getContour x
  getContourLevel (ETH3I x) = getContourLevel x
  getContourLevelPad (ETH3I x) = getContourLevelPad x
  getBin (ETH3I x) = getBin x
  getBinCenter (ETH3I x) = getBinCenter x
  getBinContent1 (ETH3I x) = getBinContent1 x
  getBinContent2 (ETH3I x) = getBinContent2 x
  getBinContent3 (ETH3I x) = getBinContent3 x
  getBinError1 (ETH3I x) = getBinError1 x
  getBinError2 (ETH3I x) = getBinError2 x
  getBinError3 (ETH3I x) = getBinError3 x
  getBinLowEdge (ETH3I x) = getBinLowEdge x
  getBinWidth (ETH3I x) = getBinWidth x
  getCellContent (ETH3I x) = getCellContent x
  getCellError (ETH3I x) = getCellError x
  scale (ETH3I x) = scale x
  setAxisColor (ETH3I x) = setAxisColor x
  setAxisRange (ETH3I x) = setAxisRange x
  setBarOffset (ETH3I x) = setBarOffset x
  setBarWidth (ETH3I x) = setBarWidth x
  setBinContent1 (ETH3I x) = setBinContent1 x
  setBinContent2 (ETH3I x) = setBinContent2 x
  setBinContent3 (ETH3I x) = setBinContent3 x
  setBinError1 (ETH3I x) = setBinError1 x
  setBinError2 (ETH3I x) = setBinError2 x
  setBinError3 (ETH3I x) = setBinError3 x
  setBins1 (ETH3I x) = setBins1 x
  setBins2 (ETH3I x) = setBins2 x
  setBins3 (ETH3I x) = setBins3 x
  setMaximum (ETH3I x) = setMaximum x
  setMinimum (ETH3I x) = setMinimum x
  setXTitle (ETH3I x) = setXTitle x
  setYTitle (ETH3I x) = setYTitle x
  setZTitle (ETH3I x) = setZTitle x

instance ITAtt3D (Exist TH3I) where


instance ITNamed (Exist TH3I) where
  setTitle (ETH3I x) = setTitle x

instance ITAttLine (Exist TH3I) where
  setLineColor (ETH3I x) = setLineColor x

instance ITAttFill (Exist TH3I) where
  setFillColor (ETH3I x) = setFillColor x
  setFillStyle (ETH3I x) = setFillStyle x

instance ITAttMarker (Exist TH3I) where


instance ITObject (Exist TH3I) where
  getName (ETH3I x) = getName x
  draw (ETH3I x) = draw x
  findObject (ETH3I x) = findObject x
  saveAs (ETH3I x) = saveAs x
  write (ETH3I x) = write x
  isA (ETH3I x) = isA x
  printObj (ETH3I x) = printObj x

instance IDeletable (Exist TH3I) where
  delete (ETH3I x) = delete x

instance ITArray (Exist TH3I) where


instance ITH3S (Exist TH3S) where


instance ITH3 (Exist TH3S) where


instance ITArrayS (Exist TH3S) where


instance ITH1 (Exist TH3S) where
  add (ETH3S x) = add x
  addBinContent (ETH3S x) = addBinContent x
  chi2Test (ETH3S x) = chi2Test x
  computeIntegral (ETH3S x) = computeIntegral x
  directoryAutoAdd (ETH3S x) = directoryAutoAdd x
  distancetoPrimitive (ETH3S x) = distancetoPrimitive x
  divide (ETH3S x) = divide x
  drawCopy (ETH3S x) a1 = return . ETH3S =<< drawCopy x a1
  drawNormalized (ETH3S x) = drawNormalized x
  drawPanel (ETH3S x) = drawPanel x
  bufferEmpty (ETH3S x) = bufferEmpty x
  eval (ETH3S x) = eval x
  executeEvent (ETH3S x) = executeEvent x
  fFT (ETH3S x) = fFT x
  fill1 (ETH3S x) = fill1 x
  fillN (ETH3S x) = fillN x
  fillRandom (ETH3S x) = fillRandom x
  findBin (ETH3S x) = findBin x
  findFixBin (ETH3S x) = findFixBin x
  findFirstBinAbove (ETH3S x) = findFirstBinAbove x
  findLastBinAbove (ETH3S x) = findLastBinAbove x
  fitPanel (ETH3S x) = fitPanel x
  getNdivisions (ETH3S x) = getNdivisions x
  getAxisColor (ETH3S x) = getAxisColor x
  getLabelColor (ETH3S x) = getLabelColor x
  getLabelFont (ETH3S x) = getLabelFont x
  getLabelOffset (ETH3S x) = getLabelOffset x
  getLabelSize (ETH3S x) = getLabelSize x
  getTitleFont (ETH3S x) = getTitleFont x
  getTitleOffset (ETH3S x) = getTitleOffset x
  getTitleSize (ETH3S x) = getTitleSize x
  getTickLength (ETH3S x) = getTickLength x
  getBarOffset (ETH3S x) = getBarOffset x
  getBarWidth (ETH3S x) = getBarWidth x
  getContour (ETH3S x) = getContour x
  getContourLevel (ETH3S x) = getContourLevel x
  getContourLevelPad (ETH3S x) = getContourLevelPad x
  getBin (ETH3S x) = getBin x
  getBinCenter (ETH3S x) = getBinCenter x
  getBinContent1 (ETH3S x) = getBinContent1 x
  getBinContent2 (ETH3S x) = getBinContent2 x
  getBinContent3 (ETH3S x) = getBinContent3 x
  getBinError1 (ETH3S x) = getBinError1 x
  getBinError2 (ETH3S x) = getBinError2 x
  getBinError3 (ETH3S x) = getBinError3 x
  getBinLowEdge (ETH3S x) = getBinLowEdge x
  getBinWidth (ETH3S x) = getBinWidth x
  getCellContent (ETH3S x) = getCellContent x
  getCellError (ETH3S x) = getCellError x
  scale (ETH3S x) = scale x
  setAxisColor (ETH3S x) = setAxisColor x
  setAxisRange (ETH3S x) = setAxisRange x
  setBarOffset (ETH3S x) = setBarOffset x
  setBarWidth (ETH3S x) = setBarWidth x
  setBinContent1 (ETH3S x) = setBinContent1 x
  setBinContent2 (ETH3S x) = setBinContent2 x
  setBinContent3 (ETH3S x) = setBinContent3 x
  setBinError1 (ETH3S x) = setBinError1 x
  setBinError2 (ETH3S x) = setBinError2 x
  setBinError3 (ETH3S x) = setBinError3 x
  setBins1 (ETH3S x) = setBins1 x
  setBins2 (ETH3S x) = setBins2 x
  setBins3 (ETH3S x) = setBins3 x
  setMaximum (ETH3S x) = setMaximum x
  setMinimum (ETH3S x) = setMinimum x
  setXTitle (ETH3S x) = setXTitle x
  setYTitle (ETH3S x) = setYTitle x
  setZTitle (ETH3S x) = setZTitle x

instance ITAtt3D (Exist TH3S) where


instance ITNamed (Exist TH3S) where
  setTitle (ETH3S x) = setTitle x

instance ITAttLine (Exist TH3S) where
  setLineColor (ETH3S x) = setLineColor x

instance ITAttFill (Exist TH3S) where
  setFillColor (ETH3S x) = setFillColor x
  setFillStyle (ETH3S x) = setFillStyle x

instance ITAttMarker (Exist TH3S) where


instance ITObject (Exist TH3S) where
  getName (ETH3S x) = getName x
  draw (ETH3S x) = draw x
  findObject (ETH3S x) = findObject x
  saveAs (ETH3S x) = saveAs x
  write (ETH3S x) = write x
  isA (ETH3S x) = isA x
  printObj (ETH3S x) = printObj x

instance IDeletable (Exist TH3S) where
  delete (ETH3S x) = delete x

instance ITArray (Exist TH3S) where


instance ITQObject (Exist TQObject) where


instance IDeletable (Exist TQObject) where
  delete (ETQObject x) = delete x

instance ITVirtualPad (Exist TVirtualPad) where
  getFrame (ETVirtualPad x) = getFrame x
  range (ETVirtualPad x) = range x

instance ITObject (Exist TVirtualPad) where
  getName (ETVirtualPad x) = getName x
  draw (ETVirtualPad x) = draw x
  findObject (ETVirtualPad x) = findObject x
  saveAs (ETVirtualPad x) = saveAs x
  write (ETVirtualPad x) = write x
  isA (ETVirtualPad x) = isA x
  printObj (ETVirtualPad x) = printObj x

instance ITAttLine (Exist TVirtualPad) where
  setLineColor (ETVirtualPad x) = setLineColor x

instance ITAttFill (Exist TVirtualPad) where
  setFillColor (ETVirtualPad x) = setFillColor x
  setFillStyle (ETVirtualPad x) = setFillStyle x

instance ITAttPad (Exist TVirtualPad) where


instance ITQObject (Exist TVirtualPad) where


instance IDeletable (Exist TVirtualPad) where
  delete (ETVirtualPad x) = delete x

instance ITPad (Exist TPad) where


instance ITVirtualPad (Exist TPad) where
  getFrame (ETPad x) = getFrame x
  range (ETPad x) = range x

instance ITObject (Exist TPad) where
  getName (ETPad x) = getName x
  draw (ETPad x) = draw x
  findObject (ETPad x) = findObject x
  saveAs (ETPad x) = saveAs x
  write (ETPad x) = write x
  isA (ETPad x) = isA x
  printObj (ETPad x) = printObj x

instance ITAttLine (Exist TPad) where
  setLineColor (ETPad x) = setLineColor x

instance ITAttFill (Exist TPad) where
  setFillColor (ETPad x) = setFillColor x
  setFillStyle (ETPad x) = setFillStyle x

instance ITAttPad (Exist TPad) where


instance ITQObject (Exist TPad) where


instance IDeletable (Exist TPad) where
  delete (ETPad x) = delete x

instance ITButton (Exist TButton) where


instance ITPad (Exist TButton) where


instance ITAttText (Exist TButton) where
  setTextColor (ETButton x) = setTextColor x
  setTextAlign (ETButton x) = setTextAlign x
  setTextSize (ETButton x) = setTextSize x

instance ITVirtualPad (Exist TButton) where
  getFrame (ETButton x) = getFrame x
  range (ETButton x) = range x

instance ITObject (Exist TButton) where
  getName (ETButton x) = getName x
  draw (ETButton x) = draw x
  findObject (ETButton x) = findObject x
  saveAs (ETButton x) = saveAs x
  write (ETButton x) = write x
  isA (ETButton x) = isA x
  printObj (ETButton x) = printObj x

instance ITAttLine (Exist TButton) where
  setLineColor (ETButton x) = setLineColor x

instance ITAttFill (Exist TButton) where
  setFillColor (ETButton x) = setFillColor x
  setFillStyle (ETButton x) = setFillStyle x

instance ITAttPad (Exist TButton) where


instance ITQObject (Exist TButton) where


instance IDeletable (Exist TButton) where
  delete (ETButton x) = delete x

instance ITGroupButton (Exist TGroupButton) where


instance ITButton (Exist TGroupButton) where


instance ITPad (Exist TGroupButton) where


instance ITAttText (Exist TGroupButton) where
  setTextColor (ETGroupButton x) = setTextColor x
  setTextAlign (ETGroupButton x) = setTextAlign x
  setTextSize (ETGroupButton x) = setTextSize x

instance ITVirtualPad (Exist TGroupButton) where
  getFrame (ETGroupButton x) = getFrame x
  range (ETGroupButton x) = range x

instance ITObject (Exist TGroupButton) where
  getName (ETGroupButton x) = getName x
  draw (ETGroupButton x) = draw x
  findObject (ETGroupButton x) = findObject x
  saveAs (ETGroupButton x) = saveAs x
  write (ETGroupButton x) = write x
  isA (ETGroupButton x) = isA x
  printObj (ETGroupButton x) = printObj x

instance ITAttLine (Exist TGroupButton) where
  setLineColor (ETGroupButton x) = setLineColor x

instance ITAttFill (Exist TGroupButton) where
  setFillColor (ETGroupButton x) = setFillColor x
  setFillStyle (ETGroupButton x) = setFillStyle x

instance ITAttPad (Exist TGroupButton) where


instance ITQObject (Exist TGroupButton) where


instance IDeletable (Exist TGroupButton) where
  delete (ETGroupButton x) = delete x

instance ITCanvas (Exist TCanvas) where


instance ITPad (Exist TCanvas) where


instance ITVirtualPad (Exist TCanvas) where
  getFrame (ETCanvas x) = getFrame x
  range (ETCanvas x) = range x

instance ITObject (Exist TCanvas) where
  getName (ETCanvas x) = getName x
  draw (ETCanvas x) = draw x
  findObject (ETCanvas x) = findObject x
  saveAs (ETCanvas x) = saveAs x
  write (ETCanvas x) = write x
  isA (ETCanvas x) = isA x
  printObj (ETCanvas x) = printObj x

instance ITAttLine (Exist TCanvas) where
  setLineColor (ETCanvas x) = setLineColor x

instance ITAttFill (Exist TCanvas) where
  setFillColor (ETCanvas x) = setFillColor x
  setFillStyle (ETCanvas x) = setFillStyle x

instance ITAttPad (Exist TCanvas) where


instance ITQObject (Exist TCanvas) where


instance IDeletable (Exist TCanvas) where
  delete (ETCanvas x) = delete x

instance ITDialogCanvas (Exist TDialogCanvas) where


instance ITCanvas (Exist TDialogCanvas) where


instance ITAttText (Exist TDialogCanvas) where
  setTextColor (ETDialogCanvas x) = setTextColor x
  setTextAlign (ETDialogCanvas x) = setTextAlign x
  setTextSize (ETDialogCanvas x) = setTextSize x

instance ITPad (Exist TDialogCanvas) where


instance ITVirtualPad (Exist TDialogCanvas) where
  getFrame (ETDialogCanvas x) = getFrame x
  range (ETDialogCanvas x) = range x

instance ITObject (Exist TDialogCanvas) where
  getName (ETDialogCanvas x) = getName x
  draw (ETDialogCanvas x) = draw x
  findObject (ETDialogCanvas x) = findObject x
  saveAs (ETDialogCanvas x) = saveAs x
  write (ETDialogCanvas x) = write x
  isA (ETDialogCanvas x) = isA x
  printObj (ETDialogCanvas x) = printObj x

instance ITAttLine (Exist TDialogCanvas) where
  setLineColor (ETDialogCanvas x) = setLineColor x

instance ITAttFill (Exist TDialogCanvas) where
  setFillColor (ETDialogCanvas x) = setFillColor x
  setFillStyle (ETDialogCanvas x) = setFillStyle x

instance ITAttPad (Exist TDialogCanvas) where


instance ITQObject (Exist TDialogCanvas) where


instance IDeletable (Exist TDialogCanvas) where
  delete (ETDialogCanvas x) = delete x

instance ITInspectCanvas (Exist TInspectCanvas) where


instance ITCanvas (Exist TInspectCanvas) where


instance ITAttText (Exist TInspectCanvas) where
  setTextColor (ETInspectCanvas x) = setTextColor x
  setTextAlign (ETInspectCanvas x) = setTextAlign x
  setTextSize (ETInspectCanvas x) = setTextSize x

instance ITPad (Exist TInspectCanvas) where


instance ITVirtualPad (Exist TInspectCanvas) where
  getFrame (ETInspectCanvas x) = getFrame x
  range (ETInspectCanvas x) = range x

instance ITObject (Exist TInspectCanvas) where
  getName (ETInspectCanvas x) = getName x
  draw (ETInspectCanvas x) = draw x
  findObject (ETInspectCanvas x) = findObject x
  saveAs (ETInspectCanvas x) = saveAs x
  write (ETInspectCanvas x) = write x
  isA (ETInspectCanvas x) = isA x
  printObj (ETInspectCanvas x) = printObj x

instance ITAttLine (Exist TInspectCanvas) where
  setLineColor (ETInspectCanvas x) = setLineColor x

instance ITAttFill (Exist TInspectCanvas) where
  setFillColor (ETInspectCanvas x) = setFillColor x
  setFillStyle (ETInspectCanvas x) = setFillStyle x

instance ITAttPad (Exist TInspectCanvas) where


instance ITQObject (Exist TInspectCanvas) where


instance IDeletable (Exist TInspectCanvas) where
  delete (ETInspectCanvas x) = delete x

instance ITEvePad (Exist TEvePad) where


instance ITPad (Exist TEvePad) where


instance ITVirtualPad (Exist TEvePad) where
  getFrame (ETEvePad x) = getFrame x
  range (ETEvePad x) = range x

instance ITObject (Exist TEvePad) where
  getName (ETEvePad x) = getName x
  draw (ETEvePad x) = draw x
  findObject (ETEvePad x) = findObject x
  saveAs (ETEvePad x) = saveAs x
  write (ETEvePad x) = write x
  isA (ETEvePad x) = isA x
  printObj (ETEvePad x) = printObj x

instance ITAttLine (Exist TEvePad) where
  setLineColor (ETEvePad x) = setLineColor x

instance ITAttFill (Exist TEvePad) where
  setFillColor (ETEvePad x) = setFillColor x
  setFillStyle (ETEvePad x) = setFillStyle x

instance ITAttPad (Exist TEvePad) where


instance ITQObject (Exist TEvePad) where


instance IDeletable (Exist TEvePad) where
  delete (ETEvePad x) = delete x

instance ITSlider (Exist TSlider) where


instance ITPad (Exist TSlider) where


instance ITVirtualPad (Exist TSlider) where
  getFrame (ETSlider x) = getFrame x
  range (ETSlider x) = range x

instance ITObject (Exist TSlider) where
  getName (ETSlider x) = getName x
  draw (ETSlider x) = draw x
  findObject (ETSlider x) = findObject x
  saveAs (ETSlider x) = saveAs x
  write (ETSlider x) = write x
  isA (ETSlider x) = isA x
  printObj (ETSlider x) = printObj x

instance ITAttLine (Exist TSlider) where
  setLineColor (ETSlider x) = setLineColor x

instance ITAttFill (Exist TSlider) where
  setFillColor (ETSlider x) = setFillColor x
  setFillStyle (ETSlider x) = setFillStyle x

instance ITAttPad (Exist TSlider) where


instance ITQObject (Exist TSlider) where


instance IDeletable (Exist TSlider) where
  delete (ETSlider x) = delete x

instance ITApplication (Exist TApplication) where
  run (ETApplication x) = run x

instance ITObject (Exist TApplication) where
  getName (ETApplication x) = getName x
  draw (ETApplication x) = draw x
  findObject (ETApplication x) = findObject x
  saveAs (ETApplication x) = saveAs x
  write (ETApplication x) = write x
  isA (ETApplication x) = isA x
  printObj (ETApplication x) = printObj x

instance ITQObject (Exist TApplication) where


instance IDeletable (Exist TApplication) where
  delete (ETApplication x) = delete x

instance ITRint (Exist TRint) where


instance ITApplication (Exist TRint) where
  run (ETRint x) = run x

instance ITObject (Exist TRint) where
  getName (ETRint x) = getName x
  draw (ETRint x) = draw x
  findObject (ETRint x) = findObject x
  saveAs (ETRint x) = saveAs x
  write (ETRint x) = write x
  isA (ETRint x) = isA x
  printObj (ETRint x) = printObj x

instance ITQObject (Exist TRint) where


instance IDeletable (Exist TRint) where
  delete (ETRint x) = delete x

instance ITRandom (Exist TRandom) where
  gaus (ETRandom x) = gaus x
  uniform (ETRandom x) = uniform x

instance ITNamed (Exist TRandom) where
  setTitle (ETRandom x) = setTitle x

instance ITObject (Exist TRandom) where
  getName (ETRandom x) = getName x
  draw (ETRandom x) = draw x
  findObject (ETRandom x) = findObject x
  saveAs (ETRandom x) = saveAs x
  write (ETRandom x) = write x
  isA (ETRandom x) = isA x
  printObj (ETRandom x) = printObj x

instance IDeletable (Exist TRandom) where
  delete (ETRandom x) = delete x

instance ITCollection (Exist TCollection) where


instance ITObject (Exist TCollection) where
  getName (ETCollection x) = getName x
  draw (ETCollection x) = draw x
  findObject (ETCollection x) = findObject x
  saveAs (ETCollection x) = saveAs x
  write (ETCollection x) = write x
  isA (ETCollection x) = isA x
  printObj (ETCollection x) = printObj x

instance IDeletable (Exist TCollection) where
  delete (ETCollection x) = delete x

instance ITSeqCollection (Exist TSeqCollection) where


instance ITCollection (Exist TSeqCollection) where


instance ITObject (Exist TSeqCollection) where
  getName (ETSeqCollection x) = getName x
  draw (ETSeqCollection x) = draw x
  findObject (ETSeqCollection x) = findObject x
  saveAs (ETSeqCollection x) = saveAs x
  write (ETSeqCollection x) = write x
  isA (ETSeqCollection x) = isA x
  printObj (ETSeqCollection x) = printObj x

instance IDeletable (Exist TSeqCollection) where
  delete (ETSeqCollection x) = delete x

instance ITObjArray (Exist TObjArray) where


instance ITSeqCollection (Exist TObjArray) where


instance ITCollection (Exist TObjArray) where


instance ITObject (Exist TObjArray) where
  getName (ETObjArray x) = getName x
  draw (ETObjArray x) = draw x
  findObject (ETObjArray x) = findObject x
  saveAs (ETObjArray x) = saveAs x
  write (ETObjArray x) = write x
  isA (ETObjArray x) = isA x
  printObj (ETObjArray x) = printObj x

instance IDeletable (Exist TObjArray) where
  delete (ETObjArray x) = delete x

instance ITList (Exist TList) where


instance ITSeqCollection (Exist TList) where


instance ITCollection (Exist TList) where


instance ITObject (Exist TList) where
  getName (ETList x) = getName x
  draw (ETList x) = draw x
  findObject (ETList x) = findObject x
  saveAs (ETList x) = saveAs x
  write (ETList x) = write x
  isA (ETList x) = isA x
  printObj (ETList x) = printObj x

instance IDeletable (Exist TList) where
  delete (ETList x) = delete x

instance ITKey (Exist TKey) where


instance ITNamed (Exist TKey) where
  setTitle (ETKey x) = setTitle x

instance ITObject (Exist TKey) where
  getName (ETKey x) = getName x
  draw (ETKey x) = draw x
  findObject (ETKey x) = findObject x
  saveAs (ETKey x) = saveAs x
  write (ETKey x) = write x
  isA (ETKey x) = isA x
  printObj (ETKey x) = printObj x

instance IDeletable (Exist TKey) where
  delete (ETKey x) = delete x

instance ITDatime (Exist TDatime) where
  convert (ETDatime x) = convert x

instance IDeletable (Exist TDatime) where
  delete (ETDatime x) = delete x



instance ITObject TObject where
  getName = xform0 c_tobject_getname
  draw = xform1 c_tobject_draw
  findObject = xform1 c_tobject_findobject
  saveAs = xform2 c_tobject_saveas
  write = xform3 c_tobject_write
  isA = xform0 c_tobject_isa
  printObj = xform1 c_tobject_printobj

instance ITNamed TNamed where
  setTitle = xform1 c_tnamed_settitle



instance ITClass TClass where

instance ITFormula TFormula where
  getParameter = xform1 c_tformula_getparameter
  setParameter = xform2 c_tformula_setparameter

instance ITAtt3D TAtt3D where

instance ITAttAxis TAttAxis where
  setLabelColor = xform1 c_tattaxis_setlabelcolor
  setLabelSize = xform1 c_tattaxis_setlabelsize
  setTickLength = xform1 c_tattaxis_setticklength
  setTitleOffset = xform1 c_tattaxis_settitleoffset
  setNdivisions = xform2 c_tattaxis_setndivisions

instance ITAttBBox TAttBBox where

instance ITAttCanvas TAttCanvas where

instance ITAttFill TAttFill where
  setFillColor = xform1 c_tattfill_setfillcolor
  setFillStyle = xform1 c_tattfill_setfillstyle

instance ITAttImage TAttImage where

instance ITAttLine TAttLine where
  setLineColor = xform1 c_tattline_setlinecolor

instance ITAttMarker TAttMarker where

instance ITAttPad TAttPad where

instance ITAttParticle TAttParticle where

instance ITAttText TAttText where
  setTextColor = xform1 c_tatttext_settextcolor
  setTextAlign = xform1 c_tatttext_settextalign
  setTextSize = xform1 c_tatttext_settextsize

instance ITHStack THStack where

instance ITF1 TF1 where

instance ITGraph TGraph where

instance ITGraphAsymmErrors TGraphAsymmErrors where

instance ITCutG TCutG where

instance ITGraphBentErrors TGraphBentErrors where

instance ITGraphErrors TGraphErrors where

instance ITGraphPolar TGraphPolar where

instance ITGraphQQ TGraphQQ where

instance ITEllipse TEllipse where

instance ITArc TArc where

instance ITCrown TCrown where

instance ITLine TLine where

instance ITArrow TArrow where

instance ITGaxis TGaxis where

instance ITShape TShape where

instance ITBRIK TBRIK where

instance ITTUBE TTUBE where

instance ITPCON TPCON where

instance ITSPHE TSPHE where

instance ITXTRU TXTRU where

instance ITBox TBox where

instance ITPave TPave where

instance ITPaveText TPaveText where

instance ITDiamond TDiamond where

instance ITPaveStats TPaveStats where

instance ITPavesText TPavesText where

instance ITLegend TLegend where
  addEntry = xform3 c_tlegend_addentry

instance ITLegendEntry TLegendEntry where

instance ITPaveLabel TPaveLabel where

instance ITPaveClass TPaveClass where

instance ITWbox TWbox where
  setBorderMode = xform1 c_twbox_setbordermode

instance ITFrame TFrame where

instance ITSliderBox TSliderBox where

instance ITTree TTree where

instance ITChain TChain where

instance ITNtuple TNtuple where

instance ITNtupleD TNtupleD where

instance ITTreeSQL TTreeSQL where

instance ITPolyLine TPolyLine where

instance ITCurlyLine TCurlyLine where

instance ITCurlyArc TCurlyArc where

instance ITEfficiency TEfficiency where

instance ITAxis TAxis where
  setTimeDisplay = xform1 c_taxis_settimedisplay
  setTimeFormat = xform1 c_taxis_settimeformat
  setTimeOffset = xform2 c_taxis_settimeoffset

instance ITLatex TLatex where

instance ITText TText where

instance ITDirectory TDirectory where
  append = xform2 c_tdirectory_append
  addD = xform2 c_tdirectory_addd
  appendKey = xform1 c_tdirectory_appendkey
  close = xform1 c_tdirectory_close
  get = xform1 c_tdirectory_get

instance ITDirectoryFile TDirectoryFile where
  getListOfKeys = xform0 c_tdirectoryfile_getlistofkeys

instance ITFile TFile where

instance ITBranch TBranch where

instance ITVirtualTreePlayer TVirtualTreePlayer where

instance ITTreePlayer TTreePlayer where

instance ITArray TArray where

instance ITArrayC TArrayC where

instance ITArrayD TArrayD where

instance ITArrayF TArrayF where

instance ITArrayI TArrayI where

instance ITArrayL TArrayL where

instance ITArrayL64 TArrayL64 where

instance ITArrayS TArrayS where

instance ITH1 TH1 where
  add = xform2 c_th1_add
  addBinContent = xform2 c_th1_addbincontent
  chi2Test = xform3 c_th1_chi2test
  computeIntegral = xform0 c_th1_computeintegral
  directoryAutoAdd = xform1 c_th1_directoryautoadd
  distancetoPrimitive = xform2 c_th1_distancetoprimitive
  divide = xform5 c_th1_divide
  drawCopy = xform1 c_th1_drawcopy
  drawNormalized = xform2 c_th1_drawnormalized
  drawPanel = xform0 c_th1_drawpanel
  bufferEmpty = xform1 c_th1_bufferempty
  eval = xform2 c_th1_eval
  executeEvent = xform3 c_th1_executeevent
  fFT = xform2 c_th1_fft
  fill1 = xform1 c_th1_fill1
  fillN = xform4 c_th1_filln
  fillRandom = xform2 c_th1_fillrandom
  findBin = xform3 c_th1_findbin
  findFixBin = xform3 c_th1_findfixbin
  findFirstBinAbove = xform2 c_th1_findfirstbinabove
  findLastBinAbove = xform2 c_th1_findlastbinabove
  fitPanel = xform0 c_th1_fitpanel
  getNdivisions = xform1 c_th1_getndivisions
  getAxisColor = xform1 c_th1_getaxiscolor
  getLabelColor = xform1 c_th1_getlabelcolor
  getLabelFont = xform1 c_th1_getlabelfont
  getLabelOffset = xform1 c_th1_getlabeloffset
  getLabelSize = xform1 c_th1_getlabelsize
  getTitleFont = xform1 c_th1_gettitlefont
  getTitleOffset = xform1 c_th1_gettitleoffset
  getTitleSize = xform1 c_th1_gettitlesize
  getTickLength = xform1 c_th1_getticklength
  getBarOffset = xform0 c_th1_getbaroffset
  getBarWidth = xform0 c_th1_getbarwidth
  getContour = xform1 c_th1_getcontour
  getContourLevel = xform1 c_th1_getcontourlevel
  getContourLevelPad = xform1 c_th1_getcontourlevelpad
  getBin = xform3 c_th1_getbin
  getBinCenter = xform1 c_th1_getbincenter
  getBinContent1 = xform1 c_th1_getbincontent1
  getBinContent2 = xform2 c_th1_getbincontent2
  getBinContent3 = xform3 c_th1_getbincontent3
  getBinError1 = xform1 c_th1_getbinerror1
  getBinError2 = xform2 c_th1_getbinerror2
  getBinError3 = xform3 c_th1_getbinerror3
  getBinLowEdge = xform1 c_th1_getbinlowedge
  getBinWidth = xform1 c_th1_getbinwidth
  getCellContent = xform2 c_th1_getcellcontent
  getCellError = xform2 c_th1_getcellerror
  scale = xform2 c_th1_scale
  setAxisColor = xform2 c_th1_setaxiscolor
  setAxisRange = xform3 c_th1_setaxisrange
  setBarOffset = xform1 c_th1_setbaroffset
  setBarWidth = xform1 c_th1_setbarwidth
  setBinContent1 = xform2 c_th1_setbincontent1
  setBinContent2 = xform3 c_th1_setbincontent2
  setBinContent3 = xform4 c_th1_setbincontent3
  setBinError1 = xform2 c_th1_setbinerror1
  setBinError2 = xform3 c_th1_setbinerror2
  setBinError3 = xform4 c_th1_setbinerror3
  setBins1 = xform2 c_th1_setbins1
  setBins2 = xform4 c_th1_setbins2
  setBins3 = xform6 c_th1_setbins3
  setMaximum = xform1 c_th1_setmaximum
  setMinimum = xform1 c_th1_setminimum
  setXTitle = xform1 c_th1_setxtitle
  setYTitle = xform1 c_th1_setytitle
  setZTitle = xform1 c_th1_setztitle

instance ITH2 TH2 where
  fill2 = xform2 c_th2_fill2
  fillRandom2 = xform2 c_th2_fillrandom2
  findFirstBinAbove2 = xform2 c_th2_findfirstbinabove2
  findLastBinAbove2 = xform2 c_th2_findlastbinabove2
  fitSlicesX = xform6 c_th2_fitslicesx
  fitSlicesY = xform6 c_th2_fitslicesy
  getCorrelationFactor = xform2 c_th2_getcorrelationfactor
  getCovariance = xform2 c_th2_getcovariance
  getStats = xform1 c_th2_getstats
  integral = xform5 c_th2_integral
  interpolate = xform3 c_th2_interpolate
  kolmogorovTest = xform2 c_th2_kolmogorovtest
  rebinX = xform2 c_th2_rebinx
  rebinY = xform2 c_th2_rebiny
  rebin2D = xform3 c_th2_rebin2d
  putStats = xform1 c_th2_putstats
  reset = xform1 c_th2_reset
  setShowProjectionX = xform1 c_th2_setshowprojectionx
  setShowProjectionY = xform1 c_th2_setshowprojectiony
  showBackground = xform2 c_th2_showbackground
  showPeaks = xform3 c_th2_showpeaks
  smooth = xform2 c_th2_smooth

instance ITH3 TH3 where

instance ITH1C TH1C where

instance ITH1D TH1D where

instance ITH1F TH1F where

instance ITH1I TH1I where

instance ITH1S TH1S where

instance ITH2C TH2C where

instance ITH2D TH2D where

instance ITH2F TH2F where

instance ITH2I TH2I where

instance ITH2Poly TH2Poly where

instance ITH2S TH2S where

instance ITH3C TH3C where

instance ITH3D TH3D where

instance ITH3F TH3F where

instance ITH3I TH3I where

instance ITH3S TH3S where

instance ITQObject TQObject where

instance ITVirtualPad TVirtualPad where
  getFrame = xform0 c_tvirtualpad_getframe
  range = xform4 c_tvirtualpad_range

instance ITPad TPad where

instance ITButton TButton where

instance ITGroupButton TGroupButton where

instance ITCanvas TCanvas where

instance ITDialogCanvas TDialogCanvas where

instance ITInspectCanvas TInspectCanvas where

instance ITEvePad TEvePad where

instance ITSlider TSlider where

instance ITApplication TApplication where
  run = xform1 c_tapplication_run

instance ITRint TRint where

instance ITRandom TRandom where
  gaus = xform2 c_trandom_gaus
  uniform = xform2 c_trandom_uniform

instance ITCollection TCollection where

instance ITSeqCollection TSeqCollection where

instance ITObjArray TObjArray where

instance ITList TList where

instance ITKey TKey where

instance ITDatime TDatime where
  convert = xform1 c_tdatime_convert

instance IDeletable TDatime where
  delete = xform0 c_tdatime_delete

instance IDeletable TKey where
  delete = xform0 c_tkey_delete

instance IDeletable TList where
  delete = xform0 c_tlist_delete

instance IDeletable TObjArray where
  delete = xform0 c_tobjarray_delete

instance IDeletable TSeqCollection where
  delete = xform0 c_tseqcollection_delete

instance IDeletable TCollection where
  delete = xform0 c_tcollection_delete

instance IDeletable TRandom where
  delete = xform0 c_trandom_delete

instance IDeletable TRint where
  delete = xform0 c_trint_delete

instance IDeletable TApplication where
  delete = xform0 c_tapplication_delete

instance IDeletable TSlider where
  delete = xform0 c_tslider_delete

instance IDeletable TEvePad where
  delete = xform0 c_tevepad_delete

instance IDeletable TInspectCanvas where
  delete = xform0 c_tinspectcanvas_delete

instance IDeletable TDialogCanvas where
  delete = xform0 c_tdialogcanvas_delete

instance IDeletable TCanvas where
  delete = xform0 c_tcanvas_delete

instance IDeletable TGroupButton where
  delete = xform0 c_tgroupbutton_delete

instance IDeletable TButton where
  delete = xform0 c_tbutton_delete

instance IDeletable TPad where
  delete = xform0 c_tpad_delete

instance IDeletable TVirtualPad where
  delete = xform0 c_tvirtualpad_delete

instance IDeletable TQObject where
  delete = xform0 c_tqobject_delete

instance IDeletable TH3S where
  delete = xform0 c_th3s_delete

instance IDeletable TH3I where
  delete = xform0 c_th3i_delete

instance IDeletable TH3F where
  delete = xform0 c_th3f_delete

instance IDeletable TH3D where
  delete = xform0 c_th3d_delete

instance IDeletable TH3C where
  delete = xform0 c_th3c_delete

instance IDeletable TH2S where
  delete = xform0 c_th2s_delete

instance IDeletable TH2Poly where
  delete = xform0 c_th2poly_delete

instance IDeletable TH2I where
  delete = xform0 c_th2i_delete

instance IDeletable TH2F where
  delete = xform0 c_th2f_delete

instance IDeletable TH2D where
  delete = xform0 c_th2d_delete

instance IDeletable TH2C where
  delete = xform0 c_th2c_delete

instance IDeletable TH1S where
  delete = xform0 c_th1s_delete

instance IDeletable TH1I where
  delete = xform0 c_th1i_delete

instance IDeletable TH1F where
  delete = xform0 c_th1f_delete

instance IDeletable TH1D where
  delete = xform0 c_th1d_delete

instance IDeletable TH1C where
  delete = xform0 c_th1c_delete

instance IDeletable TH3 where
  delete = xform0 c_th3_delete

instance IDeletable TH2 where
  delete = xform0 c_th2_delete

instance IDeletable TH1 where
  delete = xform0 c_th1_delete

instance IDeletable TArrayS where
  delete = xform0 c_tarrays_delete

instance IDeletable TArrayL64 where
  delete = xform0 c_tarrayl64_delete

instance IDeletable TArrayL where
  delete = xform0 c_tarrayl_delete

instance IDeletable TArrayI where
  delete = xform0 c_tarrayi_delete

instance IDeletable TArrayF where
  delete = xform0 c_tarrayf_delete

instance IDeletable TArrayD where
  delete = xform0 c_tarrayd_delete

instance IDeletable TArrayC where
  delete = xform0 c_tarrayc_delete

instance IDeletable TArray where
  delete = xform0 c_tarray_delete

instance IDeletable TTreePlayer where
  delete = xform0 c_ttreeplayer_delete

instance IDeletable TVirtualTreePlayer where
  delete = xform0 c_tvirtualtreeplayer_delete

instance IDeletable TBranch where
  delete = xform0 c_tbranch_delete

instance IDeletable TFile where
  delete = xform0 c_tfile_delete

instance IDeletable TDirectoryFile where
  delete = xform0 c_tdirectoryfile_delete

instance IDeletable TDirectory where
  delete = xform0 c_tdirectory_delete

instance IDeletable TText where
  delete = xform0 c_ttext_delete

instance IDeletable TLatex where
  delete = xform0 c_tlatex_delete

instance IDeletable TAxis where
  delete = xform0 c_taxis_delete

instance IDeletable TEfficiency where
  delete = xform0 c_tefficiency_delete

instance IDeletable TCurlyArc where
  delete = xform0 c_tcurlyarc_delete

instance IDeletable TCurlyLine where
  delete = xform0 c_tcurlyline_delete

instance IDeletable TPolyLine where
  delete = xform0 c_tpolyline_delete

instance IDeletable TTreeSQL where
  delete = xform0 c_ttreesql_delete

instance IDeletable TNtupleD where
  delete = xform0 c_tntupled_delete

instance IDeletable TNtuple where
  delete = xform0 c_tntuple_delete

instance IDeletable TChain where
  delete = xform0 c_tchain_delete

instance IDeletable TTree where
  delete = xform0 c_ttree_delete

instance IDeletable TSliderBox where
  delete = xform0 c_tsliderbox_delete

instance IDeletable TFrame where
  delete = xform0 c_tframe_delete

instance IDeletable TWbox where
  delete = xform0 c_twbox_delete

instance IDeletable TPaveClass where
  delete = xform0 c_tpaveclass_delete

instance IDeletable TPaveLabel where
  delete = xform0 c_tpavelabel_delete

instance IDeletable TLegendEntry where
  delete = xform0 c_tlegendentry_delete

instance IDeletable TLegend where
  delete = xform0 c_tlegend_delete

instance IDeletable TPavesText where
  delete = xform0 c_tpavestext_delete

instance IDeletable TPaveStats where
  delete = xform0 c_tpavestats_delete

instance IDeletable TDiamond where
  delete = xform0 c_tdiamond_delete

instance IDeletable TPaveText where
  delete = xform0 c_tpavetext_delete

instance IDeletable TPave where
  delete = xform0 c_tpave_delete

instance IDeletable TBox where
  delete = xform0 c_tbox_delete

instance IDeletable TXTRU where
  delete = xform0 c_txtru_delete

instance IDeletable TSPHE where
  delete = xform0 c_tsphe_delete

instance IDeletable TPCON where
  delete = xform0 c_tpcon_delete

instance IDeletable TTUBE where
  delete = xform0 c_ttube_delete

instance IDeletable TBRIK where
  delete = xform0 c_tbrik_delete

instance IDeletable TShape where
  delete = xform0 c_tshape_delete

instance IDeletable TGaxis where
  delete = xform0 c_tgaxis_delete

instance IDeletable TArrow where
  delete = xform0 c_tarrow_delete

instance IDeletable TLine where
  delete = xform0 c_tline_delete

instance IDeletable TCrown where
  delete = xform0 c_tcrown_delete

instance IDeletable TArc where
  delete = xform0 c_tarc_delete

instance IDeletable TEllipse where
  delete = xform0 c_tellipse_delete

instance IDeletable TGraphQQ where
  delete = xform0 c_tgraphqq_delete

instance IDeletable TGraphPolar where
  delete = xform0 c_tgraphpolar_delete

instance IDeletable TGraphErrors where
  delete = xform0 c_tgrapherrors_delete

instance IDeletable TGraphBentErrors where
  delete = xform0 c_tgraphbenterrors_delete

instance IDeletable TCutG where
  delete = xform0 c_tcutg_delete

instance IDeletable TGraphAsymmErrors where
  delete = xform0 c_tgraphasymmerrors_delete

instance IDeletable TGraph where
  delete = xform0 c_tgraph_delete

instance IDeletable TF1 where
  delete = xform0 c_tf1_delete

instance IDeletable THStack where
  delete = xform0 c_thstack_delete

instance IDeletable TAttText where
  delete = xform0 c_tatttext_delete

instance IDeletable TAttParticle where
  delete = xform0 c_tattparticle_delete

instance IDeletable TAttPad where
  delete = xform0 c_tattpad_delete

instance IDeletable TAttMarker where
  delete = xform0 c_tattmarker_delete

instance IDeletable TAttLine where
  delete = xform0 c_tattline_delete

instance IDeletable TAttImage where
  delete = xform0 c_tattimage_delete

instance IDeletable TAttFill where
  delete = xform0 c_tattfill_delete

instance IDeletable TAttCanvas where
  delete = xform0 c_tattcanvas_delete

instance IDeletable TAttBBox where
  delete = xform0 c_tattbbox_delete

instance IDeletable TAttAxis where
  delete = xform0 c_tattaxis_delete

instance IDeletable TAtt3D where
  delete = xform0 c_tatt3d_delete

instance IDeletable TFormula where
  delete = xform0 c_tformula_delete

instance IDeletable TClass where
  delete = xform0 c_tclass_delete



instance IDeletable TNamed where
  delete = xform0 c_tnamed_delete

instance IDeletable TObject where
  delete = xform0 c_tobject_delete

instance ITApplication TRint where
  run = xform1 c_trint_run

instance ITArray TH3S where

instance ITArray TH3I where

instance ITArray TH3F where

instance ITArray TH3D where

instance ITArray TH3C where

instance ITArray TH2S where

instance ITArray TH2I where

instance ITArray TH2F where

instance ITArray TH2D where

instance ITArray TH2C where

instance ITArray TH1S where

instance ITArray TH1I where

instance ITArray TH1F where

instance ITArray TH1D where

instance ITArray TH1C where

instance ITArray TArrayS where

instance ITArray TArrayL64 where

instance ITArray TArrayL where

instance ITArray TArrayI where

instance ITArray TArrayF where

instance ITArray TArrayD where

instance ITArray TArrayC where

instance ITArrayC TH3C where

instance ITArrayC TH2C where

instance ITArrayC TH1C where

instance ITArrayD TH3D where

instance ITArrayD TH2D where

instance ITArrayD TH1D where

instance ITArrayF TH3F where

instance ITArrayF TH2F where

instance ITArrayF TH1F where

instance ITArrayI TH3I where

instance ITArrayI TH2I where

instance ITArrayI TH1I where

instance ITArrayS TH3S where

instance ITArrayS TH2S where

instance ITArrayS TH1S where

instance ITAtt3D TH3S where

instance ITAtt3D TH3I where

instance ITAtt3D TH3F where

instance ITAtt3D TH3D where

instance ITAtt3D TH3C where

instance ITAtt3D TH3 where

instance ITAtt3D TXTRU where

instance ITAtt3D TSPHE where

instance ITAtt3D TPCON where

instance ITAtt3D TTUBE where

instance ITAtt3D TBRIK where

instance ITAtt3D TShape where

instance ITAttAxis TAxis where
  setLabelColor = xform1 c_taxis_setlabelcolor
  setLabelSize = xform1 c_taxis_setlabelsize
  setTickLength = xform1 c_taxis_setticklength
  setTitleOffset = xform1 c_taxis_settitleoffset
  setNdivisions = xform2 c_taxis_setndivisions

instance ITAttFill TSlider where
  setFillColor = xform1 c_tslider_setfillcolor
  setFillStyle = xform1 c_tslider_setfillstyle

instance ITAttFill TEvePad where
  setFillColor = xform1 c_tevepad_setfillcolor
  setFillStyle = xform1 c_tevepad_setfillstyle

instance ITAttFill TInspectCanvas where
  setFillColor = xform1 c_tinspectcanvas_setfillcolor
  setFillStyle = xform1 c_tinspectcanvas_setfillstyle

instance ITAttFill TDialogCanvas where
  setFillColor = xform1 c_tdialogcanvas_setfillcolor
  setFillStyle = xform1 c_tdialogcanvas_setfillstyle

instance ITAttFill TCanvas where
  setFillColor = xform1 c_tcanvas_setfillcolor
  setFillStyle = xform1 c_tcanvas_setfillstyle

instance ITAttFill TGroupButton where
  setFillColor = xform1 c_tgroupbutton_setfillcolor
  setFillStyle = xform1 c_tgroupbutton_setfillstyle

instance ITAttFill TButton where
  setFillColor = xform1 c_tbutton_setfillcolor
  setFillStyle = xform1 c_tbutton_setfillstyle

instance ITAttFill TPad where
  setFillColor = xform1 c_tpad_setfillcolor
  setFillStyle = xform1 c_tpad_setfillstyle

instance ITAttFill TVirtualPad where
  setFillColor = xform1 c_tvirtualpad_setfillcolor
  setFillStyle = xform1 c_tvirtualpad_setfillstyle

instance ITAttFill TH3S where
  setFillColor = xform1 c_th3s_setfillcolor
  setFillStyle = xform1 c_th3s_setfillstyle

instance ITAttFill TH3I where
  setFillColor = xform1 c_th3i_setfillcolor
  setFillStyle = xform1 c_th3i_setfillstyle

instance ITAttFill TH3F where
  setFillColor = xform1 c_th3f_setfillcolor
  setFillStyle = xform1 c_th3f_setfillstyle

instance ITAttFill TH3D where
  setFillColor = xform1 c_th3d_setfillcolor
  setFillStyle = xform1 c_th3d_setfillstyle

instance ITAttFill TH3C where
  setFillColor = xform1 c_th3c_setfillcolor
  setFillStyle = xform1 c_th3c_setfillstyle

instance ITAttFill TH2S where
  setFillColor = xform1 c_th2s_setfillcolor
  setFillStyle = xform1 c_th2s_setfillstyle

instance ITAttFill TH2Poly where
  setFillColor = xform1 c_th2poly_setfillcolor
  setFillStyle = xform1 c_th2poly_setfillstyle

instance ITAttFill TH2I where
  setFillColor = xform1 c_th2i_setfillcolor
  setFillStyle = xform1 c_th2i_setfillstyle

instance ITAttFill TH2F where
  setFillColor = xform1 c_th2f_setfillcolor
  setFillStyle = xform1 c_th2f_setfillstyle

instance ITAttFill TH2D where
  setFillColor = xform1 c_th2d_setfillcolor
  setFillStyle = xform1 c_th2d_setfillstyle

instance ITAttFill TH2C where
  setFillColor = xform1 c_th2c_setfillcolor
  setFillStyle = xform1 c_th2c_setfillstyle

instance ITAttFill TH1S where
  setFillColor = xform1 c_th1s_setfillcolor
  setFillStyle = xform1 c_th1s_setfillstyle

instance ITAttFill TH1I where
  setFillColor = xform1 c_th1i_setfillcolor
  setFillStyle = xform1 c_th1i_setfillstyle

instance ITAttFill TH1F where
  setFillColor = xform1 c_th1f_setfillcolor
  setFillStyle = xform1 c_th1f_setfillstyle

instance ITAttFill TH1D where
  setFillColor = xform1 c_th1d_setfillcolor
  setFillStyle = xform1 c_th1d_setfillstyle

instance ITAttFill TH1C where
  setFillColor = xform1 c_th1c_setfillcolor
  setFillStyle = xform1 c_th1c_setfillstyle

instance ITAttFill TH3 where
  setFillColor = xform1 c_th3_setfillcolor
  setFillStyle = xform1 c_th3_setfillstyle

instance ITAttFill TH2 where
  setFillColor = xform1 c_th2_setfillcolor
  setFillStyle = xform1 c_th2_setfillstyle

instance ITAttFill TH1 where
  setFillColor = xform1 c_th1_setfillcolor
  setFillStyle = xform1 c_th1_setfillstyle

instance ITAttFill TBranch where
  setFillColor = xform1 c_tbranch_setfillcolor
  setFillStyle = xform1 c_tbranch_setfillstyle

instance ITAttFill TEfficiency where
  setFillColor = xform1 c_tefficiency_setfillcolor
  setFillStyle = xform1 c_tefficiency_setfillstyle

instance ITAttFill TCurlyArc where
  setFillColor = xform1 c_tcurlyarc_setfillcolor
  setFillStyle = xform1 c_tcurlyarc_setfillstyle

instance ITAttFill TCurlyLine where
  setFillColor = xform1 c_tcurlyline_setfillcolor
  setFillStyle = xform1 c_tcurlyline_setfillstyle

instance ITAttFill TPolyLine where
  setFillColor = xform1 c_tpolyline_setfillcolor
  setFillStyle = xform1 c_tpolyline_setfillstyle

instance ITAttFill TTreeSQL where
  setFillColor = xform1 c_ttreesql_setfillcolor
  setFillStyle = xform1 c_ttreesql_setfillstyle

instance ITAttFill TNtupleD where
  setFillColor = xform1 c_tntupled_setfillcolor
  setFillStyle = xform1 c_tntupled_setfillstyle

instance ITAttFill TNtuple where
  setFillColor = xform1 c_tntuple_setfillcolor
  setFillStyle = xform1 c_tntuple_setfillstyle

instance ITAttFill TChain where
  setFillColor = xform1 c_tchain_setfillcolor
  setFillStyle = xform1 c_tchain_setfillstyle

instance ITAttFill TTree where
  setFillColor = xform1 c_ttree_setfillcolor
  setFillStyle = xform1 c_ttree_setfillstyle

instance ITAttFill TSliderBox where
  setFillColor = xform1 c_tsliderbox_setfillcolor
  setFillStyle = xform1 c_tsliderbox_setfillstyle

instance ITAttFill TFrame where
  setFillColor = xform1 c_tframe_setfillcolor
  setFillStyle = xform1 c_tframe_setfillstyle

instance ITAttFill TWbox where
  setFillColor = xform1 c_twbox_setfillcolor
  setFillStyle = xform1 c_twbox_setfillstyle

instance ITAttFill TPaveClass where
  setFillColor = xform1 c_tpaveclass_setfillcolor
  setFillStyle = xform1 c_tpaveclass_setfillstyle

instance ITAttFill TPaveLabel where
  setFillColor = xform1 c_tpavelabel_setfillcolor
  setFillStyle = xform1 c_tpavelabel_setfillstyle

instance ITAttFill TLegendEntry where
  setFillColor = xform1 c_tlegendentry_setfillcolor
  setFillStyle = xform1 c_tlegendentry_setfillstyle

instance ITAttFill TLegend where
  setFillColor = xform1 c_tlegend_setfillcolor
  setFillStyle = xform1 c_tlegend_setfillstyle

instance ITAttFill TPavesText where
  setFillColor = xform1 c_tpavestext_setfillcolor
  setFillStyle = xform1 c_tpavestext_setfillstyle

instance ITAttFill TPaveStats where
  setFillColor = xform1 c_tpavestats_setfillcolor
  setFillStyle = xform1 c_tpavestats_setfillstyle

instance ITAttFill TDiamond where
  setFillColor = xform1 c_tdiamond_setfillcolor
  setFillStyle = xform1 c_tdiamond_setfillstyle

instance ITAttFill TPaveText where
  setFillColor = xform1 c_tpavetext_setfillcolor
  setFillStyle = xform1 c_tpavetext_setfillstyle

instance ITAttFill TPave where
  setFillColor = xform1 c_tpave_setfillcolor
  setFillStyle = xform1 c_tpave_setfillstyle

instance ITAttFill TBox where
  setFillColor = xform1 c_tbox_setfillcolor
  setFillStyle = xform1 c_tbox_setfillstyle

instance ITAttFill TXTRU where
  setFillColor = xform1 c_txtru_setfillcolor
  setFillStyle = xform1 c_txtru_setfillstyle

instance ITAttFill TSPHE where
  setFillColor = xform1 c_tsphe_setfillcolor
  setFillStyle = xform1 c_tsphe_setfillstyle

instance ITAttFill TPCON where
  setFillColor = xform1 c_tpcon_setfillcolor
  setFillStyle = xform1 c_tpcon_setfillstyle

instance ITAttFill TTUBE where
  setFillColor = xform1 c_ttube_setfillcolor
  setFillStyle = xform1 c_ttube_setfillstyle

instance ITAttFill TBRIK where
  setFillColor = xform1 c_tbrik_setfillcolor
  setFillStyle = xform1 c_tbrik_setfillstyle

instance ITAttFill TShape where
  setFillColor = xform1 c_tshape_setfillcolor
  setFillStyle = xform1 c_tshape_setfillstyle

instance ITAttFill TArrow where
  setFillColor = xform1 c_tarrow_setfillcolor
  setFillStyle = xform1 c_tarrow_setfillstyle

instance ITAttFill TCrown where
  setFillColor = xform1 c_tcrown_setfillcolor
  setFillStyle = xform1 c_tcrown_setfillstyle

instance ITAttFill TArc where
  setFillColor = xform1 c_tarc_setfillcolor
  setFillStyle = xform1 c_tarc_setfillstyle

instance ITAttFill TEllipse where
  setFillColor = xform1 c_tellipse_setfillcolor
  setFillStyle = xform1 c_tellipse_setfillstyle

instance ITAttFill TGraphQQ where
  setFillColor = xform1 c_tgraphqq_setfillcolor
  setFillStyle = xform1 c_tgraphqq_setfillstyle

instance ITAttFill TGraphPolar where
  setFillColor = xform1 c_tgraphpolar_setfillcolor
  setFillStyle = xform1 c_tgraphpolar_setfillstyle

instance ITAttFill TGraphErrors where
  setFillColor = xform1 c_tgrapherrors_setfillcolor
  setFillStyle = xform1 c_tgrapherrors_setfillstyle

instance ITAttFill TGraphBentErrors where
  setFillColor = xform1 c_tgraphbenterrors_setfillcolor
  setFillStyle = xform1 c_tgraphbenterrors_setfillstyle

instance ITAttFill TCutG where
  setFillColor = xform1 c_tcutg_setfillcolor
  setFillStyle = xform1 c_tcutg_setfillstyle

instance ITAttFill TGraphAsymmErrors where
  setFillColor = xform1 c_tgraphasymmerrors_setfillcolor
  setFillStyle = xform1 c_tgraphasymmerrors_setfillstyle

instance ITAttFill TGraph where
  setFillColor = xform1 c_tgraph_setfillcolor
  setFillStyle = xform1 c_tgraph_setfillstyle

instance ITAttFill TF1 where
  setFillColor = xform1 c_tf1_setfillcolor
  setFillStyle = xform1 c_tf1_setfillstyle

instance ITAttLine TSlider where
  setLineColor = xform1 c_tslider_setlinecolor

instance ITAttLine TEvePad where
  setLineColor = xform1 c_tevepad_setlinecolor

instance ITAttLine TInspectCanvas where
  setLineColor = xform1 c_tinspectcanvas_setlinecolor

instance ITAttLine TDialogCanvas where
  setLineColor = xform1 c_tdialogcanvas_setlinecolor

instance ITAttLine TCanvas where
  setLineColor = xform1 c_tcanvas_setlinecolor

instance ITAttLine TGroupButton where
  setLineColor = xform1 c_tgroupbutton_setlinecolor

instance ITAttLine TButton where
  setLineColor = xform1 c_tbutton_setlinecolor

instance ITAttLine TPad where
  setLineColor = xform1 c_tpad_setlinecolor

instance ITAttLine TVirtualPad where
  setLineColor = xform1 c_tvirtualpad_setlinecolor

instance ITAttLine TH3S where
  setLineColor = xform1 c_th3s_setlinecolor

instance ITAttLine TH3I where
  setLineColor = xform1 c_th3i_setlinecolor

instance ITAttLine TH3F where
  setLineColor = xform1 c_th3f_setlinecolor

instance ITAttLine TH3D where
  setLineColor = xform1 c_th3d_setlinecolor

instance ITAttLine TH3C where
  setLineColor = xform1 c_th3c_setlinecolor

instance ITAttLine TH2S where
  setLineColor = xform1 c_th2s_setlinecolor

instance ITAttLine TH2Poly where
  setLineColor = xform1 c_th2poly_setlinecolor

instance ITAttLine TH2I where
  setLineColor = xform1 c_th2i_setlinecolor

instance ITAttLine TH2F where
  setLineColor = xform1 c_th2f_setlinecolor

instance ITAttLine TH2D where
  setLineColor = xform1 c_th2d_setlinecolor

instance ITAttLine TH2C where
  setLineColor = xform1 c_th2c_setlinecolor

instance ITAttLine TH1S where
  setLineColor = xform1 c_th1s_setlinecolor

instance ITAttLine TH1I where
  setLineColor = xform1 c_th1i_setlinecolor

instance ITAttLine TH1F where
  setLineColor = xform1 c_th1f_setlinecolor

instance ITAttLine TH1D where
  setLineColor = xform1 c_th1d_setlinecolor

instance ITAttLine TH1C where
  setLineColor = xform1 c_th1c_setlinecolor

instance ITAttLine TH3 where
  setLineColor = xform1 c_th3_setlinecolor

instance ITAttLine TH2 where
  setLineColor = xform1 c_th2_setlinecolor

instance ITAttLine TH1 where
  setLineColor = xform1 c_th1_setlinecolor

instance ITAttLine TLatex where
  setLineColor = xform1 c_tlatex_setlinecolor

instance ITAttLine TEfficiency where
  setLineColor = xform1 c_tefficiency_setlinecolor

instance ITAttLine TCurlyArc where
  setLineColor = xform1 c_tcurlyarc_setlinecolor

instance ITAttLine TCurlyLine where
  setLineColor = xform1 c_tcurlyline_setlinecolor

instance ITAttLine TPolyLine where
  setLineColor = xform1 c_tpolyline_setlinecolor

instance ITAttLine TTreeSQL where
  setLineColor = xform1 c_ttreesql_setlinecolor

instance ITAttLine TNtupleD where
  setLineColor = xform1 c_tntupled_setlinecolor

instance ITAttLine TNtuple where
  setLineColor = xform1 c_tntuple_setlinecolor

instance ITAttLine TChain where
  setLineColor = xform1 c_tchain_setlinecolor

instance ITAttLine TTree where
  setLineColor = xform1 c_ttree_setlinecolor

instance ITAttLine TSliderBox where
  setLineColor = xform1 c_tsliderbox_setlinecolor

instance ITAttLine TFrame where
  setLineColor = xform1 c_tframe_setlinecolor

instance ITAttLine TWbox where
  setLineColor = xform1 c_twbox_setlinecolor

instance ITAttLine TPaveClass where
  setLineColor = xform1 c_tpaveclass_setlinecolor

instance ITAttLine TPaveLabel where
  setLineColor = xform1 c_tpavelabel_setlinecolor

instance ITAttLine TLegendEntry where
  setLineColor = xform1 c_tlegendentry_setlinecolor

instance ITAttLine TLegend where
  setLineColor = xform1 c_tlegend_setlinecolor

instance ITAttLine TPavesText where
  setLineColor = xform1 c_tpavestext_setlinecolor

instance ITAttLine TPaveStats where
  setLineColor = xform1 c_tpavestats_setlinecolor

instance ITAttLine TDiamond where
  setLineColor = xform1 c_tdiamond_setlinecolor

instance ITAttLine TPaveText where
  setLineColor = xform1 c_tpavetext_setlinecolor

instance ITAttLine TPave where
  setLineColor = xform1 c_tpave_setlinecolor

instance ITAttLine TBox where
  setLineColor = xform1 c_tbox_setlinecolor

instance ITAttLine TXTRU where
  setLineColor = xform1 c_txtru_setlinecolor

instance ITAttLine TSPHE where
  setLineColor = xform1 c_tsphe_setlinecolor

instance ITAttLine TPCON where
  setLineColor = xform1 c_tpcon_setlinecolor

instance ITAttLine TTUBE where
  setLineColor = xform1 c_ttube_setlinecolor

instance ITAttLine TBRIK where
  setLineColor = xform1 c_tbrik_setlinecolor

instance ITAttLine TShape where
  setLineColor = xform1 c_tshape_setlinecolor

instance ITAttLine TGaxis where
  setLineColor = xform1 c_tgaxis_setlinecolor

instance ITAttLine TArrow where
  setLineColor = xform1 c_tarrow_setlinecolor

instance ITAttLine TLine where
  setLineColor = xform1 c_tline_setlinecolor

instance ITAttLine TCrown where
  setLineColor = xform1 c_tcrown_setlinecolor

instance ITAttLine TArc where
  setLineColor = xform1 c_tarc_setlinecolor

instance ITAttLine TEllipse where
  setLineColor = xform1 c_tellipse_setlinecolor

instance ITAttLine TGraphQQ where
  setLineColor = xform1 c_tgraphqq_setlinecolor

instance ITAttLine TGraphPolar where
  setLineColor = xform1 c_tgraphpolar_setlinecolor

instance ITAttLine TGraphErrors where
  setLineColor = xform1 c_tgrapherrors_setlinecolor

instance ITAttLine TGraphBentErrors where
  setLineColor = xform1 c_tgraphbenterrors_setlinecolor

instance ITAttLine TCutG where
  setLineColor = xform1 c_tcutg_setlinecolor

instance ITAttLine TGraphAsymmErrors where
  setLineColor = xform1 c_tgraphasymmerrors_setlinecolor

instance ITAttLine TGraph where
  setLineColor = xform1 c_tgraph_setlinecolor

instance ITAttLine TF1 where
  setLineColor = xform1 c_tf1_setlinecolor

instance ITAttMarker TH3S where

instance ITAttMarker TH3I where

instance ITAttMarker TH3F where

instance ITAttMarker TH3D where

instance ITAttMarker TH3C where

instance ITAttMarker TH2S where

instance ITAttMarker TH2Poly where

instance ITAttMarker TH2I where

instance ITAttMarker TH2F where

instance ITAttMarker TH2D where

instance ITAttMarker TH2C where

instance ITAttMarker TH1S where

instance ITAttMarker TH1I where

instance ITAttMarker TH1F where

instance ITAttMarker TH1D where

instance ITAttMarker TH1C where

instance ITAttMarker TH3 where

instance ITAttMarker TH2 where

instance ITAttMarker TH1 where

instance ITAttMarker TEfficiency where

instance ITAttMarker TTreeSQL where

instance ITAttMarker TNtupleD where

instance ITAttMarker TNtuple where

instance ITAttMarker TChain where

instance ITAttMarker TTree where

instance ITAttMarker TLegendEntry where

instance ITAttMarker TGraphQQ where

instance ITAttMarker TGraphPolar where

instance ITAttMarker TGraphErrors where

instance ITAttMarker TGraphBentErrors where

instance ITAttMarker TCutG where

instance ITAttMarker TGraphAsymmErrors where

instance ITAttMarker TGraph where

instance ITAttPad TSlider where

instance ITAttPad TEvePad where

instance ITAttPad TInspectCanvas where

instance ITAttPad TDialogCanvas where

instance ITAttPad TCanvas where

instance ITAttPad TGroupButton where

instance ITAttPad TButton where

instance ITAttPad TPad where

instance ITAttPad TVirtualPad where

instance ITAttText TInspectCanvas where
  setTextColor = xform1 c_tinspectcanvas_settextcolor
  setTextAlign = xform1 c_tinspectcanvas_settextalign
  setTextSize = xform1 c_tinspectcanvas_settextsize

instance ITAttText TDialogCanvas where
  setTextColor = xform1 c_tdialogcanvas_settextcolor
  setTextAlign = xform1 c_tdialogcanvas_settextalign
  setTextSize = xform1 c_tdialogcanvas_settextsize

instance ITAttText TGroupButton where
  setTextColor = xform1 c_tgroupbutton_settextcolor
  setTextAlign = xform1 c_tgroupbutton_settextalign
  setTextSize = xform1 c_tgroupbutton_settextsize

instance ITAttText TButton where
  setTextColor = xform1 c_tbutton_settextcolor
  setTextAlign = xform1 c_tbutton_settextalign
  setTextSize = xform1 c_tbutton_settextsize

instance ITAttText TText where
  setTextColor = xform1 c_ttext_settextcolor
  setTextAlign = xform1 c_ttext_settextalign
  setTextSize = xform1 c_ttext_settextsize

instance ITAttText TLatex where
  setTextColor = xform1 c_tlatex_settextcolor
  setTextAlign = xform1 c_tlatex_settextalign
  setTextSize = xform1 c_tlatex_settextsize

instance ITAttText TPaveClass where
  setTextColor = xform1 c_tpaveclass_settextcolor
  setTextAlign = xform1 c_tpaveclass_settextalign
  setTextSize = xform1 c_tpaveclass_settextsize

instance ITAttText TPaveLabel where
  setTextColor = xform1 c_tpavelabel_settextcolor
  setTextAlign = xform1 c_tpavelabel_settextalign
  setTextSize = xform1 c_tpavelabel_settextsize

instance ITAttText TLegendEntry where
  setTextColor = xform1 c_tlegendentry_settextcolor
  setTextAlign = xform1 c_tlegendentry_settextalign
  setTextSize = xform1 c_tlegendentry_settextsize

instance ITAttText TLegend where
  setTextColor = xform1 c_tlegend_settextcolor
  setTextAlign = xform1 c_tlegend_settextalign
  setTextSize = xform1 c_tlegend_settextsize

instance ITAttText TPavesText where
  setTextColor = xform1 c_tpavestext_settextcolor
  setTextAlign = xform1 c_tpavestext_settextalign
  setTextSize = xform1 c_tpavestext_settextsize

instance ITAttText TPaveStats where
  setTextColor = xform1 c_tpavestats_settextcolor
  setTextAlign = xform1 c_tpavestats_settextalign
  setTextSize = xform1 c_tpavestats_settextsize

instance ITAttText TDiamond where
  setTextColor = xform1 c_tdiamond_settextcolor
  setTextAlign = xform1 c_tdiamond_settextalign
  setTextSize = xform1 c_tdiamond_settextsize

instance ITAttText TPaveText where
  setTextColor = xform1 c_tpavetext_settextcolor
  setTextAlign = xform1 c_tpavetext_settextalign
  setTextSize = xform1 c_tpavetext_settextsize

instance ITAttText TGaxis where
  setTextColor = xform1 c_tgaxis_settextcolor
  setTextAlign = xform1 c_tgaxis_settextalign
  setTextSize = xform1 c_tgaxis_settextsize

instance ITBox TSliderBox where

instance ITBox TFrame where

instance ITBox TWbox where

instance ITBox TPaveClass where

instance ITBox TPaveLabel where

instance ITBox TLegend where

instance ITBox TPavesText where

instance ITBox TPaveStats where

instance ITBox TDiamond where

instance ITBox TPaveText where

instance ITBox TPave where

instance ITButton TGroupButton where

instance ITCanvas TInspectCanvas where

instance ITCanvas TDialogCanvas where

instance ITCollection TList where

instance ITCollection TObjArray where

instance ITCollection TSeqCollection where

instance ITCurlyLine TCurlyArc where

instance ITDictionary TClass where

instance ITDirectory TFile where
  append = xform2 c_tfile_append
  addD = xform2 c_tfile_addd
  appendKey = xform1 c_tfile_appendkey
  close = xform1 c_tfile_close
  get = xform1 c_tfile_get

instance ITDirectory TDirectoryFile where
  append = xform2 c_tdirectoryfile_append
  addD = xform2 c_tdirectoryfile_addd
  appendKey = xform1 c_tdirectoryfile_appendkey
  close = xform1 c_tdirectoryfile_close
  get = xform1 c_tdirectoryfile_get

instance ITDirectoryFile TFile where
  getListOfKeys = xform0 c_tfile_getlistofkeys

instance ITEllipse TCrown where

instance ITEllipse TArc where

instance ITFormula TF1 where
  getParameter = xform1 c_tf1_getparameter
  setParameter = xform2 c_tf1_setparameter

instance ITGraph TGraphQQ where

instance ITGraph TGraphPolar where

instance ITGraph TGraphErrors where

instance ITGraph TGraphBentErrors where

instance ITGraph TCutG where

instance ITGraph TGraphAsymmErrors where

instance ITGraphErrors TGraphPolar where

instance ITH1 TH3S where
  add = xform2 c_th3s_add
  addBinContent = xform2 c_th3s_addbincontent
  chi2Test = xform3 c_th3s_chi2test
  computeIntegral = xform0 c_th3s_computeintegral
  directoryAutoAdd = xform1 c_th3s_directoryautoadd
  distancetoPrimitive = xform2 c_th3s_distancetoprimitive
  divide = xform5 c_th3s_divide
  drawCopy = xform1 c_th3s_drawcopy
  drawNormalized = xform2 c_th3s_drawnormalized
  drawPanel = xform0 c_th3s_drawpanel
  bufferEmpty = xform1 c_th3s_bufferempty
  eval = xform2 c_th3s_eval
  executeEvent = xform3 c_th3s_executeevent
  fFT = xform2 c_th3s_fft
  fill1 = xform1 c_th3s_fill1
  fillN = xform4 c_th3s_filln
  fillRandom = xform2 c_th3s_fillrandom
  findBin = xform3 c_th3s_findbin
  findFixBin = xform3 c_th3s_findfixbin
  findFirstBinAbove = xform2 c_th3s_findfirstbinabove
  findLastBinAbove = xform2 c_th3s_findlastbinabove
  fitPanel = xform0 c_th3s_fitpanel
  getNdivisions = xform1 c_th3s_getndivisions
  getAxisColor = xform1 c_th3s_getaxiscolor
  getLabelColor = xform1 c_th3s_getlabelcolor
  getLabelFont = xform1 c_th3s_getlabelfont
  getLabelOffset = xform1 c_th3s_getlabeloffset
  getLabelSize = xform1 c_th3s_getlabelsize
  getTitleFont = xform1 c_th3s_gettitlefont
  getTitleOffset = xform1 c_th3s_gettitleoffset
  getTitleSize = xform1 c_th3s_gettitlesize
  getTickLength = xform1 c_th3s_getticklength
  getBarOffset = xform0 c_th3s_getbaroffset
  getBarWidth = xform0 c_th3s_getbarwidth
  getContour = xform1 c_th3s_getcontour
  getContourLevel = xform1 c_th3s_getcontourlevel
  getContourLevelPad = xform1 c_th3s_getcontourlevelpad
  getBin = xform3 c_th3s_getbin
  getBinCenter = xform1 c_th3s_getbincenter
  getBinContent1 = xform1 c_th3s_getbincontent1
  getBinContent2 = xform2 c_th3s_getbincontent2
  getBinContent3 = xform3 c_th3s_getbincontent3
  getBinError1 = xform1 c_th3s_getbinerror1
  getBinError2 = xform2 c_th3s_getbinerror2
  getBinError3 = xform3 c_th3s_getbinerror3
  getBinLowEdge = xform1 c_th3s_getbinlowedge
  getBinWidth = xform1 c_th3s_getbinwidth
  getCellContent = xform2 c_th3s_getcellcontent
  getCellError = xform2 c_th3s_getcellerror
  scale = xform2 c_th3s_scale
  setAxisColor = xform2 c_th3s_setaxiscolor
  setAxisRange = xform3 c_th3s_setaxisrange
  setBarOffset = xform1 c_th3s_setbaroffset
  setBarWidth = xform1 c_th3s_setbarwidth
  setBinContent1 = xform2 c_th3s_setbincontent1
  setBinContent2 = xform3 c_th3s_setbincontent2
  setBinContent3 = xform4 c_th3s_setbincontent3
  setBinError1 = xform2 c_th3s_setbinerror1
  setBinError2 = xform3 c_th3s_setbinerror2
  setBinError3 = xform4 c_th3s_setbinerror3
  setBins1 = xform2 c_th3s_setbins1
  setBins2 = xform4 c_th3s_setbins2
  setBins3 = xform6 c_th3s_setbins3
  setMaximum = xform1 c_th3s_setmaximum
  setMinimum = xform1 c_th3s_setminimum
  setXTitle = xform1 c_th3s_setxtitle
  setYTitle = xform1 c_th3s_setytitle
  setZTitle = xform1 c_th3s_setztitle

instance ITH1 TH3I where
  add = xform2 c_th3i_add
  addBinContent = xform2 c_th3i_addbincontent
  chi2Test = xform3 c_th3i_chi2test
  computeIntegral = xform0 c_th3i_computeintegral
  directoryAutoAdd = xform1 c_th3i_directoryautoadd
  distancetoPrimitive = xform2 c_th3i_distancetoprimitive
  divide = xform5 c_th3i_divide
  drawCopy = xform1 c_th3i_drawcopy
  drawNormalized = xform2 c_th3i_drawnormalized
  drawPanel = xform0 c_th3i_drawpanel
  bufferEmpty = xform1 c_th3i_bufferempty
  eval = xform2 c_th3i_eval
  executeEvent = xform3 c_th3i_executeevent
  fFT = xform2 c_th3i_fft
  fill1 = xform1 c_th3i_fill1
  fillN = xform4 c_th3i_filln
  fillRandom = xform2 c_th3i_fillrandom
  findBin = xform3 c_th3i_findbin
  findFixBin = xform3 c_th3i_findfixbin
  findFirstBinAbove = xform2 c_th3i_findfirstbinabove
  findLastBinAbove = xform2 c_th3i_findlastbinabove
  fitPanel = xform0 c_th3i_fitpanel
  getNdivisions = xform1 c_th3i_getndivisions
  getAxisColor = xform1 c_th3i_getaxiscolor
  getLabelColor = xform1 c_th3i_getlabelcolor
  getLabelFont = xform1 c_th3i_getlabelfont
  getLabelOffset = xform1 c_th3i_getlabeloffset
  getLabelSize = xform1 c_th3i_getlabelsize
  getTitleFont = xform1 c_th3i_gettitlefont
  getTitleOffset = xform1 c_th3i_gettitleoffset
  getTitleSize = xform1 c_th3i_gettitlesize
  getTickLength = xform1 c_th3i_getticklength
  getBarOffset = xform0 c_th3i_getbaroffset
  getBarWidth = xform0 c_th3i_getbarwidth
  getContour = xform1 c_th3i_getcontour
  getContourLevel = xform1 c_th3i_getcontourlevel
  getContourLevelPad = xform1 c_th3i_getcontourlevelpad
  getBin = xform3 c_th3i_getbin
  getBinCenter = xform1 c_th3i_getbincenter
  getBinContent1 = xform1 c_th3i_getbincontent1
  getBinContent2 = xform2 c_th3i_getbincontent2
  getBinContent3 = xform3 c_th3i_getbincontent3
  getBinError1 = xform1 c_th3i_getbinerror1
  getBinError2 = xform2 c_th3i_getbinerror2
  getBinError3 = xform3 c_th3i_getbinerror3
  getBinLowEdge = xform1 c_th3i_getbinlowedge
  getBinWidth = xform1 c_th3i_getbinwidth
  getCellContent = xform2 c_th3i_getcellcontent
  getCellError = xform2 c_th3i_getcellerror
  scale = xform2 c_th3i_scale
  setAxisColor = xform2 c_th3i_setaxiscolor
  setAxisRange = xform3 c_th3i_setaxisrange
  setBarOffset = xform1 c_th3i_setbaroffset
  setBarWidth = xform1 c_th3i_setbarwidth
  setBinContent1 = xform2 c_th3i_setbincontent1
  setBinContent2 = xform3 c_th3i_setbincontent2
  setBinContent3 = xform4 c_th3i_setbincontent3
  setBinError1 = xform2 c_th3i_setbinerror1
  setBinError2 = xform3 c_th3i_setbinerror2
  setBinError3 = xform4 c_th3i_setbinerror3
  setBins1 = xform2 c_th3i_setbins1
  setBins2 = xform4 c_th3i_setbins2
  setBins3 = xform6 c_th3i_setbins3
  setMaximum = xform1 c_th3i_setmaximum
  setMinimum = xform1 c_th3i_setminimum
  setXTitle = xform1 c_th3i_setxtitle
  setYTitle = xform1 c_th3i_setytitle
  setZTitle = xform1 c_th3i_setztitle

instance ITH1 TH3F where
  add = xform2 c_th3f_add
  addBinContent = xform2 c_th3f_addbincontent
  chi2Test = xform3 c_th3f_chi2test
  computeIntegral = xform0 c_th3f_computeintegral
  directoryAutoAdd = xform1 c_th3f_directoryautoadd
  distancetoPrimitive = xform2 c_th3f_distancetoprimitive
  divide = xform5 c_th3f_divide
  drawCopy = xform1 c_th3f_drawcopy
  drawNormalized = xform2 c_th3f_drawnormalized
  drawPanel = xform0 c_th3f_drawpanel
  bufferEmpty = xform1 c_th3f_bufferempty
  eval = xform2 c_th3f_eval
  executeEvent = xform3 c_th3f_executeevent
  fFT = xform2 c_th3f_fft
  fill1 = xform1 c_th3f_fill1
  fillN = xform4 c_th3f_filln
  fillRandom = xform2 c_th3f_fillrandom
  findBin = xform3 c_th3f_findbin
  findFixBin = xform3 c_th3f_findfixbin
  findFirstBinAbove = xform2 c_th3f_findfirstbinabove
  findLastBinAbove = xform2 c_th3f_findlastbinabove
  fitPanel = xform0 c_th3f_fitpanel
  getNdivisions = xform1 c_th3f_getndivisions
  getAxisColor = xform1 c_th3f_getaxiscolor
  getLabelColor = xform1 c_th3f_getlabelcolor
  getLabelFont = xform1 c_th3f_getlabelfont
  getLabelOffset = xform1 c_th3f_getlabeloffset
  getLabelSize = xform1 c_th3f_getlabelsize
  getTitleFont = xform1 c_th3f_gettitlefont
  getTitleOffset = xform1 c_th3f_gettitleoffset
  getTitleSize = xform1 c_th3f_gettitlesize
  getTickLength = xform1 c_th3f_getticklength
  getBarOffset = xform0 c_th3f_getbaroffset
  getBarWidth = xform0 c_th3f_getbarwidth
  getContour = xform1 c_th3f_getcontour
  getContourLevel = xform1 c_th3f_getcontourlevel
  getContourLevelPad = xform1 c_th3f_getcontourlevelpad
  getBin = xform3 c_th3f_getbin
  getBinCenter = xform1 c_th3f_getbincenter
  getBinContent1 = xform1 c_th3f_getbincontent1
  getBinContent2 = xform2 c_th3f_getbincontent2
  getBinContent3 = xform3 c_th3f_getbincontent3
  getBinError1 = xform1 c_th3f_getbinerror1
  getBinError2 = xform2 c_th3f_getbinerror2
  getBinError3 = xform3 c_th3f_getbinerror3
  getBinLowEdge = xform1 c_th3f_getbinlowedge
  getBinWidth = xform1 c_th3f_getbinwidth
  getCellContent = xform2 c_th3f_getcellcontent
  getCellError = xform2 c_th3f_getcellerror
  scale = xform2 c_th3f_scale
  setAxisColor = xform2 c_th3f_setaxiscolor
  setAxisRange = xform3 c_th3f_setaxisrange
  setBarOffset = xform1 c_th3f_setbaroffset
  setBarWidth = xform1 c_th3f_setbarwidth
  setBinContent1 = xform2 c_th3f_setbincontent1
  setBinContent2 = xform3 c_th3f_setbincontent2
  setBinContent3 = xform4 c_th3f_setbincontent3
  setBinError1 = xform2 c_th3f_setbinerror1
  setBinError2 = xform3 c_th3f_setbinerror2
  setBinError3 = xform4 c_th3f_setbinerror3
  setBins1 = xform2 c_th3f_setbins1
  setBins2 = xform4 c_th3f_setbins2
  setBins3 = xform6 c_th3f_setbins3
  setMaximum = xform1 c_th3f_setmaximum
  setMinimum = xform1 c_th3f_setminimum
  setXTitle = xform1 c_th3f_setxtitle
  setYTitle = xform1 c_th3f_setytitle
  setZTitle = xform1 c_th3f_setztitle

instance ITH1 TH3D where
  add = xform2 c_th3d_add
  addBinContent = xform2 c_th3d_addbincontent
  chi2Test = xform3 c_th3d_chi2test
  computeIntegral = xform0 c_th3d_computeintegral
  directoryAutoAdd = xform1 c_th3d_directoryautoadd
  distancetoPrimitive = xform2 c_th3d_distancetoprimitive
  divide = xform5 c_th3d_divide
  drawCopy = xform1 c_th3d_drawcopy
  drawNormalized = xform2 c_th3d_drawnormalized
  drawPanel = xform0 c_th3d_drawpanel
  bufferEmpty = xform1 c_th3d_bufferempty
  eval = xform2 c_th3d_eval
  executeEvent = xform3 c_th3d_executeevent
  fFT = xform2 c_th3d_fft
  fill1 = xform1 c_th3d_fill1
  fillN = xform4 c_th3d_filln
  fillRandom = xform2 c_th3d_fillrandom
  findBin = xform3 c_th3d_findbin
  findFixBin = xform3 c_th3d_findfixbin
  findFirstBinAbove = xform2 c_th3d_findfirstbinabove
  findLastBinAbove = xform2 c_th3d_findlastbinabove
  fitPanel = xform0 c_th3d_fitpanel
  getNdivisions = xform1 c_th3d_getndivisions
  getAxisColor = xform1 c_th3d_getaxiscolor
  getLabelColor = xform1 c_th3d_getlabelcolor
  getLabelFont = xform1 c_th3d_getlabelfont
  getLabelOffset = xform1 c_th3d_getlabeloffset
  getLabelSize = xform1 c_th3d_getlabelsize
  getTitleFont = xform1 c_th3d_gettitlefont
  getTitleOffset = xform1 c_th3d_gettitleoffset
  getTitleSize = xform1 c_th3d_gettitlesize
  getTickLength = xform1 c_th3d_getticklength
  getBarOffset = xform0 c_th3d_getbaroffset
  getBarWidth = xform0 c_th3d_getbarwidth
  getContour = xform1 c_th3d_getcontour
  getContourLevel = xform1 c_th3d_getcontourlevel
  getContourLevelPad = xform1 c_th3d_getcontourlevelpad
  getBin = xform3 c_th3d_getbin
  getBinCenter = xform1 c_th3d_getbincenter
  getBinContent1 = xform1 c_th3d_getbincontent1
  getBinContent2 = xform2 c_th3d_getbincontent2
  getBinContent3 = xform3 c_th3d_getbincontent3
  getBinError1 = xform1 c_th3d_getbinerror1
  getBinError2 = xform2 c_th3d_getbinerror2
  getBinError3 = xform3 c_th3d_getbinerror3
  getBinLowEdge = xform1 c_th3d_getbinlowedge
  getBinWidth = xform1 c_th3d_getbinwidth
  getCellContent = xform2 c_th3d_getcellcontent
  getCellError = xform2 c_th3d_getcellerror
  scale = xform2 c_th3d_scale
  setAxisColor = xform2 c_th3d_setaxiscolor
  setAxisRange = xform3 c_th3d_setaxisrange
  setBarOffset = xform1 c_th3d_setbaroffset
  setBarWidth = xform1 c_th3d_setbarwidth
  setBinContent1 = xform2 c_th3d_setbincontent1
  setBinContent2 = xform3 c_th3d_setbincontent2
  setBinContent3 = xform4 c_th3d_setbincontent3
  setBinError1 = xform2 c_th3d_setbinerror1
  setBinError2 = xform3 c_th3d_setbinerror2
  setBinError3 = xform4 c_th3d_setbinerror3
  setBins1 = xform2 c_th3d_setbins1
  setBins2 = xform4 c_th3d_setbins2
  setBins3 = xform6 c_th3d_setbins3
  setMaximum = xform1 c_th3d_setmaximum
  setMinimum = xform1 c_th3d_setminimum
  setXTitle = xform1 c_th3d_setxtitle
  setYTitle = xform1 c_th3d_setytitle
  setZTitle = xform1 c_th3d_setztitle

instance ITH1 TH3C where
  add = xform2 c_th3c_add
  addBinContent = xform2 c_th3c_addbincontent
  chi2Test = xform3 c_th3c_chi2test
  computeIntegral = xform0 c_th3c_computeintegral
  directoryAutoAdd = xform1 c_th3c_directoryautoadd
  distancetoPrimitive = xform2 c_th3c_distancetoprimitive
  divide = xform5 c_th3c_divide
  drawCopy = xform1 c_th3c_drawcopy
  drawNormalized = xform2 c_th3c_drawnormalized
  drawPanel = xform0 c_th3c_drawpanel
  bufferEmpty = xform1 c_th3c_bufferempty
  eval = xform2 c_th3c_eval
  executeEvent = xform3 c_th3c_executeevent
  fFT = xform2 c_th3c_fft
  fill1 = xform1 c_th3c_fill1
  fillN = xform4 c_th3c_filln
  fillRandom = xform2 c_th3c_fillrandom
  findBin = xform3 c_th3c_findbin
  findFixBin = xform3 c_th3c_findfixbin
  findFirstBinAbove = xform2 c_th3c_findfirstbinabove
  findLastBinAbove = xform2 c_th3c_findlastbinabove
  fitPanel = xform0 c_th3c_fitpanel
  getNdivisions = xform1 c_th3c_getndivisions
  getAxisColor = xform1 c_th3c_getaxiscolor
  getLabelColor = xform1 c_th3c_getlabelcolor
  getLabelFont = xform1 c_th3c_getlabelfont
  getLabelOffset = xform1 c_th3c_getlabeloffset
  getLabelSize = xform1 c_th3c_getlabelsize
  getTitleFont = xform1 c_th3c_gettitlefont
  getTitleOffset = xform1 c_th3c_gettitleoffset
  getTitleSize = xform1 c_th3c_gettitlesize
  getTickLength = xform1 c_th3c_getticklength
  getBarOffset = xform0 c_th3c_getbaroffset
  getBarWidth = xform0 c_th3c_getbarwidth
  getContour = xform1 c_th3c_getcontour
  getContourLevel = xform1 c_th3c_getcontourlevel
  getContourLevelPad = xform1 c_th3c_getcontourlevelpad
  getBin = xform3 c_th3c_getbin
  getBinCenter = xform1 c_th3c_getbincenter
  getBinContent1 = xform1 c_th3c_getbincontent1
  getBinContent2 = xform2 c_th3c_getbincontent2
  getBinContent3 = xform3 c_th3c_getbincontent3
  getBinError1 = xform1 c_th3c_getbinerror1
  getBinError2 = xform2 c_th3c_getbinerror2
  getBinError3 = xform3 c_th3c_getbinerror3
  getBinLowEdge = xform1 c_th3c_getbinlowedge
  getBinWidth = xform1 c_th3c_getbinwidth
  getCellContent = xform2 c_th3c_getcellcontent
  getCellError = xform2 c_th3c_getcellerror
  scale = xform2 c_th3c_scale
  setAxisColor = xform2 c_th3c_setaxiscolor
  setAxisRange = xform3 c_th3c_setaxisrange
  setBarOffset = xform1 c_th3c_setbaroffset
  setBarWidth = xform1 c_th3c_setbarwidth
  setBinContent1 = xform2 c_th3c_setbincontent1
  setBinContent2 = xform3 c_th3c_setbincontent2
  setBinContent3 = xform4 c_th3c_setbincontent3
  setBinError1 = xform2 c_th3c_setbinerror1
  setBinError2 = xform3 c_th3c_setbinerror2
  setBinError3 = xform4 c_th3c_setbinerror3
  setBins1 = xform2 c_th3c_setbins1
  setBins2 = xform4 c_th3c_setbins2
  setBins3 = xform6 c_th3c_setbins3
  setMaximum = xform1 c_th3c_setmaximum
  setMinimum = xform1 c_th3c_setminimum
  setXTitle = xform1 c_th3c_setxtitle
  setYTitle = xform1 c_th3c_setytitle
  setZTitle = xform1 c_th3c_setztitle

instance ITH1 TH2S where
  add = xform2 c_th2s_add
  addBinContent = xform2 c_th2s_addbincontent
  chi2Test = xform3 c_th2s_chi2test
  computeIntegral = xform0 c_th2s_computeintegral
  directoryAutoAdd = xform1 c_th2s_directoryautoadd
  distancetoPrimitive = xform2 c_th2s_distancetoprimitive
  divide = xform5 c_th2s_divide
  drawCopy = xform1 c_th2s_drawcopy
  drawNormalized = xform2 c_th2s_drawnormalized
  drawPanel = xform0 c_th2s_drawpanel
  bufferEmpty = xform1 c_th2s_bufferempty
  eval = xform2 c_th2s_eval
  executeEvent = xform3 c_th2s_executeevent
  fFT = xform2 c_th2s_fft
  fill1 = xform1 c_th2s_fill1
  fillN = xform4 c_th2s_filln
  fillRandom = xform2 c_th2s_fillrandom
  findBin = xform3 c_th2s_findbin
  findFixBin = xform3 c_th2s_findfixbin
  findFirstBinAbove = xform2 c_th2s_findfirstbinabove
  findLastBinAbove = xform2 c_th2s_findlastbinabove
  fitPanel = xform0 c_th2s_fitpanel
  getNdivisions = xform1 c_th2s_getndivisions
  getAxisColor = xform1 c_th2s_getaxiscolor
  getLabelColor = xform1 c_th2s_getlabelcolor
  getLabelFont = xform1 c_th2s_getlabelfont
  getLabelOffset = xform1 c_th2s_getlabeloffset
  getLabelSize = xform1 c_th2s_getlabelsize
  getTitleFont = xform1 c_th2s_gettitlefont
  getTitleOffset = xform1 c_th2s_gettitleoffset
  getTitleSize = xform1 c_th2s_gettitlesize
  getTickLength = xform1 c_th2s_getticklength
  getBarOffset = xform0 c_th2s_getbaroffset
  getBarWidth = xform0 c_th2s_getbarwidth
  getContour = xform1 c_th2s_getcontour
  getContourLevel = xform1 c_th2s_getcontourlevel
  getContourLevelPad = xform1 c_th2s_getcontourlevelpad
  getBin = xform3 c_th2s_getbin
  getBinCenter = xform1 c_th2s_getbincenter
  getBinContent1 = xform1 c_th2s_getbincontent1
  getBinContent2 = xform2 c_th2s_getbincontent2
  getBinContent3 = xform3 c_th2s_getbincontent3
  getBinError1 = xform1 c_th2s_getbinerror1
  getBinError2 = xform2 c_th2s_getbinerror2
  getBinError3 = xform3 c_th2s_getbinerror3
  getBinLowEdge = xform1 c_th2s_getbinlowedge
  getBinWidth = xform1 c_th2s_getbinwidth
  getCellContent = xform2 c_th2s_getcellcontent
  getCellError = xform2 c_th2s_getcellerror
  scale = xform2 c_th2s_scale
  setAxisColor = xform2 c_th2s_setaxiscolor
  setAxisRange = xform3 c_th2s_setaxisrange
  setBarOffset = xform1 c_th2s_setbaroffset
  setBarWidth = xform1 c_th2s_setbarwidth
  setBinContent1 = xform2 c_th2s_setbincontent1
  setBinContent2 = xform3 c_th2s_setbincontent2
  setBinContent3 = xform4 c_th2s_setbincontent3
  setBinError1 = xform2 c_th2s_setbinerror1
  setBinError2 = xform3 c_th2s_setbinerror2
  setBinError3 = xform4 c_th2s_setbinerror3
  setBins1 = xform2 c_th2s_setbins1
  setBins2 = xform4 c_th2s_setbins2
  setBins3 = xform6 c_th2s_setbins3
  setMaximum = xform1 c_th2s_setmaximum
  setMinimum = xform1 c_th2s_setminimum
  setXTitle = xform1 c_th2s_setxtitle
  setYTitle = xform1 c_th2s_setytitle
  setZTitle = xform1 c_th2s_setztitle

instance ITH1 TH2Poly where
  add = xform2 c_th2poly_add
  addBinContent = xform2 c_th2poly_addbincontent
  chi2Test = xform3 c_th2poly_chi2test
  computeIntegral = xform0 c_th2poly_computeintegral
  directoryAutoAdd = xform1 c_th2poly_directoryautoadd
  distancetoPrimitive = xform2 c_th2poly_distancetoprimitive
  divide = xform5 c_th2poly_divide
  drawCopy = xform1 c_th2poly_drawcopy
  drawNormalized = xform2 c_th2poly_drawnormalized
  drawPanel = xform0 c_th2poly_drawpanel
  bufferEmpty = xform1 c_th2poly_bufferempty
  eval = xform2 c_th2poly_eval
  executeEvent = xform3 c_th2poly_executeevent
  fFT = xform2 c_th2poly_fft
  fill1 = xform1 c_th2poly_fill1
  fillN = xform4 c_th2poly_filln
  fillRandom = xform2 c_th2poly_fillrandom
  findBin = xform3 c_th2poly_findbin
  findFixBin = xform3 c_th2poly_findfixbin
  findFirstBinAbove = xform2 c_th2poly_findfirstbinabove
  findLastBinAbove = xform2 c_th2poly_findlastbinabove
  fitPanel = xform0 c_th2poly_fitpanel
  getNdivisions = xform1 c_th2poly_getndivisions
  getAxisColor = xform1 c_th2poly_getaxiscolor
  getLabelColor = xform1 c_th2poly_getlabelcolor
  getLabelFont = xform1 c_th2poly_getlabelfont
  getLabelOffset = xform1 c_th2poly_getlabeloffset
  getLabelSize = xform1 c_th2poly_getlabelsize
  getTitleFont = xform1 c_th2poly_gettitlefont
  getTitleOffset = xform1 c_th2poly_gettitleoffset
  getTitleSize = xform1 c_th2poly_gettitlesize
  getTickLength = xform1 c_th2poly_getticklength
  getBarOffset = xform0 c_th2poly_getbaroffset
  getBarWidth = xform0 c_th2poly_getbarwidth
  getContour = xform1 c_th2poly_getcontour
  getContourLevel = xform1 c_th2poly_getcontourlevel
  getContourLevelPad = xform1 c_th2poly_getcontourlevelpad
  getBin = xform3 c_th2poly_getbin
  getBinCenter = xform1 c_th2poly_getbincenter
  getBinContent1 = xform1 c_th2poly_getbincontent1
  getBinContent2 = xform2 c_th2poly_getbincontent2
  getBinContent3 = xform3 c_th2poly_getbincontent3
  getBinError1 = xform1 c_th2poly_getbinerror1
  getBinError2 = xform2 c_th2poly_getbinerror2
  getBinError3 = xform3 c_th2poly_getbinerror3
  getBinLowEdge = xform1 c_th2poly_getbinlowedge
  getBinWidth = xform1 c_th2poly_getbinwidth
  getCellContent = xform2 c_th2poly_getcellcontent
  getCellError = xform2 c_th2poly_getcellerror
  scale = xform2 c_th2poly_scale
  setAxisColor = xform2 c_th2poly_setaxiscolor
  setAxisRange = xform3 c_th2poly_setaxisrange
  setBarOffset = xform1 c_th2poly_setbaroffset
  setBarWidth = xform1 c_th2poly_setbarwidth
  setBinContent1 = xform2 c_th2poly_setbincontent1
  setBinContent2 = xform3 c_th2poly_setbincontent2
  setBinContent3 = xform4 c_th2poly_setbincontent3
  setBinError1 = xform2 c_th2poly_setbinerror1
  setBinError2 = xform3 c_th2poly_setbinerror2
  setBinError3 = xform4 c_th2poly_setbinerror3
  setBins1 = xform2 c_th2poly_setbins1
  setBins2 = xform4 c_th2poly_setbins2
  setBins3 = xform6 c_th2poly_setbins3
  setMaximum = xform1 c_th2poly_setmaximum
  setMinimum = xform1 c_th2poly_setminimum
  setXTitle = xform1 c_th2poly_setxtitle
  setYTitle = xform1 c_th2poly_setytitle
  setZTitle = xform1 c_th2poly_setztitle

instance ITH1 TH2I where
  add = xform2 c_th2i_add
  addBinContent = xform2 c_th2i_addbincontent
  chi2Test = xform3 c_th2i_chi2test
  computeIntegral = xform0 c_th2i_computeintegral
  directoryAutoAdd = xform1 c_th2i_directoryautoadd
  distancetoPrimitive = xform2 c_th2i_distancetoprimitive
  divide = xform5 c_th2i_divide
  drawCopy = xform1 c_th2i_drawcopy
  drawNormalized = xform2 c_th2i_drawnormalized
  drawPanel = xform0 c_th2i_drawpanel
  bufferEmpty = xform1 c_th2i_bufferempty
  eval = xform2 c_th2i_eval
  executeEvent = xform3 c_th2i_executeevent
  fFT = xform2 c_th2i_fft
  fill1 = xform1 c_th2i_fill1
  fillN = xform4 c_th2i_filln
  fillRandom = xform2 c_th2i_fillrandom
  findBin = xform3 c_th2i_findbin
  findFixBin = xform3 c_th2i_findfixbin
  findFirstBinAbove = xform2 c_th2i_findfirstbinabove
  findLastBinAbove = xform2 c_th2i_findlastbinabove
  fitPanel = xform0 c_th2i_fitpanel
  getNdivisions = xform1 c_th2i_getndivisions
  getAxisColor = xform1 c_th2i_getaxiscolor
  getLabelColor = xform1 c_th2i_getlabelcolor
  getLabelFont = xform1 c_th2i_getlabelfont
  getLabelOffset = xform1 c_th2i_getlabeloffset
  getLabelSize = xform1 c_th2i_getlabelsize
  getTitleFont = xform1 c_th2i_gettitlefont
  getTitleOffset = xform1 c_th2i_gettitleoffset
  getTitleSize = xform1 c_th2i_gettitlesize
  getTickLength = xform1 c_th2i_getticklength
  getBarOffset = xform0 c_th2i_getbaroffset
  getBarWidth = xform0 c_th2i_getbarwidth
  getContour = xform1 c_th2i_getcontour
  getContourLevel = xform1 c_th2i_getcontourlevel
  getContourLevelPad = xform1 c_th2i_getcontourlevelpad
  getBin = xform3 c_th2i_getbin
  getBinCenter = xform1 c_th2i_getbincenter
  getBinContent1 = xform1 c_th2i_getbincontent1
  getBinContent2 = xform2 c_th2i_getbincontent2
  getBinContent3 = xform3 c_th2i_getbincontent3
  getBinError1 = xform1 c_th2i_getbinerror1
  getBinError2 = xform2 c_th2i_getbinerror2
  getBinError3 = xform3 c_th2i_getbinerror3
  getBinLowEdge = xform1 c_th2i_getbinlowedge
  getBinWidth = xform1 c_th2i_getbinwidth
  getCellContent = xform2 c_th2i_getcellcontent
  getCellError = xform2 c_th2i_getcellerror
  scale = xform2 c_th2i_scale
  setAxisColor = xform2 c_th2i_setaxiscolor
  setAxisRange = xform3 c_th2i_setaxisrange
  setBarOffset = xform1 c_th2i_setbaroffset
  setBarWidth = xform1 c_th2i_setbarwidth
  setBinContent1 = xform2 c_th2i_setbincontent1
  setBinContent2 = xform3 c_th2i_setbincontent2
  setBinContent3 = xform4 c_th2i_setbincontent3
  setBinError1 = xform2 c_th2i_setbinerror1
  setBinError2 = xform3 c_th2i_setbinerror2
  setBinError3 = xform4 c_th2i_setbinerror3
  setBins1 = xform2 c_th2i_setbins1
  setBins2 = xform4 c_th2i_setbins2
  setBins3 = xform6 c_th2i_setbins3
  setMaximum = xform1 c_th2i_setmaximum
  setMinimum = xform1 c_th2i_setminimum
  setXTitle = xform1 c_th2i_setxtitle
  setYTitle = xform1 c_th2i_setytitle
  setZTitle = xform1 c_th2i_setztitle

instance ITH1 TH2F where
  add = xform2 c_th2f_add
  addBinContent = xform2 c_th2f_addbincontent
  chi2Test = xform3 c_th2f_chi2test
  computeIntegral = xform0 c_th2f_computeintegral
  directoryAutoAdd = xform1 c_th2f_directoryautoadd
  distancetoPrimitive = xform2 c_th2f_distancetoprimitive
  divide = xform5 c_th2f_divide
  drawCopy = xform1 c_th2f_drawcopy
  drawNormalized = xform2 c_th2f_drawnormalized
  drawPanel = xform0 c_th2f_drawpanel
  bufferEmpty = xform1 c_th2f_bufferempty
  eval = xform2 c_th2f_eval
  executeEvent = xform3 c_th2f_executeevent
  fFT = xform2 c_th2f_fft
  fill1 = xform1 c_th2f_fill1
  fillN = xform4 c_th2f_filln
  fillRandom = xform2 c_th2f_fillrandom
  findBin = xform3 c_th2f_findbin
  findFixBin = xform3 c_th2f_findfixbin
  findFirstBinAbove = xform2 c_th2f_findfirstbinabove
  findLastBinAbove = xform2 c_th2f_findlastbinabove
  fitPanel = xform0 c_th2f_fitpanel
  getNdivisions = xform1 c_th2f_getndivisions
  getAxisColor = xform1 c_th2f_getaxiscolor
  getLabelColor = xform1 c_th2f_getlabelcolor
  getLabelFont = xform1 c_th2f_getlabelfont
  getLabelOffset = xform1 c_th2f_getlabeloffset
  getLabelSize = xform1 c_th2f_getlabelsize
  getTitleFont = xform1 c_th2f_gettitlefont
  getTitleOffset = xform1 c_th2f_gettitleoffset
  getTitleSize = xform1 c_th2f_gettitlesize
  getTickLength = xform1 c_th2f_getticklength
  getBarOffset = xform0 c_th2f_getbaroffset
  getBarWidth = xform0 c_th2f_getbarwidth
  getContour = xform1 c_th2f_getcontour
  getContourLevel = xform1 c_th2f_getcontourlevel
  getContourLevelPad = xform1 c_th2f_getcontourlevelpad
  getBin = xform3 c_th2f_getbin
  getBinCenter = xform1 c_th2f_getbincenter
  getBinContent1 = xform1 c_th2f_getbincontent1
  getBinContent2 = xform2 c_th2f_getbincontent2
  getBinContent3 = xform3 c_th2f_getbincontent3
  getBinError1 = xform1 c_th2f_getbinerror1
  getBinError2 = xform2 c_th2f_getbinerror2
  getBinError3 = xform3 c_th2f_getbinerror3
  getBinLowEdge = xform1 c_th2f_getbinlowedge
  getBinWidth = xform1 c_th2f_getbinwidth
  getCellContent = xform2 c_th2f_getcellcontent
  getCellError = xform2 c_th2f_getcellerror
  scale = xform2 c_th2f_scale
  setAxisColor = xform2 c_th2f_setaxiscolor
  setAxisRange = xform3 c_th2f_setaxisrange
  setBarOffset = xform1 c_th2f_setbaroffset
  setBarWidth = xform1 c_th2f_setbarwidth
  setBinContent1 = xform2 c_th2f_setbincontent1
  setBinContent2 = xform3 c_th2f_setbincontent2
  setBinContent3 = xform4 c_th2f_setbincontent3
  setBinError1 = xform2 c_th2f_setbinerror1
  setBinError2 = xform3 c_th2f_setbinerror2
  setBinError3 = xform4 c_th2f_setbinerror3
  setBins1 = xform2 c_th2f_setbins1
  setBins2 = xform4 c_th2f_setbins2
  setBins3 = xform6 c_th2f_setbins3
  setMaximum = xform1 c_th2f_setmaximum
  setMinimum = xform1 c_th2f_setminimum
  setXTitle = xform1 c_th2f_setxtitle
  setYTitle = xform1 c_th2f_setytitle
  setZTitle = xform1 c_th2f_setztitle

instance ITH1 TH2D where
  add = xform2 c_th2d_add
  addBinContent = xform2 c_th2d_addbincontent
  chi2Test = xform3 c_th2d_chi2test
  computeIntegral = xform0 c_th2d_computeintegral
  directoryAutoAdd = xform1 c_th2d_directoryautoadd
  distancetoPrimitive = xform2 c_th2d_distancetoprimitive
  divide = xform5 c_th2d_divide
  drawCopy = xform1 c_th2d_drawcopy
  drawNormalized = xform2 c_th2d_drawnormalized
  drawPanel = xform0 c_th2d_drawpanel
  bufferEmpty = xform1 c_th2d_bufferempty
  eval = xform2 c_th2d_eval
  executeEvent = xform3 c_th2d_executeevent
  fFT = xform2 c_th2d_fft
  fill1 = xform1 c_th2d_fill1
  fillN = xform4 c_th2d_filln
  fillRandom = xform2 c_th2d_fillrandom
  findBin = xform3 c_th2d_findbin
  findFixBin = xform3 c_th2d_findfixbin
  findFirstBinAbove = xform2 c_th2d_findfirstbinabove
  findLastBinAbove = xform2 c_th2d_findlastbinabove
  fitPanel = xform0 c_th2d_fitpanel
  getNdivisions = xform1 c_th2d_getndivisions
  getAxisColor = xform1 c_th2d_getaxiscolor
  getLabelColor = xform1 c_th2d_getlabelcolor
  getLabelFont = xform1 c_th2d_getlabelfont
  getLabelOffset = xform1 c_th2d_getlabeloffset
  getLabelSize = xform1 c_th2d_getlabelsize
  getTitleFont = xform1 c_th2d_gettitlefont
  getTitleOffset = xform1 c_th2d_gettitleoffset
  getTitleSize = xform1 c_th2d_gettitlesize
  getTickLength = xform1 c_th2d_getticklength
  getBarOffset = xform0 c_th2d_getbaroffset
  getBarWidth = xform0 c_th2d_getbarwidth
  getContour = xform1 c_th2d_getcontour
  getContourLevel = xform1 c_th2d_getcontourlevel
  getContourLevelPad = xform1 c_th2d_getcontourlevelpad
  getBin = xform3 c_th2d_getbin
  getBinCenter = xform1 c_th2d_getbincenter
  getBinContent1 = xform1 c_th2d_getbincontent1
  getBinContent2 = xform2 c_th2d_getbincontent2
  getBinContent3 = xform3 c_th2d_getbincontent3
  getBinError1 = xform1 c_th2d_getbinerror1
  getBinError2 = xform2 c_th2d_getbinerror2
  getBinError3 = xform3 c_th2d_getbinerror3
  getBinLowEdge = xform1 c_th2d_getbinlowedge
  getBinWidth = xform1 c_th2d_getbinwidth
  getCellContent = xform2 c_th2d_getcellcontent
  getCellError = xform2 c_th2d_getcellerror
  scale = xform2 c_th2d_scale
  setAxisColor = xform2 c_th2d_setaxiscolor
  setAxisRange = xform3 c_th2d_setaxisrange
  setBarOffset = xform1 c_th2d_setbaroffset
  setBarWidth = xform1 c_th2d_setbarwidth
  setBinContent1 = xform2 c_th2d_setbincontent1
  setBinContent2 = xform3 c_th2d_setbincontent2
  setBinContent3 = xform4 c_th2d_setbincontent3
  setBinError1 = xform2 c_th2d_setbinerror1
  setBinError2 = xform3 c_th2d_setbinerror2
  setBinError3 = xform4 c_th2d_setbinerror3
  setBins1 = xform2 c_th2d_setbins1
  setBins2 = xform4 c_th2d_setbins2
  setBins3 = xform6 c_th2d_setbins3
  setMaximum = xform1 c_th2d_setmaximum
  setMinimum = xform1 c_th2d_setminimum
  setXTitle = xform1 c_th2d_setxtitle
  setYTitle = xform1 c_th2d_setytitle
  setZTitle = xform1 c_th2d_setztitle

instance ITH1 TH2C where
  add = xform2 c_th2c_add
  addBinContent = xform2 c_th2c_addbincontent
  chi2Test = xform3 c_th2c_chi2test
  computeIntegral = xform0 c_th2c_computeintegral
  directoryAutoAdd = xform1 c_th2c_directoryautoadd
  distancetoPrimitive = xform2 c_th2c_distancetoprimitive
  divide = xform5 c_th2c_divide
  drawCopy = xform1 c_th2c_drawcopy
  drawNormalized = xform2 c_th2c_drawnormalized
  drawPanel = xform0 c_th2c_drawpanel
  bufferEmpty = xform1 c_th2c_bufferempty
  eval = xform2 c_th2c_eval
  executeEvent = xform3 c_th2c_executeevent
  fFT = xform2 c_th2c_fft
  fill1 = xform1 c_th2c_fill1
  fillN = xform4 c_th2c_filln
  fillRandom = xform2 c_th2c_fillrandom
  findBin = xform3 c_th2c_findbin
  findFixBin = xform3 c_th2c_findfixbin
  findFirstBinAbove = xform2 c_th2c_findfirstbinabove
  findLastBinAbove = xform2 c_th2c_findlastbinabove
  fitPanel = xform0 c_th2c_fitpanel
  getNdivisions = xform1 c_th2c_getndivisions
  getAxisColor = xform1 c_th2c_getaxiscolor
  getLabelColor = xform1 c_th2c_getlabelcolor
  getLabelFont = xform1 c_th2c_getlabelfont
  getLabelOffset = xform1 c_th2c_getlabeloffset
  getLabelSize = xform1 c_th2c_getlabelsize
  getTitleFont = xform1 c_th2c_gettitlefont
  getTitleOffset = xform1 c_th2c_gettitleoffset
  getTitleSize = xform1 c_th2c_gettitlesize
  getTickLength = xform1 c_th2c_getticklength
  getBarOffset = xform0 c_th2c_getbaroffset
  getBarWidth = xform0 c_th2c_getbarwidth
  getContour = xform1 c_th2c_getcontour
  getContourLevel = xform1 c_th2c_getcontourlevel
  getContourLevelPad = xform1 c_th2c_getcontourlevelpad
  getBin = xform3 c_th2c_getbin
  getBinCenter = xform1 c_th2c_getbincenter
  getBinContent1 = xform1 c_th2c_getbincontent1
  getBinContent2 = xform2 c_th2c_getbincontent2
  getBinContent3 = xform3 c_th2c_getbincontent3
  getBinError1 = xform1 c_th2c_getbinerror1
  getBinError2 = xform2 c_th2c_getbinerror2
  getBinError3 = xform3 c_th2c_getbinerror3
  getBinLowEdge = xform1 c_th2c_getbinlowedge
  getBinWidth = xform1 c_th2c_getbinwidth
  getCellContent = xform2 c_th2c_getcellcontent
  getCellError = xform2 c_th2c_getcellerror
  scale = xform2 c_th2c_scale
  setAxisColor = xform2 c_th2c_setaxiscolor
  setAxisRange = xform3 c_th2c_setaxisrange
  setBarOffset = xform1 c_th2c_setbaroffset
  setBarWidth = xform1 c_th2c_setbarwidth
  setBinContent1 = xform2 c_th2c_setbincontent1
  setBinContent2 = xform3 c_th2c_setbincontent2
  setBinContent3 = xform4 c_th2c_setbincontent3
  setBinError1 = xform2 c_th2c_setbinerror1
  setBinError2 = xform3 c_th2c_setbinerror2
  setBinError3 = xform4 c_th2c_setbinerror3
  setBins1 = xform2 c_th2c_setbins1
  setBins2 = xform4 c_th2c_setbins2
  setBins3 = xform6 c_th2c_setbins3
  setMaximum = xform1 c_th2c_setmaximum
  setMinimum = xform1 c_th2c_setminimum
  setXTitle = xform1 c_th2c_setxtitle
  setYTitle = xform1 c_th2c_setytitle
  setZTitle = xform1 c_th2c_setztitle

instance ITH1 TH1S where
  add = xform2 c_th1s_add
  addBinContent = xform2 c_th1s_addbincontent
  chi2Test = xform3 c_th1s_chi2test
  computeIntegral = xform0 c_th1s_computeintegral
  directoryAutoAdd = xform1 c_th1s_directoryautoadd
  distancetoPrimitive = xform2 c_th1s_distancetoprimitive
  divide = xform5 c_th1s_divide
  drawCopy = xform1 c_th1s_drawcopy
  drawNormalized = xform2 c_th1s_drawnormalized
  drawPanel = xform0 c_th1s_drawpanel
  bufferEmpty = xform1 c_th1s_bufferempty
  eval = xform2 c_th1s_eval
  executeEvent = xform3 c_th1s_executeevent
  fFT = xform2 c_th1s_fft
  fill1 = xform1 c_th1s_fill1
  fillN = xform4 c_th1s_filln
  fillRandom = xform2 c_th1s_fillrandom
  findBin = xform3 c_th1s_findbin
  findFixBin = xform3 c_th1s_findfixbin
  findFirstBinAbove = xform2 c_th1s_findfirstbinabove
  findLastBinAbove = xform2 c_th1s_findlastbinabove
  fitPanel = xform0 c_th1s_fitpanel
  getNdivisions = xform1 c_th1s_getndivisions
  getAxisColor = xform1 c_th1s_getaxiscolor
  getLabelColor = xform1 c_th1s_getlabelcolor
  getLabelFont = xform1 c_th1s_getlabelfont
  getLabelOffset = xform1 c_th1s_getlabeloffset
  getLabelSize = xform1 c_th1s_getlabelsize
  getTitleFont = xform1 c_th1s_gettitlefont
  getTitleOffset = xform1 c_th1s_gettitleoffset
  getTitleSize = xform1 c_th1s_gettitlesize
  getTickLength = xform1 c_th1s_getticklength
  getBarOffset = xform0 c_th1s_getbaroffset
  getBarWidth = xform0 c_th1s_getbarwidth
  getContour = xform1 c_th1s_getcontour
  getContourLevel = xform1 c_th1s_getcontourlevel
  getContourLevelPad = xform1 c_th1s_getcontourlevelpad
  getBin = xform3 c_th1s_getbin
  getBinCenter = xform1 c_th1s_getbincenter
  getBinContent1 = xform1 c_th1s_getbincontent1
  getBinContent2 = xform2 c_th1s_getbincontent2
  getBinContent3 = xform3 c_th1s_getbincontent3
  getBinError1 = xform1 c_th1s_getbinerror1
  getBinError2 = xform2 c_th1s_getbinerror2
  getBinError3 = xform3 c_th1s_getbinerror3
  getBinLowEdge = xform1 c_th1s_getbinlowedge
  getBinWidth = xform1 c_th1s_getbinwidth
  getCellContent = xform2 c_th1s_getcellcontent
  getCellError = xform2 c_th1s_getcellerror
  scale = xform2 c_th1s_scale
  setAxisColor = xform2 c_th1s_setaxiscolor
  setAxisRange = xform3 c_th1s_setaxisrange
  setBarOffset = xform1 c_th1s_setbaroffset
  setBarWidth = xform1 c_th1s_setbarwidth
  setBinContent1 = xform2 c_th1s_setbincontent1
  setBinContent2 = xform3 c_th1s_setbincontent2
  setBinContent3 = xform4 c_th1s_setbincontent3
  setBinError1 = xform2 c_th1s_setbinerror1
  setBinError2 = xform3 c_th1s_setbinerror2
  setBinError3 = xform4 c_th1s_setbinerror3
  setBins1 = xform2 c_th1s_setbins1
  setBins2 = xform4 c_th1s_setbins2
  setBins3 = xform6 c_th1s_setbins3
  setMaximum = xform1 c_th1s_setmaximum
  setMinimum = xform1 c_th1s_setminimum
  setXTitle = xform1 c_th1s_setxtitle
  setYTitle = xform1 c_th1s_setytitle
  setZTitle = xform1 c_th1s_setztitle

instance ITH1 TH1I where
  add = xform2 c_th1i_add
  addBinContent = xform2 c_th1i_addbincontent
  chi2Test = xform3 c_th1i_chi2test
  computeIntegral = xform0 c_th1i_computeintegral
  directoryAutoAdd = xform1 c_th1i_directoryautoadd
  distancetoPrimitive = xform2 c_th1i_distancetoprimitive
  divide = xform5 c_th1i_divide
  drawCopy = xform1 c_th1i_drawcopy
  drawNormalized = xform2 c_th1i_drawnormalized
  drawPanel = xform0 c_th1i_drawpanel
  bufferEmpty = xform1 c_th1i_bufferempty
  eval = xform2 c_th1i_eval
  executeEvent = xform3 c_th1i_executeevent
  fFT = xform2 c_th1i_fft
  fill1 = xform1 c_th1i_fill1
  fillN = xform4 c_th1i_filln
  fillRandom = xform2 c_th1i_fillrandom
  findBin = xform3 c_th1i_findbin
  findFixBin = xform3 c_th1i_findfixbin
  findFirstBinAbove = xform2 c_th1i_findfirstbinabove
  findLastBinAbove = xform2 c_th1i_findlastbinabove
  fitPanel = xform0 c_th1i_fitpanel
  getNdivisions = xform1 c_th1i_getndivisions
  getAxisColor = xform1 c_th1i_getaxiscolor
  getLabelColor = xform1 c_th1i_getlabelcolor
  getLabelFont = xform1 c_th1i_getlabelfont
  getLabelOffset = xform1 c_th1i_getlabeloffset
  getLabelSize = xform1 c_th1i_getlabelsize
  getTitleFont = xform1 c_th1i_gettitlefont
  getTitleOffset = xform1 c_th1i_gettitleoffset
  getTitleSize = xform1 c_th1i_gettitlesize
  getTickLength = xform1 c_th1i_getticklength
  getBarOffset = xform0 c_th1i_getbaroffset
  getBarWidth = xform0 c_th1i_getbarwidth
  getContour = xform1 c_th1i_getcontour
  getContourLevel = xform1 c_th1i_getcontourlevel
  getContourLevelPad = xform1 c_th1i_getcontourlevelpad
  getBin = xform3 c_th1i_getbin
  getBinCenter = xform1 c_th1i_getbincenter
  getBinContent1 = xform1 c_th1i_getbincontent1
  getBinContent2 = xform2 c_th1i_getbincontent2
  getBinContent3 = xform3 c_th1i_getbincontent3
  getBinError1 = xform1 c_th1i_getbinerror1
  getBinError2 = xform2 c_th1i_getbinerror2
  getBinError3 = xform3 c_th1i_getbinerror3
  getBinLowEdge = xform1 c_th1i_getbinlowedge
  getBinWidth = xform1 c_th1i_getbinwidth
  getCellContent = xform2 c_th1i_getcellcontent
  getCellError = xform2 c_th1i_getcellerror
  scale = xform2 c_th1i_scale
  setAxisColor = xform2 c_th1i_setaxiscolor
  setAxisRange = xform3 c_th1i_setaxisrange
  setBarOffset = xform1 c_th1i_setbaroffset
  setBarWidth = xform1 c_th1i_setbarwidth
  setBinContent1 = xform2 c_th1i_setbincontent1
  setBinContent2 = xform3 c_th1i_setbincontent2
  setBinContent3 = xform4 c_th1i_setbincontent3
  setBinError1 = xform2 c_th1i_setbinerror1
  setBinError2 = xform3 c_th1i_setbinerror2
  setBinError3 = xform4 c_th1i_setbinerror3
  setBins1 = xform2 c_th1i_setbins1
  setBins2 = xform4 c_th1i_setbins2
  setBins3 = xform6 c_th1i_setbins3
  setMaximum = xform1 c_th1i_setmaximum
  setMinimum = xform1 c_th1i_setminimum
  setXTitle = xform1 c_th1i_setxtitle
  setYTitle = xform1 c_th1i_setytitle
  setZTitle = xform1 c_th1i_setztitle

instance ITH1 TH1F where
  add = xform2 c_th1f_add
  addBinContent = xform2 c_th1f_addbincontent
  chi2Test = xform3 c_th1f_chi2test
  computeIntegral = xform0 c_th1f_computeintegral
  directoryAutoAdd = xform1 c_th1f_directoryautoadd
  distancetoPrimitive = xform2 c_th1f_distancetoprimitive
  divide = xform5 c_th1f_divide
  drawCopy = xform1 c_th1f_drawcopy
  drawNormalized = xform2 c_th1f_drawnormalized
  drawPanel = xform0 c_th1f_drawpanel
  bufferEmpty = xform1 c_th1f_bufferempty
  eval = xform2 c_th1f_eval
  executeEvent = xform3 c_th1f_executeevent
  fFT = xform2 c_th1f_fft
  fill1 = xform1 c_th1f_fill1
  fillN = xform4 c_th1f_filln
  fillRandom = xform2 c_th1f_fillrandom
  findBin = xform3 c_th1f_findbin
  findFixBin = xform3 c_th1f_findfixbin
  findFirstBinAbove = xform2 c_th1f_findfirstbinabove
  findLastBinAbove = xform2 c_th1f_findlastbinabove
  fitPanel = xform0 c_th1f_fitpanel
  getNdivisions = xform1 c_th1f_getndivisions
  getAxisColor = xform1 c_th1f_getaxiscolor
  getLabelColor = xform1 c_th1f_getlabelcolor
  getLabelFont = xform1 c_th1f_getlabelfont
  getLabelOffset = xform1 c_th1f_getlabeloffset
  getLabelSize = xform1 c_th1f_getlabelsize
  getTitleFont = xform1 c_th1f_gettitlefont
  getTitleOffset = xform1 c_th1f_gettitleoffset
  getTitleSize = xform1 c_th1f_gettitlesize
  getTickLength = xform1 c_th1f_getticklength
  getBarOffset = xform0 c_th1f_getbaroffset
  getBarWidth = xform0 c_th1f_getbarwidth
  getContour = xform1 c_th1f_getcontour
  getContourLevel = xform1 c_th1f_getcontourlevel
  getContourLevelPad = xform1 c_th1f_getcontourlevelpad
  getBin = xform3 c_th1f_getbin
  getBinCenter = xform1 c_th1f_getbincenter
  getBinContent1 = xform1 c_th1f_getbincontent1
  getBinContent2 = xform2 c_th1f_getbincontent2
  getBinContent3 = xform3 c_th1f_getbincontent3
  getBinError1 = xform1 c_th1f_getbinerror1
  getBinError2 = xform2 c_th1f_getbinerror2
  getBinError3 = xform3 c_th1f_getbinerror3
  getBinLowEdge = xform1 c_th1f_getbinlowedge
  getBinWidth = xform1 c_th1f_getbinwidth
  getCellContent = xform2 c_th1f_getcellcontent
  getCellError = xform2 c_th1f_getcellerror
  scale = xform2 c_th1f_scale
  setAxisColor = xform2 c_th1f_setaxiscolor
  setAxisRange = xform3 c_th1f_setaxisrange
  setBarOffset = xform1 c_th1f_setbaroffset
  setBarWidth = xform1 c_th1f_setbarwidth
  setBinContent1 = xform2 c_th1f_setbincontent1
  setBinContent2 = xform3 c_th1f_setbincontent2
  setBinContent3 = xform4 c_th1f_setbincontent3
  setBinError1 = xform2 c_th1f_setbinerror1
  setBinError2 = xform3 c_th1f_setbinerror2
  setBinError3 = xform4 c_th1f_setbinerror3
  setBins1 = xform2 c_th1f_setbins1
  setBins2 = xform4 c_th1f_setbins2
  setBins3 = xform6 c_th1f_setbins3
  setMaximum = xform1 c_th1f_setmaximum
  setMinimum = xform1 c_th1f_setminimum
  setXTitle = xform1 c_th1f_setxtitle
  setYTitle = xform1 c_th1f_setytitle
  setZTitle = xform1 c_th1f_setztitle

instance ITH1 TH1D where
  add = xform2 c_th1d_add
  addBinContent = xform2 c_th1d_addbincontent
  chi2Test = xform3 c_th1d_chi2test
  computeIntegral = xform0 c_th1d_computeintegral
  directoryAutoAdd = xform1 c_th1d_directoryautoadd
  distancetoPrimitive = xform2 c_th1d_distancetoprimitive
  divide = xform5 c_th1d_divide
  drawCopy = xform1 c_th1d_drawcopy
  drawNormalized = xform2 c_th1d_drawnormalized
  drawPanel = xform0 c_th1d_drawpanel
  bufferEmpty = xform1 c_th1d_bufferempty
  eval = xform2 c_th1d_eval
  executeEvent = xform3 c_th1d_executeevent
  fFT = xform2 c_th1d_fft
  fill1 = xform1 c_th1d_fill1
  fillN = xform4 c_th1d_filln
  fillRandom = xform2 c_th1d_fillrandom
  findBin = xform3 c_th1d_findbin
  findFixBin = xform3 c_th1d_findfixbin
  findFirstBinAbove = xform2 c_th1d_findfirstbinabove
  findLastBinAbove = xform2 c_th1d_findlastbinabove
  fitPanel = xform0 c_th1d_fitpanel
  getNdivisions = xform1 c_th1d_getndivisions
  getAxisColor = xform1 c_th1d_getaxiscolor
  getLabelColor = xform1 c_th1d_getlabelcolor
  getLabelFont = xform1 c_th1d_getlabelfont
  getLabelOffset = xform1 c_th1d_getlabeloffset
  getLabelSize = xform1 c_th1d_getlabelsize
  getTitleFont = xform1 c_th1d_gettitlefont
  getTitleOffset = xform1 c_th1d_gettitleoffset
  getTitleSize = xform1 c_th1d_gettitlesize
  getTickLength = xform1 c_th1d_getticklength
  getBarOffset = xform0 c_th1d_getbaroffset
  getBarWidth = xform0 c_th1d_getbarwidth
  getContour = xform1 c_th1d_getcontour
  getContourLevel = xform1 c_th1d_getcontourlevel
  getContourLevelPad = xform1 c_th1d_getcontourlevelpad
  getBin = xform3 c_th1d_getbin
  getBinCenter = xform1 c_th1d_getbincenter
  getBinContent1 = xform1 c_th1d_getbincontent1
  getBinContent2 = xform2 c_th1d_getbincontent2
  getBinContent3 = xform3 c_th1d_getbincontent3
  getBinError1 = xform1 c_th1d_getbinerror1
  getBinError2 = xform2 c_th1d_getbinerror2
  getBinError3 = xform3 c_th1d_getbinerror3
  getBinLowEdge = xform1 c_th1d_getbinlowedge
  getBinWidth = xform1 c_th1d_getbinwidth
  getCellContent = xform2 c_th1d_getcellcontent
  getCellError = xform2 c_th1d_getcellerror
  scale = xform2 c_th1d_scale
  setAxisColor = xform2 c_th1d_setaxiscolor
  setAxisRange = xform3 c_th1d_setaxisrange
  setBarOffset = xform1 c_th1d_setbaroffset
  setBarWidth = xform1 c_th1d_setbarwidth
  setBinContent1 = xform2 c_th1d_setbincontent1
  setBinContent2 = xform3 c_th1d_setbincontent2
  setBinContent3 = xform4 c_th1d_setbincontent3
  setBinError1 = xform2 c_th1d_setbinerror1
  setBinError2 = xform3 c_th1d_setbinerror2
  setBinError3 = xform4 c_th1d_setbinerror3
  setBins1 = xform2 c_th1d_setbins1
  setBins2 = xform4 c_th1d_setbins2
  setBins3 = xform6 c_th1d_setbins3
  setMaximum = xform1 c_th1d_setmaximum
  setMinimum = xform1 c_th1d_setminimum
  setXTitle = xform1 c_th1d_setxtitle
  setYTitle = xform1 c_th1d_setytitle
  setZTitle = xform1 c_th1d_setztitle

instance ITH1 TH1C where
  add = xform2 c_th1c_add
  addBinContent = xform2 c_th1c_addbincontent
  chi2Test = xform3 c_th1c_chi2test
  computeIntegral = xform0 c_th1c_computeintegral
  directoryAutoAdd = xform1 c_th1c_directoryautoadd
  distancetoPrimitive = xform2 c_th1c_distancetoprimitive
  divide = xform5 c_th1c_divide
  drawCopy = xform1 c_th1c_drawcopy
  drawNormalized = xform2 c_th1c_drawnormalized
  drawPanel = xform0 c_th1c_drawpanel
  bufferEmpty = xform1 c_th1c_bufferempty
  eval = xform2 c_th1c_eval
  executeEvent = xform3 c_th1c_executeevent
  fFT = xform2 c_th1c_fft
  fill1 = xform1 c_th1c_fill1
  fillN = xform4 c_th1c_filln
  fillRandom = xform2 c_th1c_fillrandom
  findBin = xform3 c_th1c_findbin
  findFixBin = xform3 c_th1c_findfixbin
  findFirstBinAbove = xform2 c_th1c_findfirstbinabove
  findLastBinAbove = xform2 c_th1c_findlastbinabove
  fitPanel = xform0 c_th1c_fitpanel
  getNdivisions = xform1 c_th1c_getndivisions
  getAxisColor = xform1 c_th1c_getaxiscolor
  getLabelColor = xform1 c_th1c_getlabelcolor
  getLabelFont = xform1 c_th1c_getlabelfont
  getLabelOffset = xform1 c_th1c_getlabeloffset
  getLabelSize = xform1 c_th1c_getlabelsize
  getTitleFont = xform1 c_th1c_gettitlefont
  getTitleOffset = xform1 c_th1c_gettitleoffset
  getTitleSize = xform1 c_th1c_gettitlesize
  getTickLength = xform1 c_th1c_getticklength
  getBarOffset = xform0 c_th1c_getbaroffset
  getBarWidth = xform0 c_th1c_getbarwidth
  getContour = xform1 c_th1c_getcontour
  getContourLevel = xform1 c_th1c_getcontourlevel
  getContourLevelPad = xform1 c_th1c_getcontourlevelpad
  getBin = xform3 c_th1c_getbin
  getBinCenter = xform1 c_th1c_getbincenter
  getBinContent1 = xform1 c_th1c_getbincontent1
  getBinContent2 = xform2 c_th1c_getbincontent2
  getBinContent3 = xform3 c_th1c_getbincontent3
  getBinError1 = xform1 c_th1c_getbinerror1
  getBinError2 = xform2 c_th1c_getbinerror2
  getBinError3 = xform3 c_th1c_getbinerror3
  getBinLowEdge = xform1 c_th1c_getbinlowedge
  getBinWidth = xform1 c_th1c_getbinwidth
  getCellContent = xform2 c_th1c_getcellcontent
  getCellError = xform2 c_th1c_getcellerror
  scale = xform2 c_th1c_scale
  setAxisColor = xform2 c_th1c_setaxiscolor
  setAxisRange = xform3 c_th1c_setaxisrange
  setBarOffset = xform1 c_th1c_setbaroffset
  setBarWidth = xform1 c_th1c_setbarwidth
  setBinContent1 = xform2 c_th1c_setbincontent1
  setBinContent2 = xform3 c_th1c_setbincontent2
  setBinContent3 = xform4 c_th1c_setbincontent3
  setBinError1 = xform2 c_th1c_setbinerror1
  setBinError2 = xform3 c_th1c_setbinerror2
  setBinError3 = xform4 c_th1c_setbinerror3
  setBins1 = xform2 c_th1c_setbins1
  setBins2 = xform4 c_th1c_setbins2
  setBins3 = xform6 c_th1c_setbins3
  setMaximum = xform1 c_th1c_setmaximum
  setMinimum = xform1 c_th1c_setminimum
  setXTitle = xform1 c_th1c_setxtitle
  setYTitle = xform1 c_th1c_setytitle
  setZTitle = xform1 c_th1c_setztitle

instance ITH1 TH3 where
  add = xform2 c_th3_add
  addBinContent = xform2 c_th3_addbincontent
  chi2Test = xform3 c_th3_chi2test
  computeIntegral = xform0 c_th3_computeintegral
  directoryAutoAdd = xform1 c_th3_directoryautoadd
  distancetoPrimitive = xform2 c_th3_distancetoprimitive
  divide = xform5 c_th3_divide
  drawCopy = xform1 c_th3_drawcopy
  drawNormalized = xform2 c_th3_drawnormalized
  drawPanel = xform0 c_th3_drawpanel
  bufferEmpty = xform1 c_th3_bufferempty
  eval = xform2 c_th3_eval
  executeEvent = xform3 c_th3_executeevent
  fFT = xform2 c_th3_fft
  fill1 = xform1 c_th3_fill1
  fillN = xform4 c_th3_filln
  fillRandom = xform2 c_th3_fillrandom
  findBin = xform3 c_th3_findbin
  findFixBin = xform3 c_th3_findfixbin
  findFirstBinAbove = xform2 c_th3_findfirstbinabove
  findLastBinAbove = xform2 c_th3_findlastbinabove
  fitPanel = xform0 c_th3_fitpanel
  getNdivisions = xform1 c_th3_getndivisions
  getAxisColor = xform1 c_th3_getaxiscolor
  getLabelColor = xform1 c_th3_getlabelcolor
  getLabelFont = xform1 c_th3_getlabelfont
  getLabelOffset = xform1 c_th3_getlabeloffset
  getLabelSize = xform1 c_th3_getlabelsize
  getTitleFont = xform1 c_th3_gettitlefont
  getTitleOffset = xform1 c_th3_gettitleoffset
  getTitleSize = xform1 c_th3_gettitlesize
  getTickLength = xform1 c_th3_getticklength
  getBarOffset = xform0 c_th3_getbaroffset
  getBarWidth = xform0 c_th3_getbarwidth
  getContour = xform1 c_th3_getcontour
  getContourLevel = xform1 c_th3_getcontourlevel
  getContourLevelPad = xform1 c_th3_getcontourlevelpad
  getBin = xform3 c_th3_getbin
  getBinCenter = xform1 c_th3_getbincenter
  getBinContent1 = xform1 c_th3_getbincontent1
  getBinContent2 = xform2 c_th3_getbincontent2
  getBinContent3 = xform3 c_th3_getbincontent3
  getBinError1 = xform1 c_th3_getbinerror1
  getBinError2 = xform2 c_th3_getbinerror2
  getBinError3 = xform3 c_th3_getbinerror3
  getBinLowEdge = xform1 c_th3_getbinlowedge
  getBinWidth = xform1 c_th3_getbinwidth
  getCellContent = xform2 c_th3_getcellcontent
  getCellError = xform2 c_th3_getcellerror
  scale = xform2 c_th3_scale
  setAxisColor = xform2 c_th3_setaxiscolor
  setAxisRange = xform3 c_th3_setaxisrange
  setBarOffset = xform1 c_th3_setbaroffset
  setBarWidth = xform1 c_th3_setbarwidth
  setBinContent1 = xform2 c_th3_setbincontent1
  setBinContent2 = xform3 c_th3_setbincontent2
  setBinContent3 = xform4 c_th3_setbincontent3
  setBinError1 = xform2 c_th3_setbinerror1
  setBinError2 = xform3 c_th3_setbinerror2
  setBinError3 = xform4 c_th3_setbinerror3
  setBins1 = xform2 c_th3_setbins1
  setBins2 = xform4 c_th3_setbins2
  setBins3 = xform6 c_th3_setbins3
  setMaximum = xform1 c_th3_setmaximum
  setMinimum = xform1 c_th3_setminimum
  setXTitle = xform1 c_th3_setxtitle
  setYTitle = xform1 c_th3_setytitle
  setZTitle = xform1 c_th3_setztitle

instance ITH1 TH2 where
  add = xform2 c_th2_add
  addBinContent = xform2 c_th2_addbincontent
  chi2Test = xform3 c_th2_chi2test
  computeIntegral = xform0 c_th2_computeintegral
  directoryAutoAdd = xform1 c_th2_directoryautoadd
  distancetoPrimitive = xform2 c_th2_distancetoprimitive
  divide = xform5 c_th2_divide
  drawCopy = xform1 c_th2_drawcopy
  drawNormalized = xform2 c_th2_drawnormalized
  drawPanel = xform0 c_th2_drawpanel
  bufferEmpty = xform1 c_th2_bufferempty
  eval = xform2 c_th2_eval
  executeEvent = xform3 c_th2_executeevent
  fFT = xform2 c_th2_fft
  fill1 = xform1 c_th2_fill1
  fillN = xform4 c_th2_filln
  fillRandom = xform2 c_th2_fillrandom
  findBin = xform3 c_th2_findbin
  findFixBin = xform3 c_th2_findfixbin
  findFirstBinAbove = xform2 c_th2_findfirstbinabove
  findLastBinAbove = xform2 c_th2_findlastbinabove
  fitPanel = xform0 c_th2_fitpanel
  getNdivisions = xform1 c_th2_getndivisions
  getAxisColor = xform1 c_th2_getaxiscolor
  getLabelColor = xform1 c_th2_getlabelcolor
  getLabelFont = xform1 c_th2_getlabelfont
  getLabelOffset = xform1 c_th2_getlabeloffset
  getLabelSize = xform1 c_th2_getlabelsize
  getTitleFont = xform1 c_th2_gettitlefont
  getTitleOffset = xform1 c_th2_gettitleoffset
  getTitleSize = xform1 c_th2_gettitlesize
  getTickLength = xform1 c_th2_getticklength
  getBarOffset = xform0 c_th2_getbaroffset
  getBarWidth = xform0 c_th2_getbarwidth
  getContour = xform1 c_th2_getcontour
  getContourLevel = xform1 c_th2_getcontourlevel
  getContourLevelPad = xform1 c_th2_getcontourlevelpad
  getBin = xform3 c_th2_getbin
  getBinCenter = xform1 c_th2_getbincenter
  getBinContent1 = xform1 c_th2_getbincontent1
  getBinContent2 = xform2 c_th2_getbincontent2
  getBinContent3 = xform3 c_th2_getbincontent3
  getBinError1 = xform1 c_th2_getbinerror1
  getBinError2 = xform2 c_th2_getbinerror2
  getBinError3 = xform3 c_th2_getbinerror3
  getBinLowEdge = xform1 c_th2_getbinlowedge
  getBinWidth = xform1 c_th2_getbinwidth
  getCellContent = xform2 c_th2_getcellcontent
  getCellError = xform2 c_th2_getcellerror
  scale = xform2 c_th2_scale
  setAxisColor = xform2 c_th2_setaxiscolor
  setAxisRange = xform3 c_th2_setaxisrange
  setBarOffset = xform1 c_th2_setbaroffset
  setBarWidth = xform1 c_th2_setbarwidth
  setBinContent1 = xform2 c_th2_setbincontent1
  setBinContent2 = xform3 c_th2_setbincontent2
  setBinContent3 = xform4 c_th2_setbincontent3
  setBinError1 = xform2 c_th2_setbinerror1
  setBinError2 = xform3 c_th2_setbinerror2
  setBinError3 = xform4 c_th2_setbinerror3
  setBins1 = xform2 c_th2_setbins1
  setBins2 = xform4 c_th2_setbins2
  setBins3 = xform6 c_th2_setbins3
  setMaximum = xform1 c_th2_setmaximum
  setMinimum = xform1 c_th2_setminimum
  setXTitle = xform1 c_th2_setxtitle
  setYTitle = xform1 c_th2_setytitle
  setZTitle = xform1 c_th2_setztitle

instance ITH2 TH2S where
  fill2 = xform2 c_th2s_fill2
  fillRandom2 = xform2 c_th2s_fillrandom2
  findFirstBinAbove2 = xform2 c_th2s_findfirstbinabove2
  findLastBinAbove2 = xform2 c_th2s_findlastbinabove2
  fitSlicesX = xform6 c_th2s_fitslicesx
  fitSlicesY = xform6 c_th2s_fitslicesy
  getCorrelationFactor = xform2 c_th2s_getcorrelationfactor
  getCovariance = xform2 c_th2s_getcovariance
  getStats = xform1 c_th2s_getstats
  integral = xform5 c_th2s_integral
  interpolate = xform3 c_th2s_interpolate
  kolmogorovTest = xform2 c_th2s_kolmogorovtest
  rebinX = xform2 c_th2s_rebinx
  rebinY = xform2 c_th2s_rebiny
  rebin2D = xform3 c_th2s_rebin2d
  putStats = xform1 c_th2s_putstats
  reset = xform1 c_th2s_reset
  setShowProjectionX = xform1 c_th2s_setshowprojectionx
  setShowProjectionY = xform1 c_th2s_setshowprojectiony
  showBackground = xform2 c_th2s_showbackground
  showPeaks = xform3 c_th2s_showpeaks
  smooth = xform2 c_th2s_smooth

instance ITH2 TH2Poly where
  fill2 = xform2 c_th2poly_fill2
  fillRandom2 = xform2 c_th2poly_fillrandom2
  findFirstBinAbove2 = xform2 c_th2poly_findfirstbinabove2
  findLastBinAbove2 = xform2 c_th2poly_findlastbinabove2
  fitSlicesX = xform6 c_th2poly_fitslicesx
  fitSlicesY = xform6 c_th2poly_fitslicesy
  getCorrelationFactor = xform2 c_th2poly_getcorrelationfactor
  getCovariance = xform2 c_th2poly_getcovariance
  getStats = xform1 c_th2poly_getstats
  integral = xform5 c_th2poly_integral
  interpolate = xform3 c_th2poly_interpolate
  kolmogorovTest = xform2 c_th2poly_kolmogorovtest
  rebinX = xform2 c_th2poly_rebinx
  rebinY = xform2 c_th2poly_rebiny
  rebin2D = xform3 c_th2poly_rebin2d
  putStats = xform1 c_th2poly_putstats
  reset = xform1 c_th2poly_reset
  setShowProjectionX = xform1 c_th2poly_setshowprojectionx
  setShowProjectionY = xform1 c_th2poly_setshowprojectiony
  showBackground = xform2 c_th2poly_showbackground
  showPeaks = xform3 c_th2poly_showpeaks
  smooth = xform2 c_th2poly_smooth

instance ITH2 TH2I where
  fill2 = xform2 c_th2i_fill2
  fillRandom2 = xform2 c_th2i_fillrandom2
  findFirstBinAbove2 = xform2 c_th2i_findfirstbinabove2
  findLastBinAbove2 = xform2 c_th2i_findlastbinabove2
  fitSlicesX = xform6 c_th2i_fitslicesx
  fitSlicesY = xform6 c_th2i_fitslicesy
  getCorrelationFactor = xform2 c_th2i_getcorrelationfactor
  getCovariance = xform2 c_th2i_getcovariance
  getStats = xform1 c_th2i_getstats
  integral = xform5 c_th2i_integral
  interpolate = xform3 c_th2i_interpolate
  kolmogorovTest = xform2 c_th2i_kolmogorovtest
  rebinX = xform2 c_th2i_rebinx
  rebinY = xform2 c_th2i_rebiny
  rebin2D = xform3 c_th2i_rebin2d
  putStats = xform1 c_th2i_putstats
  reset = xform1 c_th2i_reset
  setShowProjectionX = xform1 c_th2i_setshowprojectionx
  setShowProjectionY = xform1 c_th2i_setshowprojectiony
  showBackground = xform2 c_th2i_showbackground
  showPeaks = xform3 c_th2i_showpeaks
  smooth = xform2 c_th2i_smooth

instance ITH2 TH2F where
  fill2 = xform2 c_th2f_fill2
  fillRandom2 = xform2 c_th2f_fillrandom2
  findFirstBinAbove2 = xform2 c_th2f_findfirstbinabove2
  findLastBinAbove2 = xform2 c_th2f_findlastbinabove2
  fitSlicesX = xform6 c_th2f_fitslicesx
  fitSlicesY = xform6 c_th2f_fitslicesy
  getCorrelationFactor = xform2 c_th2f_getcorrelationfactor
  getCovariance = xform2 c_th2f_getcovariance
  getStats = xform1 c_th2f_getstats
  integral = xform5 c_th2f_integral
  interpolate = xform3 c_th2f_interpolate
  kolmogorovTest = xform2 c_th2f_kolmogorovtest
  rebinX = xform2 c_th2f_rebinx
  rebinY = xform2 c_th2f_rebiny
  rebin2D = xform3 c_th2f_rebin2d
  putStats = xform1 c_th2f_putstats
  reset = xform1 c_th2f_reset
  setShowProjectionX = xform1 c_th2f_setshowprojectionx
  setShowProjectionY = xform1 c_th2f_setshowprojectiony
  showBackground = xform2 c_th2f_showbackground
  showPeaks = xform3 c_th2f_showpeaks
  smooth = xform2 c_th2f_smooth

instance ITH2 TH2D where
  fill2 = xform2 c_th2d_fill2
  fillRandom2 = xform2 c_th2d_fillrandom2
  findFirstBinAbove2 = xform2 c_th2d_findfirstbinabove2
  findLastBinAbove2 = xform2 c_th2d_findlastbinabove2
  fitSlicesX = xform6 c_th2d_fitslicesx
  fitSlicesY = xform6 c_th2d_fitslicesy
  getCorrelationFactor = xform2 c_th2d_getcorrelationfactor
  getCovariance = xform2 c_th2d_getcovariance
  getStats = xform1 c_th2d_getstats
  integral = xform5 c_th2d_integral
  interpolate = xform3 c_th2d_interpolate
  kolmogorovTest = xform2 c_th2d_kolmogorovtest
  rebinX = xform2 c_th2d_rebinx
  rebinY = xform2 c_th2d_rebiny
  rebin2D = xform3 c_th2d_rebin2d
  putStats = xform1 c_th2d_putstats
  reset = xform1 c_th2d_reset
  setShowProjectionX = xform1 c_th2d_setshowprojectionx
  setShowProjectionY = xform1 c_th2d_setshowprojectiony
  showBackground = xform2 c_th2d_showbackground
  showPeaks = xform3 c_th2d_showpeaks
  smooth = xform2 c_th2d_smooth

instance ITH2 TH2C where
  fill2 = xform2 c_th2c_fill2
  fillRandom2 = xform2 c_th2c_fillrandom2
  findFirstBinAbove2 = xform2 c_th2c_findfirstbinabove2
  findLastBinAbove2 = xform2 c_th2c_findlastbinabove2
  fitSlicesX = xform6 c_th2c_fitslicesx
  fitSlicesY = xform6 c_th2c_fitslicesy
  getCorrelationFactor = xform2 c_th2c_getcorrelationfactor
  getCovariance = xform2 c_th2c_getcovariance
  getStats = xform1 c_th2c_getstats
  integral = xform5 c_th2c_integral
  interpolate = xform3 c_th2c_interpolate
  kolmogorovTest = xform2 c_th2c_kolmogorovtest
  rebinX = xform2 c_th2c_rebinx
  rebinY = xform2 c_th2c_rebiny
  rebin2D = xform3 c_th2c_rebin2d
  putStats = xform1 c_th2c_putstats
  reset = xform1 c_th2c_reset
  setShowProjectionX = xform1 c_th2c_setshowprojectionx
  setShowProjectionY = xform1 c_th2c_setshowprojectiony
  showBackground = xform2 c_th2c_showbackground
  showPeaks = xform3 c_th2c_showpeaks
  smooth = xform2 c_th2c_smooth

instance ITH3 TH3S where

instance ITH3 TH3I where

instance ITH3 TH3F where

instance ITH3 TH3D where

instance ITH3 TH3C where

instance ITLine TGaxis where

instance ITLine TArrow where

instance ITNamed TKey where
  setTitle = xform1 c_tkey_settitle

instance ITNamed TRandom where
  setTitle = xform1 c_trandom_settitle

instance ITNamed TH3S where
  setTitle = xform1 c_th3s_settitle

instance ITNamed TH3I where
  setTitle = xform1 c_th3i_settitle

instance ITNamed TH3F where
  setTitle = xform1 c_th3f_settitle

instance ITNamed TH3D where
  setTitle = xform1 c_th3d_settitle

instance ITNamed TH3C where
  setTitle = xform1 c_th3c_settitle

instance ITNamed TH2S where
  setTitle = xform1 c_th2s_settitle

instance ITNamed TH2Poly where
  setTitle = xform1 c_th2poly_settitle

instance ITNamed TH2I where
  setTitle = xform1 c_th2i_settitle

instance ITNamed TH2F where
  setTitle = xform1 c_th2f_settitle

instance ITNamed TH2D where
  setTitle = xform1 c_th2d_settitle

instance ITNamed TH2C where
  setTitle = xform1 c_th2c_settitle

instance ITNamed TH1S where
  setTitle = xform1 c_th1s_settitle

instance ITNamed TH1I where
  setTitle = xform1 c_th1i_settitle

instance ITNamed TH1F where
  setTitle = xform1 c_th1f_settitle

instance ITNamed TH1D where
  setTitle = xform1 c_th1d_settitle

instance ITNamed TH1C where
  setTitle = xform1 c_th1c_settitle

instance ITNamed TH3 where
  setTitle = xform1 c_th3_settitle

instance ITNamed TH2 where
  setTitle = xform1 c_th2_settitle

instance ITNamed TH1 where
  setTitle = xform1 c_th1_settitle

instance ITNamed TBranch where
  setTitle = xform1 c_tbranch_settitle

instance ITNamed TFile where
  setTitle = xform1 c_tfile_settitle

instance ITNamed TDirectoryFile where
  setTitle = xform1 c_tdirectoryfile_settitle

instance ITNamed TDirectory where
  setTitle = xform1 c_tdirectory_settitle

instance ITNamed TText where
  setTitle = xform1 c_ttext_settitle

instance ITNamed TLatex where
  setTitle = xform1 c_tlatex_settitle

instance ITNamed TAxis where
  setTitle = xform1 c_taxis_settitle

instance ITNamed TEfficiency where
  setTitle = xform1 c_tefficiency_settitle

instance ITNamed TTreeSQL where
  setTitle = xform1 c_ttreesql_settitle

instance ITNamed TNtupleD where
  setTitle = xform1 c_tntupled_settitle

instance ITNamed TNtuple where
  setTitle = xform1 c_tntuple_settitle

instance ITNamed TChain where
  setTitle = xform1 c_tchain_settitle

instance ITNamed TTree where
  setTitle = xform1 c_ttree_settitle

instance ITNamed TXTRU where
  setTitle = xform1 c_txtru_settitle

instance ITNamed TSPHE where
  setTitle = xform1 c_tsphe_settitle

instance ITNamed TPCON where
  setTitle = xform1 c_tpcon_settitle

instance ITNamed TTUBE where
  setTitle = xform1 c_ttube_settitle

instance ITNamed TBRIK where
  setTitle = xform1 c_tbrik_settitle

instance ITNamed TShape where
  setTitle = xform1 c_tshape_settitle

instance ITNamed TGraphQQ where
  setTitle = xform1 c_tgraphqq_settitle

instance ITNamed TGraphPolar where
  setTitle = xform1 c_tgraphpolar_settitle

instance ITNamed TGraphErrors where
  setTitle = xform1 c_tgrapherrors_settitle

instance ITNamed TGraphBentErrors where
  setTitle = xform1 c_tgraphbenterrors_settitle

instance ITNamed TCutG where
  setTitle = xform1 c_tcutg_settitle

instance ITNamed TGraphAsymmErrors where
  setTitle = xform1 c_tgraphasymmerrors_settitle

instance ITNamed TGraph where
  setTitle = xform1 c_tgraph_settitle

instance ITNamed TF1 where
  setTitle = xform1 c_tf1_settitle

instance ITNamed THStack where
  setTitle = xform1 c_thstack_settitle

instance ITNamed TAttParticle where
  setTitle = xform1 c_tattparticle_settitle

instance ITNamed TFormula where
  setTitle = xform1 c_tformula_settitle

instance ITNamed TClass where
  setTitle = xform1 c_tclass_settitle



instance ITObject TKey where
  getName = xform0 c_tkey_getname
  draw = xform1 c_tkey_draw
  findObject = xform1 c_tkey_findobject
  saveAs = xform2 c_tkey_saveas
  write = xform3 c_tkey_write
  isA = xform0 c_tkey_isa
  printObj = xform1 c_tkey_printobj

instance ITObject TList where
  getName = xform0 c_tlist_getname
  draw = xform1 c_tlist_draw
  findObject = xform1 c_tlist_findobject
  saveAs = xform2 c_tlist_saveas
  write = xform3 c_tlist_write
  isA = xform0 c_tlist_isa
  printObj = xform1 c_tlist_printobj

instance ITObject TObjArray where
  getName = xform0 c_tobjarray_getname
  draw = xform1 c_tobjarray_draw
  findObject = xform1 c_tobjarray_findobject
  saveAs = xform2 c_tobjarray_saveas
  write = xform3 c_tobjarray_write
  isA = xform0 c_tobjarray_isa
  printObj = xform1 c_tobjarray_printobj

instance ITObject TSeqCollection where
  getName = xform0 c_tseqcollection_getname
  draw = xform1 c_tseqcollection_draw
  findObject = xform1 c_tseqcollection_findobject
  saveAs = xform2 c_tseqcollection_saveas
  write = xform3 c_tseqcollection_write
  isA = xform0 c_tseqcollection_isa
  printObj = xform1 c_tseqcollection_printobj

instance ITObject TCollection where
  getName = xform0 c_tcollection_getname
  draw = xform1 c_tcollection_draw
  findObject = xform1 c_tcollection_findobject
  saveAs = xform2 c_tcollection_saveas
  write = xform3 c_tcollection_write
  isA = xform0 c_tcollection_isa
  printObj = xform1 c_tcollection_printobj

instance ITObject TRandom where
  getName = xform0 c_trandom_getname
  draw = xform1 c_trandom_draw
  findObject = xform1 c_trandom_findobject
  saveAs = xform2 c_trandom_saveas
  write = xform3 c_trandom_write
  isA = xform0 c_trandom_isa
  printObj = xform1 c_trandom_printobj

instance ITObject TRint where
  getName = xform0 c_trint_getname
  draw = xform1 c_trint_draw
  findObject = xform1 c_trint_findobject
  saveAs = xform2 c_trint_saveas
  write = xform3 c_trint_write
  isA = xform0 c_trint_isa
  printObj = xform1 c_trint_printobj

instance ITObject TApplication where
  getName = xform0 c_tapplication_getname
  draw = xform1 c_tapplication_draw
  findObject = xform1 c_tapplication_findobject
  saveAs = xform2 c_tapplication_saveas
  write = xform3 c_tapplication_write
  isA = xform0 c_tapplication_isa
  printObj = xform1 c_tapplication_printobj

instance ITObject TSlider where
  getName = xform0 c_tslider_getname
  draw = xform1 c_tslider_draw
  findObject = xform1 c_tslider_findobject
  saveAs = xform2 c_tslider_saveas
  write = xform3 c_tslider_write
  isA = xform0 c_tslider_isa
  printObj = xform1 c_tslider_printobj

instance ITObject TEvePad where
  getName = xform0 c_tevepad_getname
  draw = xform1 c_tevepad_draw
  findObject = xform1 c_tevepad_findobject
  saveAs = xform2 c_tevepad_saveas
  write = xform3 c_tevepad_write
  isA = xform0 c_tevepad_isa
  printObj = xform1 c_tevepad_printobj

instance ITObject TInspectCanvas where
  getName = xform0 c_tinspectcanvas_getname
  draw = xform1 c_tinspectcanvas_draw
  findObject = xform1 c_tinspectcanvas_findobject
  saveAs = xform2 c_tinspectcanvas_saveas
  write = xform3 c_tinspectcanvas_write
  isA = xform0 c_tinspectcanvas_isa
  printObj = xform1 c_tinspectcanvas_printobj

instance ITObject TDialogCanvas where
  getName = xform0 c_tdialogcanvas_getname
  draw = xform1 c_tdialogcanvas_draw
  findObject = xform1 c_tdialogcanvas_findobject
  saveAs = xform2 c_tdialogcanvas_saveas
  write = xform3 c_tdialogcanvas_write
  isA = xform0 c_tdialogcanvas_isa
  printObj = xform1 c_tdialogcanvas_printobj

instance ITObject TCanvas where
  getName = xform0 c_tcanvas_getname
  draw = xform1 c_tcanvas_draw
  findObject = xform1 c_tcanvas_findobject
  saveAs = xform2 c_tcanvas_saveas
  write = xform3 c_tcanvas_write
  isA = xform0 c_tcanvas_isa
  printObj = xform1 c_tcanvas_printobj

instance ITObject TGroupButton where
  getName = xform0 c_tgroupbutton_getname
  draw = xform1 c_tgroupbutton_draw
  findObject = xform1 c_tgroupbutton_findobject
  saveAs = xform2 c_tgroupbutton_saveas
  write = xform3 c_tgroupbutton_write
  isA = xform0 c_tgroupbutton_isa
  printObj = xform1 c_tgroupbutton_printobj

instance ITObject TButton where
  getName = xform0 c_tbutton_getname
  draw = xform1 c_tbutton_draw
  findObject = xform1 c_tbutton_findobject
  saveAs = xform2 c_tbutton_saveas
  write = xform3 c_tbutton_write
  isA = xform0 c_tbutton_isa
  printObj = xform1 c_tbutton_printobj

instance ITObject TPad where
  getName = xform0 c_tpad_getname
  draw = xform1 c_tpad_draw
  findObject = xform1 c_tpad_findobject
  saveAs = xform2 c_tpad_saveas
  write = xform3 c_tpad_write
  isA = xform0 c_tpad_isa
  printObj = xform1 c_tpad_printobj

instance ITObject TVirtualPad where
  getName = xform0 c_tvirtualpad_getname
  draw = xform1 c_tvirtualpad_draw
  findObject = xform1 c_tvirtualpad_findobject
  saveAs = xform2 c_tvirtualpad_saveas
  write = xform3 c_tvirtualpad_write
  isA = xform0 c_tvirtualpad_isa
  printObj = xform1 c_tvirtualpad_printobj

instance ITObject TH3S where
  getName = xform0 c_th3s_getname
  draw = xform1 c_th3s_draw
  findObject = xform1 c_th3s_findobject
  saveAs = xform2 c_th3s_saveas
  write = xform3 c_th3s_write
  isA = xform0 c_th3s_isa
  printObj = xform1 c_th3s_printobj

instance ITObject TH3I where
  getName = xform0 c_th3i_getname
  draw = xform1 c_th3i_draw
  findObject = xform1 c_th3i_findobject
  saveAs = xform2 c_th3i_saveas
  write = xform3 c_th3i_write
  isA = xform0 c_th3i_isa
  printObj = xform1 c_th3i_printobj

instance ITObject TH3F where
  getName = xform0 c_th3f_getname
  draw = xform1 c_th3f_draw
  findObject = xform1 c_th3f_findobject
  saveAs = xform2 c_th3f_saveas
  write = xform3 c_th3f_write
  isA = xform0 c_th3f_isa
  printObj = xform1 c_th3f_printobj

instance ITObject TH3D where
  getName = xform0 c_th3d_getname
  draw = xform1 c_th3d_draw
  findObject = xform1 c_th3d_findobject
  saveAs = xform2 c_th3d_saveas
  write = xform3 c_th3d_write
  isA = xform0 c_th3d_isa
  printObj = xform1 c_th3d_printobj

instance ITObject TH3C where
  getName = xform0 c_th3c_getname
  draw = xform1 c_th3c_draw
  findObject = xform1 c_th3c_findobject
  saveAs = xform2 c_th3c_saveas
  write = xform3 c_th3c_write
  isA = xform0 c_th3c_isa
  printObj = xform1 c_th3c_printobj

instance ITObject TH2S where
  getName = xform0 c_th2s_getname
  draw = xform1 c_th2s_draw
  findObject = xform1 c_th2s_findobject
  saveAs = xform2 c_th2s_saveas
  write = xform3 c_th2s_write
  isA = xform0 c_th2s_isa
  printObj = xform1 c_th2s_printobj

instance ITObject TH2Poly where
  getName = xform0 c_th2poly_getname
  draw = xform1 c_th2poly_draw
  findObject = xform1 c_th2poly_findobject
  saveAs = xform2 c_th2poly_saveas
  write = xform3 c_th2poly_write
  isA = xform0 c_th2poly_isa
  printObj = xform1 c_th2poly_printobj

instance ITObject TH2I where
  getName = xform0 c_th2i_getname
  draw = xform1 c_th2i_draw
  findObject = xform1 c_th2i_findobject
  saveAs = xform2 c_th2i_saveas
  write = xform3 c_th2i_write
  isA = xform0 c_th2i_isa
  printObj = xform1 c_th2i_printobj

instance ITObject TH2F where
  getName = xform0 c_th2f_getname
  draw = xform1 c_th2f_draw
  findObject = xform1 c_th2f_findobject
  saveAs = xform2 c_th2f_saveas
  write = xform3 c_th2f_write
  isA = xform0 c_th2f_isa
  printObj = xform1 c_th2f_printobj

instance ITObject TH2D where
  getName = xform0 c_th2d_getname
  draw = xform1 c_th2d_draw
  findObject = xform1 c_th2d_findobject
  saveAs = xform2 c_th2d_saveas
  write = xform3 c_th2d_write
  isA = xform0 c_th2d_isa
  printObj = xform1 c_th2d_printobj

instance ITObject TH2C where
  getName = xform0 c_th2c_getname
  draw = xform1 c_th2c_draw
  findObject = xform1 c_th2c_findobject
  saveAs = xform2 c_th2c_saveas
  write = xform3 c_th2c_write
  isA = xform0 c_th2c_isa
  printObj = xform1 c_th2c_printobj

instance ITObject TH1S where
  getName = xform0 c_th1s_getname
  draw = xform1 c_th1s_draw
  findObject = xform1 c_th1s_findobject
  saveAs = xform2 c_th1s_saveas
  write = xform3 c_th1s_write
  isA = xform0 c_th1s_isa
  printObj = xform1 c_th1s_printobj

instance ITObject TH1I where
  getName = xform0 c_th1i_getname
  draw = xform1 c_th1i_draw
  findObject = xform1 c_th1i_findobject
  saveAs = xform2 c_th1i_saveas
  write = xform3 c_th1i_write
  isA = xform0 c_th1i_isa
  printObj = xform1 c_th1i_printobj

instance ITObject TH1F where
  getName = xform0 c_th1f_getname
  draw = xform1 c_th1f_draw
  findObject = xform1 c_th1f_findobject
  saveAs = xform2 c_th1f_saveas
  write = xform3 c_th1f_write
  isA = xform0 c_th1f_isa
  printObj = xform1 c_th1f_printobj

instance ITObject TH1D where
  getName = xform0 c_th1d_getname
  draw = xform1 c_th1d_draw
  findObject = xform1 c_th1d_findobject
  saveAs = xform2 c_th1d_saveas
  write = xform3 c_th1d_write
  isA = xform0 c_th1d_isa
  printObj = xform1 c_th1d_printobj

instance ITObject TH1C where
  getName = xform0 c_th1c_getname
  draw = xform1 c_th1c_draw
  findObject = xform1 c_th1c_findobject
  saveAs = xform2 c_th1c_saveas
  write = xform3 c_th1c_write
  isA = xform0 c_th1c_isa
  printObj = xform1 c_th1c_printobj

instance ITObject TH3 where
  getName = xform0 c_th3_getname
  draw = xform1 c_th3_draw
  findObject = xform1 c_th3_findobject
  saveAs = xform2 c_th3_saveas
  write = xform3 c_th3_write
  isA = xform0 c_th3_isa
  printObj = xform1 c_th3_printobj

instance ITObject TH2 where
  getName = xform0 c_th2_getname
  draw = xform1 c_th2_draw
  findObject = xform1 c_th2_findobject
  saveAs = xform2 c_th2_saveas
  write = xform3 c_th2_write
  isA = xform0 c_th2_isa
  printObj = xform1 c_th2_printobj

instance ITObject TH1 where
  getName = xform0 c_th1_getname
  draw = xform1 c_th1_draw
  findObject = xform1 c_th1_findobject
  saveAs = xform2 c_th1_saveas
  write = xform3 c_th1_write
  isA = xform0 c_th1_isa
  printObj = xform1 c_th1_printobj

instance ITObject TTreePlayer where
  getName = xform0 c_ttreeplayer_getname
  draw = xform1 c_ttreeplayer_draw
  findObject = xform1 c_ttreeplayer_findobject
  saveAs = xform2 c_ttreeplayer_saveas
  write = xform3 c_ttreeplayer_write
  isA = xform0 c_ttreeplayer_isa
  printObj = xform1 c_ttreeplayer_printobj

instance ITObject TVirtualTreePlayer where
  getName = xform0 c_tvirtualtreeplayer_getname
  draw = xform1 c_tvirtualtreeplayer_draw
  findObject = xform1 c_tvirtualtreeplayer_findobject
  saveAs = xform2 c_tvirtualtreeplayer_saveas
  write = xform3 c_tvirtualtreeplayer_write
  isA = xform0 c_tvirtualtreeplayer_isa
  printObj = xform1 c_tvirtualtreeplayer_printobj

instance ITObject TBranch where
  getName = xform0 c_tbranch_getname
  draw = xform1 c_tbranch_draw
  findObject = xform1 c_tbranch_findobject
  saveAs = xform2 c_tbranch_saveas
  write = xform3 c_tbranch_write
  isA = xform0 c_tbranch_isa
  printObj = xform1 c_tbranch_printobj

instance ITObject TFile where
  getName = xform0 c_tfile_getname
  draw = xform1 c_tfile_draw
  findObject = xform1 c_tfile_findobject
  saveAs = xform2 c_tfile_saveas
  write = xform3 c_tfile_write
  isA = xform0 c_tfile_isa
  printObj = xform1 c_tfile_printobj

instance ITObject TDirectoryFile where
  getName = xform0 c_tdirectoryfile_getname
  draw = xform1 c_tdirectoryfile_draw
  findObject = xform1 c_tdirectoryfile_findobject
  saveAs = xform2 c_tdirectoryfile_saveas
  write = xform3 c_tdirectoryfile_write
  isA = xform0 c_tdirectoryfile_isa
  printObj = xform1 c_tdirectoryfile_printobj

instance ITObject TDirectory where
  getName = xform0 c_tdirectory_getname
  draw = xform1 c_tdirectory_draw
  findObject = xform1 c_tdirectory_findobject
  saveAs = xform2 c_tdirectory_saveas
  write = xform3 c_tdirectory_write
  isA = xform0 c_tdirectory_isa
  printObj = xform1 c_tdirectory_printobj

instance ITObject TText where
  getName = xform0 c_ttext_getname
  draw = xform1 c_ttext_draw
  findObject = xform1 c_ttext_findobject
  saveAs = xform2 c_ttext_saveas
  write = xform3 c_ttext_write
  isA = xform0 c_ttext_isa
  printObj = xform1 c_ttext_printobj

instance ITObject TLatex where
  getName = xform0 c_tlatex_getname
  draw = xform1 c_tlatex_draw
  findObject = xform1 c_tlatex_findobject
  saveAs = xform2 c_tlatex_saveas
  write = xform3 c_tlatex_write
  isA = xform0 c_tlatex_isa
  printObj = xform1 c_tlatex_printobj

instance ITObject TAxis where
  getName = xform0 c_taxis_getname
  draw = xform1 c_taxis_draw
  findObject = xform1 c_taxis_findobject
  saveAs = xform2 c_taxis_saveas
  write = xform3 c_taxis_write
  isA = xform0 c_taxis_isa
  printObj = xform1 c_taxis_printobj

instance ITObject TEfficiency where
  getName = xform0 c_tefficiency_getname
  draw = xform1 c_tefficiency_draw
  findObject = xform1 c_tefficiency_findobject
  saveAs = xform2 c_tefficiency_saveas
  write = xform3 c_tefficiency_write
  isA = xform0 c_tefficiency_isa
  printObj = xform1 c_tefficiency_printobj

instance ITObject TCurlyArc where
  getName = xform0 c_tcurlyarc_getname
  draw = xform1 c_tcurlyarc_draw
  findObject = xform1 c_tcurlyarc_findobject
  saveAs = xform2 c_tcurlyarc_saveas
  write = xform3 c_tcurlyarc_write
  isA = xform0 c_tcurlyarc_isa
  printObj = xform1 c_tcurlyarc_printobj

instance ITObject TCurlyLine where
  getName = xform0 c_tcurlyline_getname
  draw = xform1 c_tcurlyline_draw
  findObject = xform1 c_tcurlyline_findobject
  saveAs = xform2 c_tcurlyline_saveas
  write = xform3 c_tcurlyline_write
  isA = xform0 c_tcurlyline_isa
  printObj = xform1 c_tcurlyline_printobj

instance ITObject TPolyLine where
  getName = xform0 c_tpolyline_getname
  draw = xform1 c_tpolyline_draw
  findObject = xform1 c_tpolyline_findobject
  saveAs = xform2 c_tpolyline_saveas
  write = xform3 c_tpolyline_write
  isA = xform0 c_tpolyline_isa
  printObj = xform1 c_tpolyline_printobj

instance ITObject TTreeSQL where
  getName = xform0 c_ttreesql_getname
  draw = xform1 c_ttreesql_draw
  findObject = xform1 c_ttreesql_findobject
  saveAs = xform2 c_ttreesql_saveas
  write = xform3 c_ttreesql_write
  isA = xform0 c_ttreesql_isa
  printObj = xform1 c_ttreesql_printobj

instance ITObject TNtupleD where
  getName = xform0 c_tntupled_getname
  draw = xform1 c_tntupled_draw
  findObject = xform1 c_tntupled_findobject
  saveAs = xform2 c_tntupled_saveas
  write = xform3 c_tntupled_write
  isA = xform0 c_tntupled_isa
  printObj = xform1 c_tntupled_printobj

instance ITObject TNtuple where
  getName = xform0 c_tntuple_getname
  draw = xform1 c_tntuple_draw
  findObject = xform1 c_tntuple_findobject
  saveAs = xform2 c_tntuple_saveas
  write = xform3 c_tntuple_write
  isA = xform0 c_tntuple_isa
  printObj = xform1 c_tntuple_printobj

instance ITObject TChain where
  getName = xform0 c_tchain_getname
  draw = xform1 c_tchain_draw
  findObject = xform1 c_tchain_findobject
  saveAs = xform2 c_tchain_saveas
  write = xform3 c_tchain_write
  isA = xform0 c_tchain_isa
  printObj = xform1 c_tchain_printobj

instance ITObject TTree where
  getName = xform0 c_ttree_getname
  draw = xform1 c_ttree_draw
  findObject = xform1 c_ttree_findobject
  saveAs = xform2 c_ttree_saveas
  write = xform3 c_ttree_write
  isA = xform0 c_ttree_isa
  printObj = xform1 c_ttree_printobj

instance ITObject TSliderBox where
  getName = xform0 c_tsliderbox_getname
  draw = xform1 c_tsliderbox_draw
  findObject = xform1 c_tsliderbox_findobject
  saveAs = xform2 c_tsliderbox_saveas
  write = xform3 c_tsliderbox_write
  isA = xform0 c_tsliderbox_isa
  printObj = xform1 c_tsliderbox_printobj

instance ITObject TFrame where
  getName = xform0 c_tframe_getname
  draw = xform1 c_tframe_draw
  findObject = xform1 c_tframe_findobject
  saveAs = xform2 c_tframe_saveas
  write = xform3 c_tframe_write
  isA = xform0 c_tframe_isa
  printObj = xform1 c_tframe_printobj

instance ITObject TWbox where
  getName = xform0 c_twbox_getname
  draw = xform1 c_twbox_draw
  findObject = xform1 c_twbox_findobject
  saveAs = xform2 c_twbox_saveas
  write = xform3 c_twbox_write
  isA = xform0 c_twbox_isa
  printObj = xform1 c_twbox_printobj

instance ITObject TPaveClass where
  getName = xform0 c_tpaveclass_getname
  draw = xform1 c_tpaveclass_draw
  findObject = xform1 c_tpaveclass_findobject
  saveAs = xform2 c_tpaveclass_saveas
  write = xform3 c_tpaveclass_write
  isA = xform0 c_tpaveclass_isa
  printObj = xform1 c_tpaveclass_printobj

instance ITObject TPaveLabel where
  getName = xform0 c_tpavelabel_getname
  draw = xform1 c_tpavelabel_draw
  findObject = xform1 c_tpavelabel_findobject
  saveAs = xform2 c_tpavelabel_saveas
  write = xform3 c_tpavelabel_write
  isA = xform0 c_tpavelabel_isa
  printObj = xform1 c_tpavelabel_printobj

instance ITObject TLegendEntry where
  getName = xform0 c_tlegendentry_getname
  draw = xform1 c_tlegendentry_draw
  findObject = xform1 c_tlegendentry_findobject
  saveAs = xform2 c_tlegendentry_saveas
  write = xform3 c_tlegendentry_write
  isA = xform0 c_tlegendentry_isa
  printObj = xform1 c_tlegendentry_printobj

instance ITObject TLegend where
  getName = xform0 c_tlegend_getname
  draw = xform1 c_tlegend_draw
  findObject = xform1 c_tlegend_findobject
  saveAs = xform2 c_tlegend_saveas
  write = xform3 c_tlegend_write
  isA = xform0 c_tlegend_isa
  printObj = xform1 c_tlegend_printobj

instance ITObject TPavesText where
  getName = xform0 c_tpavestext_getname
  draw = xform1 c_tpavestext_draw
  findObject = xform1 c_tpavestext_findobject
  saveAs = xform2 c_tpavestext_saveas
  write = xform3 c_tpavestext_write
  isA = xform0 c_tpavestext_isa
  printObj = xform1 c_tpavestext_printobj

instance ITObject TPaveStats where
  getName = xform0 c_tpavestats_getname
  draw = xform1 c_tpavestats_draw
  findObject = xform1 c_tpavestats_findobject
  saveAs = xform2 c_tpavestats_saveas
  write = xform3 c_tpavestats_write
  isA = xform0 c_tpavestats_isa
  printObj = xform1 c_tpavestats_printobj

instance ITObject TDiamond where
  getName = xform0 c_tdiamond_getname
  draw = xform1 c_tdiamond_draw
  findObject = xform1 c_tdiamond_findobject
  saveAs = xform2 c_tdiamond_saveas
  write = xform3 c_tdiamond_write
  isA = xform0 c_tdiamond_isa
  printObj = xform1 c_tdiamond_printobj

instance ITObject TPaveText where
  getName = xform0 c_tpavetext_getname
  draw = xform1 c_tpavetext_draw
  findObject = xform1 c_tpavetext_findobject
  saveAs = xform2 c_tpavetext_saveas
  write = xform3 c_tpavetext_write
  isA = xform0 c_tpavetext_isa
  printObj = xform1 c_tpavetext_printobj

instance ITObject TPave where
  getName = xform0 c_tpave_getname
  draw = xform1 c_tpave_draw
  findObject = xform1 c_tpave_findobject
  saveAs = xform2 c_tpave_saveas
  write = xform3 c_tpave_write
  isA = xform0 c_tpave_isa
  printObj = xform1 c_tpave_printobj

instance ITObject TBox where
  getName = xform0 c_tbox_getname
  draw = xform1 c_tbox_draw
  findObject = xform1 c_tbox_findobject
  saveAs = xform2 c_tbox_saveas
  write = xform3 c_tbox_write
  isA = xform0 c_tbox_isa
  printObj = xform1 c_tbox_printobj

instance ITObject TXTRU where
  getName = xform0 c_txtru_getname
  draw = xform1 c_txtru_draw
  findObject = xform1 c_txtru_findobject
  saveAs = xform2 c_txtru_saveas
  write = xform3 c_txtru_write
  isA = xform0 c_txtru_isa
  printObj = xform1 c_txtru_printobj

instance ITObject TSPHE where
  getName = xform0 c_tsphe_getname
  draw = xform1 c_tsphe_draw
  findObject = xform1 c_tsphe_findobject
  saveAs = xform2 c_tsphe_saveas
  write = xform3 c_tsphe_write
  isA = xform0 c_tsphe_isa
  printObj = xform1 c_tsphe_printobj

instance ITObject TPCON where
  getName = xform0 c_tpcon_getname
  draw = xform1 c_tpcon_draw
  findObject = xform1 c_tpcon_findobject
  saveAs = xform2 c_tpcon_saveas
  write = xform3 c_tpcon_write
  isA = xform0 c_tpcon_isa
  printObj = xform1 c_tpcon_printobj

instance ITObject TTUBE where
  getName = xform0 c_ttube_getname
  draw = xform1 c_ttube_draw
  findObject = xform1 c_ttube_findobject
  saveAs = xform2 c_ttube_saveas
  write = xform3 c_ttube_write
  isA = xform0 c_ttube_isa
  printObj = xform1 c_ttube_printobj

instance ITObject TBRIK where
  getName = xform0 c_tbrik_getname
  draw = xform1 c_tbrik_draw
  findObject = xform1 c_tbrik_findobject
  saveAs = xform2 c_tbrik_saveas
  write = xform3 c_tbrik_write
  isA = xform0 c_tbrik_isa
  printObj = xform1 c_tbrik_printobj

instance ITObject TShape where
  getName = xform0 c_tshape_getname
  draw = xform1 c_tshape_draw
  findObject = xform1 c_tshape_findobject
  saveAs = xform2 c_tshape_saveas
  write = xform3 c_tshape_write
  isA = xform0 c_tshape_isa
  printObj = xform1 c_tshape_printobj

instance ITObject TGaxis where
  getName = xform0 c_tgaxis_getname
  draw = xform1 c_tgaxis_draw
  findObject = xform1 c_tgaxis_findobject
  saveAs = xform2 c_tgaxis_saveas
  write = xform3 c_tgaxis_write
  isA = xform0 c_tgaxis_isa
  printObj = xform1 c_tgaxis_printobj

instance ITObject TArrow where
  getName = xform0 c_tarrow_getname
  draw = xform1 c_tarrow_draw
  findObject = xform1 c_tarrow_findobject
  saveAs = xform2 c_tarrow_saveas
  write = xform3 c_tarrow_write
  isA = xform0 c_tarrow_isa
  printObj = xform1 c_tarrow_printobj

instance ITObject TLine where
  getName = xform0 c_tline_getname
  draw = xform1 c_tline_draw
  findObject = xform1 c_tline_findobject
  saveAs = xform2 c_tline_saveas
  write = xform3 c_tline_write
  isA = xform0 c_tline_isa
  printObj = xform1 c_tline_printobj

instance ITObject TCrown where
  getName = xform0 c_tcrown_getname
  draw = xform1 c_tcrown_draw
  findObject = xform1 c_tcrown_findobject
  saveAs = xform2 c_tcrown_saveas
  write = xform3 c_tcrown_write
  isA = xform0 c_tcrown_isa
  printObj = xform1 c_tcrown_printobj

instance ITObject TArc where
  getName = xform0 c_tarc_getname
  draw = xform1 c_tarc_draw
  findObject = xform1 c_tarc_findobject
  saveAs = xform2 c_tarc_saveas
  write = xform3 c_tarc_write
  isA = xform0 c_tarc_isa
  printObj = xform1 c_tarc_printobj

instance ITObject TEllipse where
  getName = xform0 c_tellipse_getname
  draw = xform1 c_tellipse_draw
  findObject = xform1 c_tellipse_findobject
  saveAs = xform2 c_tellipse_saveas
  write = xform3 c_tellipse_write
  isA = xform0 c_tellipse_isa
  printObj = xform1 c_tellipse_printobj

instance ITObject TGraphQQ where
  getName = xform0 c_tgraphqq_getname
  draw = xform1 c_tgraphqq_draw
  findObject = xform1 c_tgraphqq_findobject
  saveAs = xform2 c_tgraphqq_saveas
  write = xform3 c_tgraphqq_write
  isA = xform0 c_tgraphqq_isa
  printObj = xform1 c_tgraphqq_printobj

instance ITObject TGraphPolar where
  getName = xform0 c_tgraphpolar_getname
  draw = xform1 c_tgraphpolar_draw
  findObject = xform1 c_tgraphpolar_findobject
  saveAs = xform2 c_tgraphpolar_saveas
  write = xform3 c_tgraphpolar_write
  isA = xform0 c_tgraphpolar_isa
  printObj = xform1 c_tgraphpolar_printobj

instance ITObject TGraphErrors where
  getName = xform0 c_tgrapherrors_getname
  draw = xform1 c_tgrapherrors_draw
  findObject = xform1 c_tgrapherrors_findobject
  saveAs = xform2 c_tgrapherrors_saveas
  write = xform3 c_tgrapherrors_write
  isA = xform0 c_tgrapherrors_isa
  printObj = xform1 c_tgrapherrors_printobj

instance ITObject TGraphBentErrors where
  getName = xform0 c_tgraphbenterrors_getname
  draw = xform1 c_tgraphbenterrors_draw
  findObject = xform1 c_tgraphbenterrors_findobject
  saveAs = xform2 c_tgraphbenterrors_saveas
  write = xform3 c_tgraphbenterrors_write
  isA = xform0 c_tgraphbenterrors_isa
  printObj = xform1 c_tgraphbenterrors_printobj

instance ITObject TCutG where
  getName = xform0 c_tcutg_getname
  draw = xform1 c_tcutg_draw
  findObject = xform1 c_tcutg_findobject
  saveAs = xform2 c_tcutg_saveas
  write = xform3 c_tcutg_write
  isA = xform0 c_tcutg_isa
  printObj = xform1 c_tcutg_printobj

instance ITObject TGraphAsymmErrors where
  getName = xform0 c_tgraphasymmerrors_getname
  draw = xform1 c_tgraphasymmerrors_draw
  findObject = xform1 c_tgraphasymmerrors_findobject
  saveAs = xform2 c_tgraphasymmerrors_saveas
  write = xform3 c_tgraphasymmerrors_write
  isA = xform0 c_tgraphasymmerrors_isa
  printObj = xform1 c_tgraphasymmerrors_printobj

instance ITObject TGraph where
  getName = xform0 c_tgraph_getname
  draw = xform1 c_tgraph_draw
  findObject = xform1 c_tgraph_findobject
  saveAs = xform2 c_tgraph_saveas
  write = xform3 c_tgraph_write
  isA = xform0 c_tgraph_isa
  printObj = xform1 c_tgraph_printobj

instance ITObject TF1 where
  getName = xform0 c_tf1_getname
  draw = xform1 c_tf1_draw
  findObject = xform1 c_tf1_findobject
  saveAs = xform2 c_tf1_saveas
  write = xform3 c_tf1_write
  isA = xform0 c_tf1_isa
  printObj = xform1 c_tf1_printobj

instance ITObject THStack where
  getName = xform0 c_thstack_getname
  draw = xform1 c_thstack_draw
  findObject = xform1 c_thstack_findobject
  saveAs = xform2 c_thstack_saveas
  write = xform3 c_thstack_write
  isA = xform0 c_thstack_isa
  printObj = xform1 c_thstack_printobj

instance ITObject TAttParticle where
  getName = xform0 c_tattparticle_getname
  draw = xform1 c_tattparticle_draw
  findObject = xform1 c_tattparticle_findobject
  saveAs = xform2 c_tattparticle_saveas
  write = xform3 c_tattparticle_write
  isA = xform0 c_tattparticle_isa
  printObj = xform1 c_tattparticle_printobj

instance ITObject TFormula where
  getName = xform0 c_tformula_getname
  draw = xform1 c_tformula_draw
  findObject = xform1 c_tformula_findobject
  saveAs = xform2 c_tformula_saveas
  write = xform3 c_tformula_write
  isA = xform0 c_tformula_isa
  printObj = xform1 c_tformula_printobj

instance ITObject TClass where
  getName = xform0 c_tclass_getname
  draw = xform1 c_tclass_draw
  findObject = xform1 c_tclass_findobject
  saveAs = xform2 c_tclass_saveas
  write = xform3 c_tclass_write
  isA = xform0 c_tclass_isa
  printObj = xform1 c_tclass_printobj



instance ITObject TNamed where
  getName = xform0 c_tnamed_getname
  draw = xform1 c_tnamed_draw
  findObject = xform1 c_tnamed_findobject
  saveAs = xform2 c_tnamed_saveas
  write = xform3 c_tnamed_write
  isA = xform0 c_tnamed_isa
  printObj = xform1 c_tnamed_printobj

instance ITPad TSlider where

instance ITPad TEvePad where

instance ITPad TInspectCanvas where

instance ITPad TDialogCanvas where

instance ITPad TCanvas where

instance ITPad TGroupButton where

instance ITPad TButton where

instance ITPave TPaveClass where

instance ITPave TPaveLabel where

instance ITPave TLegend where

instance ITPave TPavesText where

instance ITPave TPaveStats where

instance ITPave TDiamond where

instance ITPave TPaveText where

instance ITPaveLabel TPaveClass where

instance ITPaveText TPavesText where

instance ITPaveText TPaveStats where

instance ITPaveText TDiamond where

instance ITPolyLine TCurlyArc where

instance ITPolyLine TCurlyLine where

instance ITQObject TRint where

instance ITQObject TApplication where

instance ITQObject TSlider where

instance ITQObject TEvePad where

instance ITQObject TInspectCanvas where

instance ITQObject TDialogCanvas where

instance ITQObject TCanvas where

instance ITQObject TGroupButton where

instance ITQObject TButton where

instance ITQObject TPad where

instance ITQObject TVirtualPad where

instance ITSeqCollection TList where

instance ITSeqCollection TObjArray where

instance ITShape TXTRU where

instance ITShape TSPHE where

instance ITShape TPCON where

instance ITShape TTUBE where

instance ITShape TBRIK where

instance ITText TLatex where

instance ITTree TTreeSQL where

instance ITTree TNtupleD where

instance ITTree TNtuple where

instance ITTree TChain where

instance ITVirtualPad TSlider where
  getFrame = xform0 c_tslider_getframe
  range = xform4 c_tslider_range

instance ITVirtualPad TEvePad where
  getFrame = xform0 c_tevepad_getframe
  range = xform4 c_tevepad_range

instance ITVirtualPad TInspectCanvas where
  getFrame = xform0 c_tinspectcanvas_getframe
  range = xform4 c_tinspectcanvas_range

instance ITVirtualPad TDialogCanvas where
  getFrame = xform0 c_tdialogcanvas_getframe
  range = xform4 c_tdialogcanvas_range

instance ITVirtualPad TCanvas where
  getFrame = xform0 c_tcanvas_getframe
  range = xform4 c_tcanvas_range

instance ITVirtualPad TGroupButton where
  getFrame = xform0 c_tgroupbutton_getframe
  range = xform4 c_tgroupbutton_range

instance ITVirtualPad TButton where
  getFrame = xform0 c_tbutton_getframe
  range = xform4 c_tbutton_range

instance ITVirtualPad TPad where
  getFrame = xform0 c_tpad_getframe
  range = xform4 c_tpad_range

instance ITVirtualTreePlayer TTreePlayer where

instance ITWbox TSliderBox where
  setBorderMode = xform1 c_tsliderbox_setbordermode

instance ITWbox TFrame where
  setBorderMode = xform1 c_tframe_setbordermode


newTObject :: IO TObject
newTObject = xformnull c_tobject_newtobject

-- | constructor : 
--   
--   > TNamed( char* name, char* title) 
--   

newTNamed :: String -> String -> IO TNamed
newTNamed = xform1 c_tnamed_newtnamed


newTFormula :: String -> String -> IO TFormula
newTFormula = xform1 c_tformula_newtformula


newTAttAxis :: IO TAttAxis
newTAttAxis = xformnull c_tattaxis_newtattaxis


newTAttCanvas :: IO TAttCanvas
newTAttCanvas = xformnull c_tattcanvas_newtattcanvas


newTAttFill :: Int -> Int -> IO TAttFill
newTAttFill = xform1 c_tattfill_newtattfill


newTAttLine :: Int -> Int -> Int -> IO TAttLine
newTAttLine = xform2 c_tattline_newtattline


newTAttMarker :: Int -> Int -> Int -> IO TAttMarker
newTAttMarker = xform2 c_tattmarker_newtattmarker


newTAttPad :: IO TAttPad
newTAttPad = xformnull c_tattpad_newtattpad


newTAttText :: Int -> Double -> Int -> Int -> Double -> IO TAttText
newTAttText = xform4 c_tatttext_newtatttext


newTHStack :: String -> String -> IO THStack
newTHStack = xform1 c_thstack_newthstack


newTF1 :: String -> String -> Double -> Double -> IO TF1
newTF1 = xform3 c_tf1_newtf1


newTGraph :: Int -> [Double] -> [Double] -> IO TGraph
newTGraph = xform2 c_tgraph_newtgraph


newTGraphAsymmErrors :: Int -> [Double] -> [Double] -> [Double] -> [Double] -> [Double] -> [Double] -> IO TGraphAsymmErrors
newTGraphAsymmErrors = xform6 c_tgraphasymmerrors_newtgraphasymmerrors


newTCutG :: String -> Int -> [Double] -> [Double] -> IO TCutG
newTCutG = xform3 c_tcutg_newtcutg


newTGraphBentErrors :: Int -> [Double] -> [Double] -> [Double] -> [Double] -> [Double] -> [Double] -> [Double] -> [Double] -> [Double] -> [Double] -> IO TGraphBentErrors
newTGraphBentErrors = xform10 c_tgraphbenterrors_newtgraphbenterrors


newTGraphErrors :: Int -> [Double] -> [Double] -> [Double] -> [Double] -> IO TGraphErrors
newTGraphErrors = xform4 c_tgrapherrors_newtgrapherrors


newTGraphPolar :: Int -> [Double] -> [Double] -> [Double] -> [Double] -> IO TGraphPolar
newTGraphPolar = xform4 c_tgraphpolar_newtgraphpolar


newTGraphQQ :: Int -> [Double] -> Int -> [Double] -> IO TGraphQQ
newTGraphQQ = xform3 c_tgraphqq_newtgraphqq


newTEllipse :: Double -> Double -> Double -> Double -> Double -> Double -> Double -> IO TEllipse
newTEllipse = xform6 c_tellipse_newtellipse


newTArc :: Double -> Double -> Double -> Double -> Double -> IO TArc
newTArc = xform4 c_tarc_newtarc


newTCrown :: Double -> Double -> Double -> Double -> Double -> Double -> IO TCrown
newTCrown = xform5 c_tcrown_newtcrown


newTLine :: Double -> Double -> Double -> Double -> IO TLine
newTLine = xform3 c_tline_newtline


newTArrow :: Double -> Double -> Double -> Double -> Double -> String -> IO TArrow
newTArrow = xform5 c_tarrow_newtarrow


newTGaxis :: Double -> Double -> Double -> Double -> Double -> Double -> Int -> String -> Double -> IO TGaxis
newTGaxis = xform8 c_tgaxis_newtgaxis


newTShape :: String -> String -> String -> IO TShape
newTShape = xform2 c_tshape_newtshape


newTBRIK :: String -> String -> String -> Double -> Double -> Double -> IO TBRIK
newTBRIK = xform5 c_tbrik_newtbrik


newTTUBE :: String -> String -> String -> Double -> Double -> Double -> Double -> IO TTUBE
newTTUBE = xform6 c_ttube_newttube


newTPCON :: String -> String -> String -> Double -> Double -> Int -> IO TPCON
newTPCON = xform5 c_tpcon_newtpcon


newTSPHE :: String -> String -> String -> Double -> Double -> Double -> Double -> Double -> Double -> IO TSPHE
newTSPHE = xform8 c_tsphe_newtsphe


newTXTRU :: String -> String -> String -> Int -> Int -> IO TXTRU
newTXTRU = xform4 c_txtru_newtxtru


newTBox :: Double -> Double -> Double -> Double -> IO TBox
newTBox = xform3 c_tbox_newtbox


newTPave :: Double -> Double -> Double -> Double -> Int -> String -> IO TPave
newTPave = xform5 c_tpave_newtpave


newTPaveText :: Double -> Double -> Double -> Double -> String -> IO TPaveText
newTPaveText = xform4 c_tpavetext_newtpavetext


newTDiamond :: Double -> Double -> Double -> Double -> IO TDiamond
newTDiamond = xform3 c_tdiamond_newtdiamond


newTPaveStats :: Double -> Double -> Double -> Double -> String -> IO TPaveStats
newTPaveStats = xform4 c_tpavestats_newtpavestats


newTPavesText :: Double -> Double -> Double -> Double -> Int -> String -> IO TPavesText
newTPavesText = xform5 c_tpavestext_newtpavestext


newTLegend :: Double -> Double -> Double -> Double -> String -> String -> IO TLegend
newTLegend = xform5 c_tlegend_newtlegend


newTPaveLabel :: Double -> Double -> Double -> Double -> String -> String -> IO TPaveLabel
newTPaveLabel = xform5 c_tpavelabel_newtpavelabel


newTWbox :: Double -> Double -> Double -> Double -> Int -> Int -> Int -> IO TWbox
newTWbox = xform6 c_twbox_newtwbox


newTFrame :: Double -> Double -> Double -> Double -> IO TFrame
newTFrame = xform3 c_tframe_newtframe


newTSliderBox :: Double -> Double -> Double -> Double -> Int -> Int -> Int -> IO TSliderBox
newTSliderBox = xform6 c_tsliderbox_newtsliderbox


newTTree :: String -> String -> Int -> IO TTree
newTTree = xform2 c_ttree_newttree


newTChain :: String -> String -> IO TChain
newTChain = xform1 c_tchain_newtchain


newTNtuple :: String -> String -> String -> Int -> IO TNtuple
newTNtuple = xform3 c_tntuple_newtntuple


newTNtupleD :: String -> String -> String -> Int -> IO TNtupleD
newTNtupleD = xform3 c_tntupled_newtntupled


newTPolyLine :: Int -> [Double] -> [Double] -> String -> IO TPolyLine
newTPolyLine = xform3 c_tpolyline_newtpolyline


newTCurlyLine :: Double -> Double -> Double -> Double -> Double -> Double -> IO TCurlyLine
newTCurlyLine = xform5 c_tcurlyline_newtcurlyline


newTCurlyArc :: Double -> Double -> Double -> Double -> Double -> Double -> Double -> IO TCurlyArc
newTCurlyArc = xform6 c_tcurlyarc_newtcurlyarc


newTAxis :: Int -> Double -> Double -> IO TAxis
newTAxis = xform2 c_taxis_newtaxis


newTLatex :: Double -> Double -> String -> IO TLatex
newTLatex = xform2 c_tlatex_newtlatex


newTFile :: String -> String -> String -> Int -> IO TFile
newTFile = xform3 c_tfile_newtfile


newTH1D :: String -> String -> Int -> Double -> Double -> IO TH1D
newTH1D = xform4 c_th1d_newth1d


newTH1F :: String -> String -> Int -> Double -> Double -> IO TH1F
newTH1F = xform4 c_th1f_newth1f


newTH2D :: String -> String -> Int -> Double -> Double -> Int -> Double -> Double -> IO TH2D
newTH2D = xform7 c_th2d_newth2d


newTH2F :: String -> String -> Int -> Double -> Double -> Int -> Double -> Double -> IO TH2F
newTH2F = xform7 c_th2f_newth2f


newTCanvas :: String -> String -> Int -> Int -> IO TCanvas
newTCanvas = xform3 c_tcanvas_newtcanvas


newTApplication :: String -> [Int] -> [String] -> IO TApplication
newTApplication = xform2 c_tapplication_newtapplication


newTRint :: String -> [Int] -> [String] -> IO TRint
newTRint = xform2 c_trint_newtrint


newTRandom :: Int -> IO TRandom
newTRandom = xform0 c_trandom_newtrandom


newTKey :: String -> String -> TClass -> Int -> TDirectory -> IO TKey
newTKey = xform4 c_tkey_newtkey


newTDatime :: Int -> Int -> Int -> Int -> Int -> Int -> IO TDatime
newTDatime = xform5 c_tdatime_newtdatime

tLatexDrawLatex :: TLatex -> Double -> Double -> String -> IO TLatex
tLatexDrawLatex = xform3 c_tlatex_tlatexdrawlatex

tH1GetAsymmetry :: TH1 -> TH1 -> Double -> Double -> IO TH1
tH1GetAsymmetry = xform3 c_th1_th1getasymmetry

tH1GetBufferLength :: TH1 -> IO Int
tH1GetBufferLength = xform0 c_th1_th1getbufferlength

tH1GetBufferSize :: TH1 -> IO Int
tH1GetBufferSize = xform0 c_th1_th1getbuffersize

tH1GetDirectory :: TH1 -> IO TDirectory
tH1GetDirectory = xform0 c_th1_th1getdirectory

tH1GetXaxis :: TH1 -> IO TAxis
tH1GetXaxis = xform0 c_th1_th1getxaxis

tH1GetYaxis :: TH1 -> IO TAxis
tH1GetYaxis = xform0 c_th1_th1getyaxis

tH1GetZaxis :: TH1 -> IO TAxis
tH1GetZaxis = xform0 c_th1_th1getzaxis

tH2ProjectionX :: TH2 -> String -> Int -> Int -> String -> IO TH1D
tH2ProjectionX = xform4 c_th2_th2projectionx

tH2ProjectionY :: TH2 -> String -> Int -> Int -> String -> IO TH1D
tH2ProjectionY = xform4 c_th2_th2projectiony
